% Contains a list of all the HIPAA relations.

:- dynamic
	adequate/1,
	aggregated/1,
	appears/1,
	automatically/1,
	brief/1,
	cadaveric/1,
	clear/1,
	confidential/1,
	contemporaneously/1,
	costBased/1,
	credible/1,
	deceased/1,
	deidentified/1,
	directly/1,
	expressly/2,
	eyeColor/1,
	face2face/1,
	facialHair/1,
	fails/1,
	free/1,
	gender/1,
	goodFaith/1,
	hairColor/1,
	height/1,
	impracticable/1,
	incapacitated/1,
	includesSufficientDetail/1,
	inExerciseOfProfessionalJudgment/1,
	inPerson/1,
	inPlainLanguage/1,
	inProgress/1,
	intentional/1,
	invalid/1,
	isCommunicableDisease/1,
	isAdministrativeTribunal/1,
	isAdult/1,
	isArmedForcesPersonnel/2,
	isAttorney/1,
	isChild/1,
	isCity/1,
	isClery/1,
	isCommunicableDisease/1,
	isCoroner/1,
	isCorrectionalInstitution/1,
	isCounseling/1,
	isCounterIntelligence/1,
	isCounty/1,
	isCourt/1,
	isCourtProceeding/1,
	isCrime/1,
	isCrimeVictim/1,
	isDataUseAgreement/1,
	isDemographicInformation/1,
	isDesignatedRecordSet/1,
	isEmancipatedMinor/1,
	isEntireMedicalRecord/1,
	isFDAProduct/1,
	isFederalAgency/1,
	isFederalAgent/1,
	isFoodProduct/1,
	isForeign/1,
	isForeignAgent/1,
	isForeignArmedForcesPersonnel/2,
	isForeignNationalBeneficiary/1,
	isFugitive/1,
	isFuneralDirector/1,
	isIllness/1,
	isImmediate/1,
	isInjury/1,
	isInmate/1,
	isInstitutionallyRelatedFoundation/1,
	isIntelligence/1,
	isInvestigation/1,
	isIRB/1,
	isGovernmentBenefitProgram/1,
	isGrandJury/1,
	isHealthcareProviderService/1,
	isHealthcareSystem/1,
	isHealthInsurance/1,
	isHealthOversightAgency/1,
	isHealthPlanService/1,
	isHIPAAIndividual/1,
	isLaw/1,
	isLawEnforcement/1,
	isLawEnforcementActivity/1,
	isLawEnforcementInquiry/2,
	isLawEnforcementPurpose/1,
	isLegalPermission/1,
	isLHCP/1,
	isMedicalExaminer/1,
	isMilitaryCommandAuthority/1,
	isMilitaryMission/1,
	isMissingPerson/1,
	isNamedInsured/1,
	isNonGovernmentalOrganization/1,
	isOffice/1,
	isOrganProcurementOrganization/1,
%	isPHI/1, % defined in objects.pl
	isPractical/1,
	isPrecinct/1,
	isPresent/1,
	isPrivacyBoard/1,
	isPrivacyOfficial/1,
	isPrivacyPractice/1,
	isPublicHealthAuthority/1,
	isPublicOfficial/1,
	isQualifiedProtectiveOrder/1,
	isRecurring/1,
	isReliefOrg/1,
	isResearcher/1,
	isRoutine/1,
	isStandard/1,
	isState/1,
	isStreetAddress/1,
	isSubjectToCivilRightsLaws/1,
	isSubjectToGovermentRegulatoryPrograms/1,
	isSuspect/1,
	isTherapy/1,
	isTreatment/1,
	isVerySmall/1,
	isWorkersComp/1,
	isZipCode/1,
	lawful/1,
	likely/1,
	limitedToExtendReasonablyPracticable/1,
	materially/1,
	multiple/1,
	occursOnce/1,
	onGovernmentLetterhead/1,
	onsite/1,
	opportunity/1,
	oral/1,
	paper/1,
	participatesInOrganizedHealthcareArrangement/1,
	performsMultipleCoveredFunctions/1,
	practicable/1,
	prominent/1,
	promptly/1,
	race/1,
	readilyProducable/1,
	relavent/1,
	satisfactory/1,
	serious/1,
	solely/1,
	temporarily/1,
	timely/1,
	toTheExtentPossible/1,
	unavailable/1,
	unintentional/1,
	weight/1,
	workplaceRelated/1,
	written/1.

attribute(adequate).
attribute(aggregated).
attribute(appears).
attribute(arePsychotherapyNotes).
attribute(automatically).
attribute(brief).
attribute(cadaveric).
attribute(clear).
attribute(complete).
attribute(confidential).
attribute(contemporaneously).
attribute(costBased).
attribute(credible).
attribute(deceased).
attribute(deidentified).
attribute(directly).
attribute(expressly).
attribute(eyeColor).
attribute(face2face).
attribute(facialHair).
attribute(fails).
attribute(free).
attribute(gender).
attribute(goodFaith).
attribute(hairColor).
attribute(height).
attribute(impracticable).
attribute(incapacitated).
attribute(includesSufficientDetail).
attribute(inExerciseOfProfessionalJudgment).
attribute(inPerson).
attribute(inPlainLanguage).
attribute(inProgress).
attribute(intentional).
attribute(invalid).
attribute(isAdministrativeTribunal).
attribute(isAdult).
attribute(isArmedForces).
attribute(isArmedForcesPersonnel).
attribute(isAttorney).
attribute(isChild).
attribute(isCity).
attribute(isClery).
attribute(isCommunicableDisease).
attribute(isCoroner).
attribute(isCorrectionalInstitution).
attribute(isCounseling).
attribute(isCounterIntelligence).
attribute(isCounty).
attribute(isCourt).
attribute(isCourtProceeding).
attribute(isCrime).
attribute(isDataUseAgreement).
attribute(isDemographicInformation).
attribute(isDesignatedRecordSet).
attribute(isEmancipatedMinor).
attribute(isEntireMedicalRecord).
attribute(isFDAAgent).
attribute(isFDAProduct).
attribute(isFederalAgency).
attribute(isFederalAgent).
attribute(isFoodProduct).
attribute(isForeign).
attribute(isForeignAgent).
attribute(isForeignArmedForcesPersonnel).
attribute(isForeignNationalBeneficiary).
attribute(isFugitive).
attribute(isFuneralDirector).
attribute(isGovernmentAuthority).
attribute(isGovernmentBenefitProgram).
attribute(isGovernmentProgram).
attribute(isGrandJury).
attribute(isHealthcareProviderService).
attribute(isHealthcareSystem).
attribute(isHealthInsurance).
attribute(isHealthOversightAgency).
attribute(isHealthPlanService).
attribute(isHIPAAIndividual).
attribute(isIllness).
attribute(isImmediate).
attribute(isInjury).
attribute(isInmate).
attribute(isInstitutionallyRelatedFoundation).
attribute(isIntelligence).
attribute(isInvestigation).
attribute(isIRB).
attribute(isLaw).
attribute(isLawEnforcement).
attribute(isLawEnforcementActivity).
attribute(isLawEnforcementInquiry).
attribute(isLawEnforcementPurpose).
attribute(isLegalPermission).
attribute(isLHCP).
attribute(isPerson).
attribute(isPHI).
attribute(isMedicalExaminer).
attribute(isMilitaryCommandAuthority).
attribute(isMilitaryMission).
attribute(isMissingPerson).
attribute(isNamedInsured).
attribute(isNonGovernmentalOrganization).
attribute(isOffice).
attribute(isOrganProcurementOrganization).
attribute(isPractical).
attribute(isPrecinct).
attribute(isPresent).
attribute(isPrivacyBoard).
attribute(isPrivacyOfficial).
attribute(isPrivacyPractice).
attribute(isPublicHealthAuthority).
attribute(isPublicOfficial).
attribute(isQualifiedProtectiveOrder).
attribute(isRecurring).
attribute(isReliefOrg).
attribute(isResearcher).
attribute(isRoutine).
attribute(isSocialService).
attribute(isState).
attribute(isStandard).
attribute(isStreetAddress).
attribute(isSubjectToCivilRightsLaws).
attribute(isSubjectToGovermentRegulatoryPrograms).
attribute(isSuspect).
attribute(isTherapy).
attribute(isTreatment).
attribute(isVerySmall).
attribute(isWorkersComp).
attribute(isZipCode).
attribute(lawful).
attribute(likely).
attribute(limitedToExtendReasonablyPracticable).
attribute(materially).
attribute(multiple).
attribute(nominalValue).
attribute(occursOnce).
attribute(onGovernmentLetterhead).
attribute(onsite).
attribute(opportunity).
attribute(oral).
attribute(paper).
attribute(participatesInOrganizedHealthcareArrangement).
attribute(performsMultipleCoveredFunctions).
attribute(practicable).
attribute(promptly).
attribute(prominent).
attribute(race).
attribute(readilyProducable).
attribute(relavent).
attribute(satisfactory).
attribute(serious).
attribute(solely).
attribute(temporarily).
attribute(timely).
attribute(toTheExtentPossible).
attribute(unavailable).
attribute(unintentional).
attribute(valid).
attribute(weight).
attribute(workplaceRelated).
attribute(written).

% [IGNORE_PRECONDITIONS]
isPerson(X) :-
	isHIPAAIndividual(X).

% [IGNORE_PRECONDITIONS]
isPersonOrOffice(X) :-
	isPerson(X).
% [IGNORE_PRECONDITIONS]
isPersonOrOffice(X) :-
	isOffice(X).

% [IGNORE_PRECONDITIONS]
inWrittenOrElectronicForm(X) :-
	written(X).
% [IGNORE_PRECONDITIONS]
inWrittenOrElectronicForm(X) :-
	electronic(X).

% eof
