% Contains a list of all the HIPAA objects.

:- multifile
        identifies/2.

:- dynamic
	accounting/1,
	accountNumber/1,
	activities/1,
	address/1,
	administrativeRequest/3,
	administrativeTasks/1,
	alternative/1,
	aspects/1,
	basis/1,
	biometricIdentifier/1,
	birth/1,
	bodyFluidAnalysis/1,
	bodyFluidSample/1,
	bodyFluidTyping/1,
	bloodType/1,
	communications/1,
	complianceDate/1,
	conditionOf/1,
	criteria/1,
	custody/1,
	dataUseAgreement/2,
	day/1,
	death/1,
	deidentified/1,
	dentalRecord/1,
	description/1,
	detriment/1,
	deviceIdentifiers/1,
	disability/1,
	disease/1,
	disposition/1,
	dna/1,
	dnaAnalysis/1,
	dob/1,
	duties/1,
	effectiveDate/1,
	emailAddress/1,
	experience/2,
	expirationDate/1,
	face/1,
	faxNumber/1,
	filledPrescription/1,
	fingerPrint/1,
	format/1,
	frequency/1,
	fundraising/1,
	fundraisingMaterials/1,
	generalCondition/1,
	goodOrder/1,
	harm/1,
	health/1,
	healthPlanBeneficiaryNumber/1,
	healthBenefits/1,
	healthcare/2,
	healthcareOperations/1,
	howToHandle/1,
	identificationBadge/1,
	identifies/2,
	information/1,
	injury/1,
	insuranceContract/2,
	ipAddress/1,
	jointNotice/1,
	lastKnownAddress/1,
	legalAction/2,
	legalOptions/1,
	length/1,
	licenseNumber/1,
	licensePlateNumber/1,
	link/1,
	maintenance/1,
	majority/1,
	management/1,
	medicalRecordNumber/1,
	meeting/1,
	month/1,
	mou/2,
	nominalValue/1,
	numberOf/1,
	otherContactMeans/1,
	parole/1,
	payment/1,
	people/1,
	periodicity/1,
	photo/1,
	placeOfBirth/1,
	plan/1,
	population/1,
	postMarket/1,
	premium/1,
	premises/1,
	privacy/1,
	probation/1,
	productDefects/1,
	propensity/2,
	proposal/1,
	publicHealthBenefitsClaim/1,
	reasonsFor/1,
	reasonToSupport/1,
	rebuttal/1,
	rehabilitation/1,
	religiousAffiliation/1,
	restrictionsAndConditions/1,
	rhFactor/1,
	safety/1,
	scar/1,
	serviceDeliverySite/1,
	services/2,
	ssn/1,
	statement/1,
	summary/1,
	supervisedRelease/1,
	tattoo/1,
	telephoneNumber/1,
	time/1,
	timePeriod/1,
	trainingPrograms/1,
	treatment/1,
	url/1,
	vin/1,
	violentCrime/2,
	voicePrint/1,
	waiver/1,
	website/1,
	workforce/1,
	workplace/1,
	xRays/1,
	year/1.

object(accounting).
object(accountNumber).
object(activities).
object(administrativeRequest).
object(administrativeTasks).
object(address).
object(appointmentReminders).
object(alternative).
object(alternativeLocations).
object(alternativeMeans).
object(aspects).
object(basis).
object(biologicalProductDeviations).
object(biometricIdentifier).
object(birth).
object(bloodType).
object(bodyFluidAnalysis).
object(bodyFluidSample).
object(bodyFluidTyping).
object(commonPractice).
object(communication).
object(communications).
object(complianceDate).
object(conditionOf).
object(confidentialityAgreement).
object(consent).
object(criteria).
object(currentDate).
object(custody).
object(dataUseAgreement).
object(day).
object(database).
object(death).
object(dentalRecord).
object(description).
object(detriment).
object(deviceIdentifiers).
object(disability).
object(disease).
object(disposition).
object(dna).
object(dnaAnalysis).
object(dob).
object(drs).
object(duties).
object(effectiveDate).
object(ein).
object(electronicPHI).
object(email).
object(emailAddress).
object(employmentActions).
object(experience).
object(expirationDate).
object(expirationEvents).
object(face).
object(faxNumber).
object(federalRegister).
object(filledPrescription).
object(fingerPrint).
object(format).
object(frequency).
object(fundraising).
object(fundraisingMaterials).
object(generalCondition).
object(gift).
object(goodOrder).
object(harm).
object(health).
object(healthPlanBeneficiaryNumber).
object(healthBenefits).
object(healthcare).
object(healthcareOperations).
object(healthInformation).
object(hipaa).
object(howToHandle).
object(identificationBadge).
object(identifiers).
object(individuallyIdentifiableHealthInfo).
object(information).
object(injury).
object(insuranceContract).
object(internalDocuments).
object(ipAddress).
object(lastKnownAddress).
object(law).
object(legalAction).
object(legalOptions).
object(length).
object(licenseNumber).
object(licensePlateNumber).
object(link).
object(maintenance).
object(majority).
object(management).
object(marketing).
object(mechanism).
object(medicalRecordNumber).
object(medicalSupplies).
object(meeting).
object(minimal).
object(month).
object(notice).
object(numberOf).
object(otherContactMeans).
object(parole).
object(payment).
object(people).
object(periodicity).
object(photo).
object(placeOfBirth).
object(plan).
object(population).
object(postMarket).
object(premium).
object(premises).
object(privacy).
object(probation).
object(productDefects).
object(professionalStandards).
object(propensity).
object(proposal).
object(psychotherapyNotes).
object(publicHealth).
object(publicHealthBenefitsClaim).
object(publicHealthInterventions).
object(publicHealthSurveillance).
object(reasonsFor).
object(reasonToSupport).
object(rebuttal).
object(rehabilitation).
object(reidentificationCode).
object(religiousAffiliation).
object(research).
object(researchProtocol).
object(restrictionsAndConditions).
object(rhFactor).
object(safety).
object(scar).
object(serviceDeliverySite).
object(services).
object(ssn).
object(standard).
object(statement).
object(statisticalMethods).
object(summary).
object(summaryHealthInformation).
object(supervisedRelease).
object(tattoo).
object(telephoneNumber).
object(time).
object(timePeriod).
object(trainingPrograms).
object(transaction).
object(treatment).
object(unitedStates).
object(url).
object(vin).
object(violentCrime).
object(voicePrint).
object(waiver).
object(website).
object(workforce).
object(workplace).
object(writtenContract).
object(xRays).
object(year).

% 164.502(d)(2)
% [IGNORE_PRECONDITIONS]
isPHI(X) :-
	deidentified(X),
	fail.

% Relations involving time
isTimeUnit(year(_)).
isTimeUnit(month(_)).
isTimeUnit(day(_)).

% Setting up the about and identifies relationships
identifies(phi(X),X).
identifies(psychotherapyNotes(X),X).

% Grouping TPO
valid_HIPAA_TPO(treatment).
valid_HIPAA_TPO(payment).
valid_HIPAA_TPO(healthcareOperations).
valid_HIPAA_TPO(treatment(_)).
valid_HIPAA_TPO(payment(_)).
valid_HIPAA_TPO(healthcareOperations(_)).

% eof





