:- multifile object/1.

:- consult('SecurityRuleObjects.pl').

:- dynamic
	about/2,
	arePsychotherapyNotes/1,
	authorization/3,
	changes/1,
	copy/1,
	cost/1,
	date/1,
	harmfulEffects/1,
	how/1,
	identity/1,
	isPHI/1,
	location/1,
	name/1,
	pattern/1,
	planDocuments/1,
	policies/1,
	procedures/1,
	psychotherapyNotes/1,
	risk/1,
	sanctions/1.

object(authorization).
object(changes).
object(copy).
object(cost).
object(date).
object(electronicMedia).
object(harmfulEffects).
object(how).
object(identity).
object(location).
object(mou).
object(name).
object(pattern).
object(planDocuments).
object(phi).
object(policies).
object(procedures).
object(risk).
object(sanctions).

% Some relations involving objects
isPHI(phi(_)).
isPHI(X) :-
	arePsychotherapyNotes(X).
isPHI(name(_)).
arePsychotherapyNotes(psychotherapyNotes(X)) :-
	psychotherapyNotes(X).

about(phi(X),X).
about(psychotherapyNotes(X),X).

isProceduresOrPolicies(CE,procedures(CE)).
isProceduresOrPolicies(CE,policies(CE)).

% eof
