% Models section 164.316 of the HIPAA Security Rule

s164_316a(CE,PoliciesAndProcedures) :-
	isCoveredEntity(CE),
	isProceduresOrPolicies(CE,PoliciesAndProcedures),
	add_to_wm(s164_316a(CE,PoliciesAndProcedures)).
privilege(CE,
	  atAnyTime(changes(CE,PoliciesAndProcedures)),
	  '164.316(a)') :-
	wm(s164_316a(CE,PoliciesAndProcedures)).
% TODO what is the implied right?

s164_316b1i(CE,PoliciesAndProcedures) :-
	isCoveredEntity(CE),
	isProceduresOrPolicies(CE,PoliciesAndProcedures),
	inCompliance(CE,hipaaSecurityRule,PoliciesAndProcedures),
	add_to_wm(s164_316b1i(CE,PoliciesAndProcedures)).
obligation(CE,
	   maintains(CE,written(PoliciesAndProcedures)),
	   '164.316(b)(1)(i)') :-
	wm(s164_316b1i(CE,PoliciesAndProcedures)).
% TODO what is the implied right?
privilege(CE,
	  maintains(CE,electronic(written(PoliciesAndProcedures))),
	   '164.316(b)(1)(i)') :-
	wm(s164_316b1i(CE,PoliciesAndProcedures)).
% TODO what is the implied noright?

s164_316b1ii(CE,DocumentedItem) :-
	isCoveredEntity(CE),
	obligation(CE,documents(CE,DocumentedItem),_),
	add_to_wm(s164_316b1ii(CE,DocumentedItem)).
obligation(CE,
	   maintains(CE,written(record(DocumentedItem))),
	   '164.316(b)(1)(ii)') :-
	wm(s164_316b1ii(CE,DocumentedItem)).
% TODO what is the implied right?
privilege(CE,
	  maintains(CE,electronic(written(record(DocumentedItem)))),
	   '164.316(b)(1)(ii)') :-
	wm(s164_316b1ii(CE,DocumentedItem)).
% TODO what is the implied noright?

s164_316b2i_createsLater(CE,DocumentedItem) :-
	isCoveredEntity(CE),
	after(date(creates(CE,DocumentedItem)),
	      date(last(effective(DocumentedItem,_)))),
	obligation(CE,documents(CE,DocumentedItem),_),
	add_to_wm(s164_316b2i_createsLater(CE,DocumentedItem)).
obligation(CE,
	   from(retains(documents(CE,DocumentedItem),year(6)),
		date(creates(CE,DocumentedItem))),
	   '164.316(b)(2)(i)') :-
	wm(s164_316b2i_createsLater(CE,DocumentedItem)).
% TODO what is the implied right?
s164_316b2i_lastEffectiveLater(CE,DocumentedItem) :-
	isCoveredEntity(CE),
	after(date(last(effective(DocumentedItem,_))),
	      date(creates(CE,DocumentedItem))),
	obligation(CE,documents(CE,DocumentedItem),_),
	add_to_wm(s164_316b2i_lastEffectiveLater(CE,DocumentedItem)).
obligation(CE,
	   from(retains(documents(CE,DocumentedItem),year(6)),
		date(last(effective(DocumentedItem,_)))),
	   '164.316(b)(2)(i)') :-
	wm(s164_316b2i_lastEffectiveLater(CE,DocumentedItem)).
% TODO what is the implied right?

s164_316b2ii(CE,Person,DocumentedItem) :-
	isCoveredEntity(CE),
	responsible(Person,
		    implements(procedures(CE))),
	pertains(documents(CE,DocumentedItem),
		 procedures(CE)),
	obligation(CE,documents(CE,DocumentedItem,_)),
	add_to_wm(s164_316b2ii(CE,Person,DocumentedItem)).
obligation(CE,
	   makes(CE,
		 available(documents(CE,DocumentedItem),
			   Person)),
	   '164.316(b)(2)(ii)') :-
	wm(s164_316b2ii(CE,Person,DocumentedItem)).
implied(right(Person,
	      receives(Person,CE,documents(CE,DocumentedItem)),
	      '164.316(b)(2)(ii)')) :-
	wm(s164_316b2ii(CE,Person,DocumentedItem)).

s164_316b2iii(CE,Changes,DocumentedItem) :-
	isCoveredEntity(CE),
	obligation(CE,documents(CE,DocumentedItem,_),_),
	is_s164_316b2iii_changes(CE,Changes),
	affects(changes(Changes),
		security(PHI)),
	isPHI(PHI),
	electronic(PHI),
	add_to_wm(s164_316b2iii(CE,Changes,DocumentedItem)).
is_s164_316b2iii_changes(CE,environment(CE)).
is_s164_316b2iii_changes(CE,operations(CE)).
obligation(CE,
	   inResponseTo(periodic(reviews(CE,
					 documents(CE,DocumentedItem))),
			changes(Changes)),
	   '164.316(b)(2)(iii)') :-
	wm(s164_316b2iii(CE,Changes,DocumentedItem)).
% TODO what is the implied right?
obligation(CE,
	   asNeeded(inResponseTo(periodic(updates(CE,documents(CE,DocumentedItem))),
				 changes(Changes))),
	   '164.316(b)(2)(iii)') :-
	wm(s164_316b2iii(CE,Changes,DocumentedItem)).
% TODO what is the implied right?

% eof
