:- multifile relation/1.

:- multifile
	for/2,
	inCompliance/2,
	inNonCompliance/2,
        isCoveredEntity/1,
	required_by_law/3.
:- dynamic inCompliance/3,
	required_by_law/3.


:- dynamic
	affects/2,
	after/2,
	anticipates/2,
	applies/2,
	applies/3,
	areBusinessAssociates/2,
	authorizes/3,
	available/2,
	becomesAwareOf/2,
	changes/2,
	controls/2,
	complies/2,
	conducts/2,
	contains/2,
	creates/2,
	deems/2,
	destroys/2,
	detects/2,
	determines/2,
	develops/2,
	discloses/3,
	documents/2,
	effective/2,
	end/1,
	ensures/2,
	evaluates/2,
	evaluates/3,
	for/2,
	grants/2,
	identifies/2,
	implements/2,
	in/2,
	inCompliance/2,
	isComponentOf/2,
	isMemberOfWorkforce/2,
	isNecessaryFor/2,
	isPlanSponsor/2,
	isResponsible/2,
	knows/2,
	maintains/2,
	meets/2,
	mitigates/2,
	modifies/2,
	obtains/2,
	obtains/3,
	prevents/2,
	receives/3,
	removes/2,
	reports/3,
	responsible/2,
	reviews/2,
	revises/2,	
	safeguards/2,
	seeks/2,
	smallerThan/2,
	sufficient/2,
	suspects/2,
	terminates/2,
	through/2,
	to/2,
	tracks/2,
	uses/2,
	violates/2,
	while/2.

:- consult('PrivacyRuleRelations.pl').

relation(about).
relation(affects).
relation(after).
relation(anticipates).
relation(applies).
relation(areBusinessAssociates).
relation(authorizes).
relation(available).
relation(becomesAwareOf).
relation(changes).
relation(complies).
relation(conducts).
relation(contains).
relation(controls).
relation(creates).
relation(deems).
relation(destroys).
relation(detects).
relation(determines).
relation(develops).
relation(discloses).
relation(documents).
relation(effective).
relation(end).
relation(ensures).
relation(evaluates).
relation(for).
relation(grants).
relation(identifies).
relation(implements).
relation(implied).
relation(in).
relation(inCompliance).
relation(isComponentOf).
relation(isMemberOfWorkforce).
relation(isNecessaryFor).
relation(isPlanSponsor).
relation(isResponsible).
relation(knows).
relation(maintains).
relation(meets).
relation(mitigates).
relation(modifies).
relation(obtains).
relation(prevents).
relation(receives).
relation(removes).
relation(reports).
relation(required_by_law).
relation(responsible).
relation(reviews).
relation(revises).
relation(safeguards).
relation(seeks).
relation(smallerThan).
relation(sufficient).
relation(suspects).
relation(terminates).
relation(through).
relation(to).
relation(tracks).
relation(uses).
relation(violates).
relation(while).


% Grouping the uses and discloses cases
% isUsageOrDisclOsure(CoveredEntity,ThirdParty,PHI,UsageorDiclosure)
isUsageOrDisclosure(X,_,PHI,uses(X,PHI)).
isUsageOrDisclosure(X,Y,PHI,discloses(X,Y,PHI)).

% [IGNORE_PRECONDITIONS]
isGHPorHIIorHMO(X) :-
	isGroupHealthPlan(X).
% [IGNORE_PRECONDITIONS]
isGHPorHIIorHMO(X) :-
	isHealthInsuranceIssuer(X).
% [IGNORE_PRECONDITIONS]
isGHPorHIIorHMO(X) :-
	isHMO(X).

% eof
