% Models section 164.500 of the HIPAA Privacy Rule

s164_500b1(HCC,CE,CreatesOrReceives,Section,PHI) :-
	isHealthcareClearingHouse(HCC),
	createsOrReceives(HCC,CE,PHI,CreatesOrReceives),%
	CreatesOrReceives,%
	isCoveredEntity(CE),
	areBusinessAssociates(CE,HCC),
	isPHI(PHI),
	is164_500b1_section(Section),
	add_to_wm(s164_500b1(HCC,CE,CreatesOrReceives,Section,PHI)).
is164_500b1_section('164.500').
is164_500b1_section('164.501').
is164_500b1_section('164.502').
is164_500b1_section('164.504').
is164_500b1_section('164.512').
is164_500b1_section('164.532').
is164_500b1_section('164.534').
obligation(HCC,
	   complyWith(HCC,Section),
	   '164.500(b)(1)(i)') :-
	wm(s164_500b1(HCC,CE,CreatesOrReceives,Section,PHI)).
% TODO what is the implied right?

s164_500b1iii(HCC,CE,UsageOrDisclosure,Purpose,PHI) :-
	isHealthcareClearingHouse(HCC),
	areBusinessAssociates(CE,HCC),
	isCoveredEntity(CE),
	isUsageOrDisclosure(HCC,_,PHI,UsageOrDisclosure),
	isPHI(PHI),
	not(permits(writtenContract(CE,HCC),
		    for(UsageOrDisclosure,
			Purpose))),
	add_to_wm(s164_500b1iii(HCC,CE,UsageOrDisclosure,Purpose,PHI)).
obligation(HCC,
	   not(for(UsageOrDisclosure,
		   Purpose)),
	   '164.500(b)(1)(iii)') :-
	wm(s164_500b1iii(HCC,CE,UsageOrDisclosure,Purpose,PHI)).
implied(right(Individual,
	      not(for(UsageOrDisclosure,
		      Purpose)),
	      '164.500(b)(1)(iii)')) :-
	about(PHI,Individual),
	wm(s164_500b1iii(HCC,CE,UsageOrDisclosure,Purpose,PHI)).

s164_500b1v(HCC,CE,UsageOrDisclosure,Purpose,PHI) :-
	isHealthcareClearingHouse(HCC),
	areBusinessAssociates(CE,HCC),
	isCoveredEntity(CE),
	isUsageOrDisclosure(HCC,_,PHI,UsageOrDisclosure),
	isPHI(PHI),
	not(permits(writtenContract(CE,HCC),
		    for(UsageOrDisclosure,
			Purpose))),
	add_to_wm(s164_500b1v(HCC,CE,UsageOrDisclosure,Purpose,PHI)).
obligation(HCC,
	   not(for(UsageOrDisclosure,
		   Purpose)),
	   '164.500(b)(1)(v)') :-
	wm(s164_500b1v(HCC,CE,UsageOrDisclosure,Purpose,PHI)).
implied(right(Individual,
	      not(for(UsageOrDisclosure,
		      Purpose)),
	      '164.500(b)(1)(v)')) :-
	about(PHI,Individual),
	wm(s164_500b1v(HCC,CE,UsageOrDisclosure,Purpose,PHI)).

s164_500b2(HCCH,CreatesOrReceives,PHI) :-
	isHealthcareClearingHouse(HCCH),
	createsOrReceives(HCCH,_,PHI,CreatesOrReceives),
	CreatesOrReceives,
	isPHI(PHI),
	not(areBusinessAssociates(_,HCCH)),
	add_to_wm(s164_500b2(HCCH,CreatesOrReceives,PHI)).
obligation(HCCH,
	   complies(HCCH,hipaa),
	   '164.500(b)(2)') :-
	wm(s164_500b2(HCCH,CreatesOrReceives,PHI)).
% TODO what is the implied right?

s164_500c(FederalAgency,ForeignNationalBeneficiaries) :-
	isDoDorFederalAgency(FederalAgency),
	provides(FederalAgency,
		 ForeignNationalBeneficiaries,
		 healthcare(FederalAgency,ForeignNationalBeneficiaries)),
	isForeignNationalBeneficiary(ForeignNationalBeneficiaries),
	add_to_wm(s164_500c(FederalAgency,ForeignNationalBeneficiaries)).
isDoDorFederalAgency(departmentOfDefense).
privilege(FederalAgency,
	  not(complies(FederalAgency,hipaa)),
	  '164.500(c)') :-
	wm(s164_500c(FederalAgency,ForeignNationalBeneficiaries)).
implied(noRight(ForeignNationalBeneficiaries,
		right(ForeignNationalBeneficiaries,X,Y),
		'164.500(c)')) :-
	wm(s164_500c(FederalAgency,ForeignNationalBeneficiaries)).

% eof




