% Models section 164.514 of the HIPAA Privacy Rule

not_isPHI(PHI) :-
	about(PHI,Individual),
	not(reasonable(believes(_,
			        identifies(PHI,
					   Individual)))).

s164_514b1(CE,Statatician,Recipient,Individual,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	isPHI(PHI),
	knows(Statatician,
	      for(statisticalMethods,
		  deidentifies(statisticalMethods,
			       PHI))),
	determines(Statisticalmethods,
		   isVerySmall(risk(for(uses(Recipient,
					     PHI),
					identifies(Recipient,
						   Individual))))),
	anticipates(CE,
		    receives(Recipient,
			     CE,
			     PHI)),
	documents(Statisticalmethods,
		  statisticalmethods),
	add_to_wm(s164_512b1(CE,Statatician,Recipient,Individual,PHI)).
s164_514b1(CE,Statatician,Recipient,Individual,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	knows(Statatician,
	      statisticalMethods),
	determines(Statisticalmethods,
		   isVerySmall(risk(for(uses(Recipient,
					     combined(PHI,
						      Info)),
					identifies(Recipient,
						   Individual))))),
	reasonable(available(Recipient,
			     Info)),
	anticipates(CE,
		    receives(Recipient,
			     CE,
			     PHI)),
	documents(Statisticalmethods,
		  statisticalmethods),
	add_to_wm(s164_514b1(CE,Statatician,Recipient,Individual,PHI)).
s164_514b2(CE,Individual,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	removes(CE,
		from(Identifiers,
		     PHI)),
	is_s164_514b2_identifier(Individual,Identifiers),
	not(knows(CE,
		  identifies(PHI,
			     Individual))),
	not(knows(CE,
		  identifies(combined(PHI,
				      _),
			     Individual))),
	add_to_wm(s164_514b2(CE,Individual,PHI)).
privilege(CE,
	  determines(CE,
		     not(isPHI(PHI))),
	  '164.514(b)') :-
	wm(s164_514b1(CE,Statatician,Recipient,Individual,PHI)) ;
	wm(s164_514b2(CE,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(determines(CE,
				     not(isPHI(PHI)))),
		      _),
		'164.514(b)')) :-
	wm(s164_514b1(CE,Statatician,Recipient,Individual,PHI)) ;
	wm(s164_514b2(CE,Individual,PHI)).
obligation(CE,
	   not(determines(CE,not(isPHI(PHI)))),
	   '164.514(b)') :-
	not(wm(s164_514b1(CE,Statatician,Recipient,Individual,PHI))),
	not(wm(s164_514b2(CE,Individual,PHI))).
implied(right(Individual,
	      not(determines(CE,not(isPHI(PHI)))),
	      '164.514(b)')) :-
	not(wm(s164_514b1(CE,Statatician,Recipient,Individual,PHI))),
	not(wm(s164_514b2(CE,Individual,PHI))).

s164_514b2_identifiers(Individual,name(Individual)).
s164_514b2_identifiers(Individual,Region) :-
	in(Individual,
	   Region),
	smallerThan(Region,
		    State),
	isState(State),
	not(isZipCode(Region)).
s164_514b2_identifiers(_,ZipCode) :-
	isZipCode(ZipCode),
	s164_514b2B1_zipCode(ZipCode).
s164_514b2B1_zipCode(ZipCode) :-
	isZipCode(ZipCode),
	moreThan(population(combined(ZipList)),
		 20000),
	haveSameStartingDigits(ZipList,3),
	member(ZipCode,ZipList).
s164_514b2B1_zipCode(ZipCode) :-
	isZipCode(ZipCode),
	lessThan(population(combined(ZipList)),
		    20000),
	haveSameStartingDigits(ZipList,3),
	member(ZipCode,ZipList),
	haveSameStartingDigits([ZipCode,000],3).
s164_514b2_identifiers(Individual,month(birth(Individual))).
s164_514b2_identifiers(Individual,day(birth(Individual))).
s164_514b2_identifiers(Individual,month(admits(CE,Individual))) :-
	admits(CE,Individual),
	isCoveredEntity(CE).
s164_514b2_identifiers(Individual,day(admits(CE,Individual))) :-
	admits(CE,Individual),
	isCoveredEntity(CE).
s164_514b2_identifiers(Individual,month(discharges(CE,Individual))) :-
	discharges(CE,Individual),
	isCoveredEntity(CE).
s164_514b2_identifiers(Individual,day(discharges(CE,Individual))) :-
	discharges(CE,Individual),
	isCoveredEntity(CE).
s164_514b2_identifiers(Individual,month(death(Individual))).
s164_514b2_identifiers(Individual,day(death(Individual))).

s164_514b2_identifiers(Individual,year(birth(Individual))) :-
	moreThan(year(birth(Individual)),89),
	not(into(aggregated(year(birth(Individual))),
	     singleCategoryAge90orOlder)).
s164_514b2_identifiers(Individual,year(admits(CE,Individual))) :-
	moreThan(year(birth(Individual)),89),
	not(into(aggregated(year(admits(CE,Individual))),
	     singleCategoryAge90orOlder)),
        admits(CE,Individual),
	isCoveredEntity(CE).
s164_514b2_identifiers(Individual,year(discharges(CE,Individual))) :-
	discharges(CE,Individual),
	moreThan(year(birth(Individual)),89),
	not(into(aggregated(year(discharges(CE,Individual))),
	     singleCategoryAge90orOlder)),
	isCoveredEntity(CE).
s164_514b2_identifiers(Individual,year(death(Individual))) :-
	moreThan(year(birth(Individual)),89),
	not(into(aggregated(year(death(Individual))),
	     singleCategoryAge90orOlder)).

s164_514b2_identifiers(Individual,telephoneNumber(Individual)).
s164_514b2_identifiers(Individual,faxNumber(Individual)).
s164_514b2_identifiers(Individual,emailAddress(Individual)).
s164_514b2_identifiers(Individual,ssn(Individual)).
s164_514b2_identifiers(Individual,medicalRecordNumber(Individual)).
s164_514b2_identifiers(Individual,healthPlanBeneficiaryNumber(Individual)).
s164_514b2_identifiers(Individual,accountNumber(Individual)).
s164_514b2_identifiers(Individual,licenseNumber(Individual)).
s164_514b2_identifiers(Individual,licensePlateNumber(Individual)).
s164_514b2_identifiers(Individual,vin(Individual)).
s164_514b2_identifiers(Individual,deviceIdentifiers(Individual)).
s164_514b2_identifiers(Individual,url(Individual)).
s164_514b2_identifiers(Individual,ipAddress(Individual)).
s164_514b2_identifiers(Individual,biometricIdentifier(Individual)).
s164_514b2_identifiers(Individual,fingerPrint(Individual)).
s164_514b2_identifiers(Individual,voicePrint(Individual)).
s164_514b2_identifiers(Individual,photo(face(Individual))).
s164_514b2_identifiers(Individual,Number) :-
	number(Number),
	identifies(Number,
		   Individual).

s164_514c(CE,Attacker,Individual,InfoAboutIndividual,PHI) :-
	isCoveredEntity(CE),
	deidentified(PHI),
	about(PHI,Individual),
	not(derives(CE,
		    reidentificationCode(PHI),
		    InfoAboutIndividual)),
	about(InfoAboutIndividual,Individual),
	not(isRelatedTo(reidentificationCode(PHI),
			InfoAboutIndividual)),
	not(able(Attacker,
		 for(translates(Attacker,
				PHI,
				_),
		     identifies(Attacker,
				PHI)))),
	not(uses(CE,
		 reidentificationCode(PHI))),
	not(discloses(CE,
		       _,
		       reidentificationCode(PHI))),
	add_to_wm(s164_514c(CE,Attacker,Individual,InfoAboutIndividual,PHI)).
privilege(CE,
	  for(assigns(CE,
		      reidentificationCode(PHI),
		      PHI),
	      reidentifies(CE,
			   Individual)),
	  '164.514(c)') :-
	wm(s164_514c(CE,Attacker,Individual,InfoAboutIndividual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(for(assigns(CE,
				      reidentificationCode(PHI),
				      PHI),
			      reidentifies(CE,
					   Individual))),
		      _),
		'164.514(c)')) :-
	wm(s164_514c(CE,Attacker,Individual,InfoAboutIndividual,PHI)).
obligation(CE,
	   not(UsageOrDisclosure),
	   '164.514(C)') :-
	isUsageOrDisclosure(CE,_,reidentificationCode(PHI),UsageOrDisclosure),
	wm(s164_514c(CE,_,Individual,InfoAboutIndividual,reidentificationCode(PHI))).
implied(right(Individual,
	      not(UsageOrDisclosure),
	      '164.514(C)')) :-
	isUsageOrDisclosure(CE,_,reidentificationCode(PHI),UsageOrDisclosure),
	wm(s164_514c(CE,_,Individual,InfoAboutIndividual,reidentificationCode(PHI))).

s164_514d2iA(CE,Person,PHI) :-
	isCoveredEntity(CE),
	isMemberOfWorkforce(Person,CE),
	for(requires(Person,PHI),
	    duties(Person)),
	isPHI(PHI),
	add_to_wm(s164_514d2iA(CE,Person,PHI)).
obligation(CE,
	   identifies(CE,Person),
	   '164.514(d)(2)(i)(A)') :-
	wm(s164_514d2iA(CE,Person,PHI)).
% TODO add the implied right	      

s164_514d2iB(CE,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	isMemberOfWorkforce(Person,CE),
	for(requires(Person,PHI),
	    duties(Person)),
        add_to_wm(s164_514d2iB(CE,PHI)).
obligation(CE,
	   identifies(CE,
		      categories(PHI)),
	   '164.514(d)(2)(i)(B)') :-
	wm(s164_514d2iB(CE,PHI)).
% TODO add the implied right

s164_514d2ii(CE,Person,PHI) :-
	maintains(CE,PHI),
        isPHI(PHI),
	isMemberOfWorkforce(Person,CE),
	for(requires(Person,
		     PHI),
	    duties(Person)),
	obligation(CE,
		   identifies(CE,
			      categories(PHI)),
		   '164.514(d)(2)(i)(B)'),
	add_to_wm(s164_514d2ii(CE,Person,PHI)).
obligation(CE,
	   reasonable(makesEfforts(CE,limits(CE,
					     to(access(Person,
						       PHI),
						categories(PHI))))),
	   '164.514(d)(2)(ii)') :-
	wm(s164_514d2ii(CE,Person,PHI)).
implied(right(Individual,
	      limits(CE,
		     to(access(Person,
			       PHI),
			categories(PHI))),
	      '164.514(d)(2)(ii)')) :-
	about(PHI,Individual),
	wm(s164_514d2ii(CE,Person,PHI)).
	
s164_514d3i(CE,ThirdParty,Purpose,ProceduresOrPolicies,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	isProceduresOrPolicies(CE,ProceduresOrPolicies),
	for(discloses(CE,
		      ThirdParty,
		      PHI),
	    Purpose),
	isRoutine(for(discloses(CE,
				ThirdParty,
				PHI),
		      Purpose)),
	isRecurring(for(discloses(CE,
				  ThirdParty,
				  PHI),
		        Purpose)),
	limits(ProceduresOrPolicies,
	       to(discloses(CE,
			    ThirdParty,
			    PHI),
		  reasonable(for(requires(ThirdParty,
					  PHI),
				 Purpose)))),
	add_to_wm(s164_514d3i(CE,ThirdParty,Purpose,ProceduresOrPolicies,PHI)).
obligation(CE,
     implements(CE,
	        ProceduresOrPolicies),
     '164.514(d)(3)(i)') :-
	wm(s164_514d3i(CE,ThirdParty,Purpose,ProceduresOrPolicies,PHI)).
% TODO add implied right

s164_514d3iiA(CE,ThirdParty,Purpose,PHI) :-
	isCoveredEntity(CE),
	for(discloses(CE,
		      ThirdParty,
		      PHI),
	    Purpose),
	isPHI(PHI),
	add_to_wm(s164_514d3iiA(CE,ThirdParty,Purpose,PHI)).
obligation(CE,
	   develops(CE,
		    criteria(to(limits(CE,
				       discloses(CE,
						 ThirdParty,
						 PHI)),
				for(requires(ThirdParty,
					     PHI),
				    Purpose)))),
	   '164.514(d)(3)(ii)(A)') :-
	wm(s164_514d3iiA(CE,ThirdParty,Purpose,PHI)).
implied(right(Individual,
	      to(limits(CE,
			discloses(CE,ThirdParty,PHI)),
		 for(requires(ThirdParty,
			      PHI),
		     Purpose)),
	      '164.514(d)(3)(ii)(A)')) :-
	about(PHI,Individual),
	wm(s164_514d3iiA(CE,ThirdParty,Purpose,PHI)).

s164_514d3iiB(CE,ThirdParty,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	requests(ThirdParty,
		 CE,
		 discloses(CE,
			   ThirdParty,
			   PHI)),
	add_to_wm(s164_514d3iiB(CE,ThirdParty,PHI)).
obligation(CE,
	   individually(CE,
			reviews(requests(ThirdParty,
					 CE,
					 discloses(CE,
						   ThirdParty,
						   PHI)))),
	   '164.514(d)(3)(ii)(B)') :-
	wm(s164_514d3iiB(CE,ThirdParty,PHI)).
implied(right(Individual,
	      individually(CE,
			   reviews(requests(ThirdParty,
					    CE,
					    discloses(CE,ThirdParty,PHI)))),
	      '164.514(d)(3)(ii)(B)')) :-
	about(PHI,Individual),
	wm(s164_514d3iiB(CE,ThirdParty,PHI)).

s164_514d3iiiA(CE,ThirdParty,Purpose,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	for(discloses(CE,
		      ThirdParty,
		      PHI),
	    Purpose),
	isPublicOfficial(ThirdParty),
	privilege(CE,
	    discloses(CE,
		      ThirdParty,
		      PHI),
	    Source),
	isSubsectionOf(Source, '164.512'),
	represents(ThirdParty,
		   isMinimumNecessaryFor(PHI,
					 Purpose)),
	add_to_wm(s164_514d3iiiA(CE,ThirdParty,Purpose,PHI)).
s164_514d3iiiB(CE,ThirdParty,_,PHI) :-
	isCoveredEntity(CE),
	isCoveredEntity(ThirdParty),
	isPHI(PHI),
	add_to_wm(s164_514d3iiiB(CE,ThirdParty,_,PHI)).
s164_514d3iiiC(CE,
	       ThirdParty,
	       provides(ThirdParty,
			CE,
			services(ThirdParty,CE)),
	       PHI) :-
	isCoveredEntity(CE),
	(   isMemberOfWorkforce(ThirdParty,CE)
	    ; 
	    areBusinessAssociates(CE,ThirdParty)
	),
	isPHI(PHI),
	represents(ThirdParty,
		   isMinimumNecessaryFor(PHI,
					 provides(ThirdParty,
						  CE,
						  services(ThirdParty,CE)))),
	add_to_wm(s164_514d3iiiC(CE,ThirdParty,provides(ThirdParty,CE,services(ThirdParty,CE)),PHI)).
s164_514d3iiiD(CE,ThirdParty,research,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	provides(ThirdParty,
		 CE,
		 documents(ThirdParty,
			   _)),
	for(requests(ThirdParty,
		     discloses(CE,
			       ThirdParty,
			       PHI)),
	    research),
	add_to_wm(s164_514d3iiiD(CE,ThirdParty,research,PHI)).
	
privilege(CE,
	  for(relies(CE,
		     requests(ThirdParty,
			      discloses(CE,
					ThirdParty,
					PHI))),
	      isMinimumNecessaryFor(PHI,
				    Purpose)),
	  '164.514(d)(3)(iii)') :-
	reasonable(relies(CE,
			  requests(ThirdParty,
				   discloses(CE,
					     ThirdParty,
					     PHI)))),
	wm(s164_514d3iiiA(CE,ThirdParty,Purpose,PHI)) ;
	wm(s164_514d3iiiB(CE,ThirdParty,Purpose,PHI)) ;
	wm(s164_514d3iiiC(CE,ThirdParty,Purpose,PHI)),
	wm(s164_514d3iiiD(CE,ThirdParty,Purpose,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(for(relies(CE,
				     requests(ThirdParty,
					      discloses(CE,ThirdParty,PHI))),
			      isMinimumNecessaryFor(PHI,
						    Purpose))),
		      _),
		'164.514(d)(3)(iii)')) :-
	reasonable(relies(CE,
			  requests(ThirdParty,
				   discloses(CE,
					     ThirdParty,
					     PHI)))),
	wm(s164_514d3iiiA(CE,ThirdParty,Purpose,PHI)) ;
	wm(s164_514d3iiiB(CE,ThirdParty,Purpose,PHI)) ;
	wm(s164_514d3iiiC(CE,ThirdParty,Purpose,PHI)),
	wm(s164_514d3iiiD(CE,ThirdParty,Purpose,PHI)).

s164_514d4i(CE,OtherCE,Purpose,PHI) :-
	for(requests(CE,
		     OtherCE,
		     PHI),
	    Purpose),
	maintains(OtherCE,PHI),
	isCoveredEntity(OtherCE),
	isPHI(PHI),
	isCoveredEntity(CE),
	add_to_wm(s164_514d4i(CE,OtherCE,PHI)).
obligation(CE,
	   to(limits(CE,
		     for(requests(CE,
				  OtherCE,
				  PHI),
			 Purpose)),
	      isMinimumNecessaryFor(PHI,Purpose)),
	   '164.514(d)(4)(i)') :-
	wm(s164_514d4i(CE,OtherCE,Purpose,PHI)).
implied(right(Individual,
	      to(limits(CE,
			for(requests(CE,OtherCE,PHI),
			    Purpose)),
		 isMinimumNecessaryFor(PHI,Purpose)),
	      '164.514(d)(4)(i)')) :-
	about(PHI,Individual),
	wm(s164_514d4i(CE,OtherCE,Purpose,PHI)).

s164_514d4ii(CE,OtherCE,Purpose,ProceduresOrPolicies,PHI) :-
	for(requests(CE,
		     OtherCE,
		     PHI),
	    Purpose),
	maintains(OtherCE,PHI),
	isCoveredEntity(CE),
	isPHI(PHI),
	isProceduresOrPolicies(CE,ProceduresOrPolicies),
	isRoutine(for(requests(CE,
			       OtherCE,
			       PHI),
		      Purpose)),
	isRecurring(for(requests(CE,
				 OtherCE,
				 PHI),
		        Purpose)),
	limits(ProceduresOrPolicies,
	       to(requests(CE,
			   OtherCE,
			   PHI),
		  reasonable(for(requires(CE,
					  PHI),
				 Purpose)))),
	add_to_wm(s164_514d4ii(CE,OtherCE,Purpose,ProceduresOrPolicies,PHI)).
obligation(CE,
	   implements(CE,
		      ProceduresOrPolicies),
	   '164.514(d)(4)(ii)') :-
	wm(s164_514d4ii(CE,OtherCE,Purpose,ProceduresOrPolicies,PHI)).
% TODO what is the implied right?

s164_514d4iiiA(CE,OtherCE,Purpose,PHI) :-
	for(requests(CE,
		     OtherCE,
		     PHI),
	    Purpose),
	maintains(OtherCE,PHI),
	isCoveredEntity(OtherCE),
	isCoveredEntity(CE),
	isPHI(PHI),
	not(isRoutine(for(requests(CE,
				   OtherCE,
				   PHI),
			  Purpose))),
	not(isRecurring(for(requests(CE,
				     OtherCE,
				     PHI),
			    Purpose))),
	add_to_wm(s164_514d4iiiA(CE,OtherCE,Purpose,PHI)).
obligation(CE,
	   develops(CE,
		    criteria(to(limits(CE,
				       requests(CE,
						OtherCE,
						PHI)),
				for(requires(CE,
					     PHI),
				    Purpose)))),
	   '164.514(d)(4)(iii)(A)') :-
	wm(s164_514d4iiiA(CE,OtherCE,Purpose,PHI)).
implied(right(Individual,
	      to(limits(CE,
			requests(CE,
				 OtherCE,
				 PHI)),
		 for(requires(CE,PHI),
		     Purpose)),
	      '164.514(d)(4)(iii)(A)')) :-
	about(PHI,Individual),
	wm(s164_514d4iiiA(CE,OtherCE,Purpose,PHI)).

s164_514d4iiiB(CE,OtherCE,PHI) :-
	requests(CE,
		 OtherCE,
		 discloses(OtherCE,
			   CE,
			   PHI)),
	maintains(OtherCE,PHI),
	isCoveredEntity(CE),
	add_to_wm(s164_514d4iiiB(CE,OtherCE,PHI)).
obligation(CE,
	   individually(CE,
			reviews(requests(CE,
					 OtherCE,
					 discloses(OtherCE,
						   CE,
						   PHI)))),
	   '164.514(d)(4)(iii)(B)') :-
	wm(s164_514d4iiiB(CE,OtherCE,PHI)).
implied(right(Individual,
	      individually(CE,
			   reviews(requests(CE,
					    OtherCE,
					    discloses(OtherCE,
						      CE,
						      PHI)))),
	      '164.514(d)(4)(iii)(B)')) :-
	about(PHI,Individual),
	wm(s164_514d4iiiB(CE,OtherCE,PHI)).

isUsesDisclosureOrRequest(CE,_,PHI,uses(CE,PHI)).
isUsesDisclosureOrRequest(CE,ThirdParty,PHI,discloses(CE,ThirdParty,PHI)).
isUsesDisclosureOrRequest(CE,ThirdParty,PHI,requests(CE,ThirdParty,PHI)).

s164_514d5(CE,ThirdParty,PHI,UsesDisclosureOrRequest,Purpose) :-
	isPHI(PHI),
	isEntireMedicalRecord(PHI),
	not(for(requires(CE,PHI),
	        UsesDisclosureOrRequest)),
	not(minimumNecessaryException(CE, PHI, Purpose)),
	add_to_wm(s164_514d5(CE,ThirdParty,PHI,UsesDisclosureOrRequest,Purpose)).
obligation(CE,
	   not(for(UsesDisclosureOrRequest,
	           Purpose)),
	   '164.514(d)(5)') :-
	wm(s164_514d5(CE,ThirdParty,PHI,UsesDisclosureOrRequest,Purpose)).
implied(right(Individual,
	      not(for(UsesDisclosureOrRequest,Purpose)),
	      '164.514(d)(5)')) :-
	about(PHI,Individual),
	wm(s164_514d5(CE,ThirdParty,PHI,UsesDisclosureOrRequest,Purpose)).
	
s164_514d5_privilege(CE,ThirdParty,PHI,UsesDisclosureOrRequest,Purpose) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	isEntireMedicalRecord(PHI),
	for(requires(CE,
		     PHI),
	    UsesDisclosureOrRequest),
	not(minimumNecessaryException(CE, PHI, Purpose)),
	meetsRequirementsOf_s164_514d5(isUsesDisclosureOrRequest(CE,ThirdParty,PHI,UsesDisclosureOrRequest)),
	add_to_wm(s164_514d5_privilege(CE,ThirdParty,PHI,UsesDisclosureOrRequest,Purpose)).
privilege(CE,
	  for(UsesDisclosureOrRequest,Purpose),
	  '164.514(d)(5)') :-
	wm(s164_514d5_privilege(CE,ThirdParty,PHI,UsesDisclosureOrRequest,Purpose)).
implied(noRight(Individual,
		right(Individual,
		      not(for(UsesDisclosureOrRequest,Purpose)),
		      _),
		'164.514(d)(5)')) :-
	about(PHI,Individual),
	wm(s164_514d5_privilege(CE,ThirdParty,PHI,UsesDisclosureOrRequest,Purpose)).

s164_514e1(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	isUsageOrDisclosure(CE,ThirdParty,PHI,UsageOrDisclosure),
	isLimitedDataSet(PHI),
	isLimitedDataSetRecipient(ThirdParty),
	s164_514e3i_Purpose(CE,Purpose,PHI),
	obtains(CE,
		satisfactory(assures(ThirdParty,
				     CE,
				     dataUseAgreement(CE,ThirdParty)))),
	add_to_wm(s164_514e1(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI)).
privilege(CE,
	  UsageOrDisclosure,
	  '164.514(e)') :-
	wm(s164_514e1(CE,_,Purpose,UsageOrDisclosure,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(UsageOrDisclosure),
		      _),
		'164.514(e)')) :-
	about(PHI,Individual),
	wm(s164_514e1(CE,_,Purpose,UsageOrDisclosure,PHI)).

isLimitedDataSetRecipient(ThirdParty) :-
	discloses(CE,
		  ThirdParty,
		  LimitedDataSet),
	isLimitedDataSet(LimitedDataSet),
	maintains(CE,LimitedDataSet),
	isCoveredEntity(CE).
isLimitedDataSetRecipient(ThirdParty) :-
	receives(ThirdParty,
		 CE,
		 LimitedDataSet),
	isLimitedDataSet(LimitedDataSet),
	maintains(CE,LimitedDataSet),
	isCoveredEntity(CE).

isLimitedDataSet(PHI) :-
	not(contains(PHI,Info)),
	s164_514e2_info(Individual,Info),
	about(PHI,Individual).
s164_514e2_info(Person,name(Person)).
s164_514e2_info(Person,Location) :-
	locatedAt(Person,Location),
	not(isCity(Location)),
	not(isState(Location)),
	not(isZipCode(Location)).
s164_514e2_info(Person,telephoneNumber(Person)).
s164_514e2_info(Person,faxNumber(Person)).
s164_514e2_info(Person,emailAddress(Person)).
s164_514e2_info(Person,ssn(Person)).
s164_514e2_info(Person,medicalRecordNumber(Person)).
s164_514e2_info(Person,healthPlanBeneficiaryNumber(Person)).
s164_514e2_info(Person,accountNumber(Person)).
s164_514e2_info(Person,licenseNumber(Person)).
s164_514e2_info(Person,licensePlateNumber(Person)).
s164_514e2_info(Person,vin(Person)).
s164_514e2_info(Person,deviceIdentifiers(Person)).
s164_514e2_info(Person,url(Person)).
s164_514e2_info(Person,ipAddress(Person)).
s164_514e2_info(Person,biometricIdentifier(Person)).
s164_514e2_info(Person,fingerPrint(Person)).
s164_514e2_info(Person,voicePrint(Person)).
s164_514e2_info(Person,photo(face(Person))).

s164_514e3i_Purpose(_,research,_).
s164_514e3i_Purpose(_,publicHealth,_).
s164_514e3i_Purpose(CE,healthcareOperations(CE),_).

s164_514e3ii(CE,LimitedDataSet,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	isLimitedDataSet(LimitedDataSet),
	(   uses(CE,
		 LimitedDataSet)
	    ; 
	    not(uses(CE,
		     LimitedDataSet))
	),
	add_to_wm(s164_514e3ii(CE,LimitedDataSet,PHI)).
privilege(CE,
	  for(uses(CE,PHI),
	      creates(CE,
		      LimitedDataSet)),
    '164.514(e)(3)(ii)') :-
	wm(s164_514e3ii(CE,LimitedDataSet,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(for(uses(CE,PHI),
			      creates(CE,
				      LimitedDataSet))),
		      _),
		'164.514(e)(3)(ii)')) :-
	wm(s164_514e3ii(CE,LimitedDataSet,PHI)).
privilege(CE,
	  for(discloses(CE,BA,PHI),
	      creates(BA,
		      LimitedDataSet)),
	  '164.514(e)(3)(ii)') :-
	areBusinessAssociates(CE,BA),
	wm(s164_514e3ii(CE,LimitedDataSet,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(for(discloses(CE,BA,PHI),
			      creates(BA,
				      LimitedDataSet))),
		      _),
		'164.514(e)(3)(ii)')) :-
	areBusinessAssociates(CE,BA),
	about(PHI,Individual),
	wm(s164_514e3ii(CE,LimitedDataSet,PHI)).

obtains(CE,
	satisfactory(assures(ThirdParty,
			     CE,
			     dataUseAgreement(CE,ThirdParty)))) :-
	obtains(CE,
		dataUseAgreement(CE,ThirdParty)),
	isCoveredEntity(CE),
	isLimitedDataSetRecipient(ThirdParty),
	dataUseAgreement(CE,ThirdParty).

s164_514e4iiA_permitted(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	privilege(CE,
		  for(UsageOrDisclosure,
		      Purpose),
		  Subsection),
	isSubsectionOf(Subsection,'164.514(e)(3)'),
	isUsageOrDisclosure(ThirdParty,_,PHI,UsageOrDisclosure),
	dataUseAgreement(CE,ThirdParty),
	add_to_wm(s164_514e4iiA_permitted(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI)).
obligation(CE,
	   contains(dataUseAgreement(CE,ThirdParty),
		    permits(law,
			    for(UsageOrDisclosure,
				Purpose))),
	   '164.514(e)(4)(ii)(A)') :-
	wm(s164_514e4iiA_permitted(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI)).
implied(right(Individual,
	      knows(Individual,
		    permits(law,
			    for(UsageOrDisclosure,
				Purpose))),
	      '164.514(e)(4)(ii)(A)')) :-
	about(PHI,Individual),
	wm(s164_514e4iiA_permitted(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI)).

s164_514e4iiA_notPermitted(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	not(privilege(CE,
		for(discloses(CE,
			      _,
			      PHI),
		    Purpose),
		Subsection)),
	isSubsectionOf(Subsection,'164.514(e)(3)'),
	isUsageOrDisclosure(ThirdParty,_,PHI,UsageOrDisclosure),
	dataUseAgreement(CE,ThirdParty),
	add_to_wm(s164_514e4iiA_notPermitted(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI)).
obligation(CE,
	   not(contains(dataUseAgreement(CE,ThirdParty),
			for(UsageOrDisclosure,
			    Purpose))),
	   '164.514(e)(4)(ii)(A)') :-
	wm(s164_514e4iiA_notPermitted(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI)).
implied(right(Individual,
	      knows(Individual,
		    for(UsageOrDisclosure,
			Purpose)),
     '164.514(e)(4)(ii)(A)')) :-
	about(PHI,Individual),
	wm(s164_514e4iiA_notPermitted(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI)).
liability(ThirdParty,
	  not(for(UsageOrDisclosure,
		  Purpose)),
	  '164.514(e)(4)(ii)(A)') :-
	wm(s164_514e4iiA_notPermitted(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI)).
implied(power(CE,
	      dataUseAgreement(CE,ThirdParty),
	      requires(CE,
		       not(for(UsageOrDisclosure,
			       Purpose))),
	      '164.514(e)(4)(ii)(A)')) :-
	wm(s164_514e4iiA_notPermitted(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI)).
disability(CE,
	   power(CE,
		 dataUseAgreement(CE,ThirdParty),
		 authorizes(CE,
			    ThirdParty,
			    for(UsageOrDisclosure,
				Purpose)),
		 _),
	   '164.514(e)(4)(ii)(A)') :-
	wm(s164_514e4iiA_notPermitted(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI)).
implied(immunity(ThirdParty,
		 CE,
		 power(CE,
		       dataUseAgreement(CE,ThirdParty),
		       authorizes(CE,
				  ThirdParty,
				  for(UsageOrDisclosure,
				      Purpose)),
		       _),
		 '164.514(e)(4)(ii)(A)')) :-
	wm(s164_514e4iiA_notPermitted(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI)).

s164_514e4iiB(CE,ThirdParty,Person,Purpose,UsesOrReceives,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	permits(law,
		for(UsesOrReceives,
		    Purpose)),
	usesOrReceives(Person,ThirdParty,PHI,UsesOrReceives),
	dataUseAgreement(CE,ThirdParty),
	add_to_wm(s164_514e4iiB(CE,ThirdParty,Person,Purpose,UsesOrReceives,PHI)).
usesOrReceives(Person,_,PHI,uses(Person,PHI)).
usesOrReceives(Person,ThirdParty,PHI,receives(Person,ThirdParty,PHI)).
obligation(CE,
	   contains(dataUseAgreement(CE,ThirdParty),
		    Person),
	   '164.514(e)(4)(ii)(B)') :-
	wm(s164_514e4iiB(CE,ThirdParty,Person,Purpose,UsesOrReceives,PHI)).
implied(right(Individual,
	      knows(Individual,Person),
	      '164.514(e)(4)(ii)(B)')) :-
	about(PHI,Individual),
	wm(s164_514e4iiB(CE,ThirdParty,Person,Purpose,UsesOrReceives,PHI)).
liability(ThirdParty,
	  establishes(ThirdParty,
		      Person),
	  '164.514(e)(4)(ii)(B)') :-
	wm(s164_514e4iiB(CE,ThirdParty,Person,Purpose,UsesOrReceives,PHI)).
implied(power(CE,
	      dataUseAgreement(CE,ThirdParty),
	      requires(CE,
		       establishes(ThirdParty,
				   Person)),
	      '164.514(e)(4)(ii)(B)')) :-
	wm(s164_514e4iiB(CE,ThirdParty,Person,Purpose,UsesOrReceives,PHI)).

s164_514e4iiC1(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	not(permits(dataUseAgreement(CE,ThirdParty),
		    for(UsageOrDisclosure,
			Purpose))),
	not(requires(law,
		     for(UsageOrDisclosure,
			 Purpose))),
	dataUseAgreement(CE,ThirdParty),
	isUsageOrDisclosure(CE,ThirdParty,PHI,UsageOrDisclosure),
	add_to_wm(s164_514e4iiC1(CE,ThirdParty,Purpose,PHI)).
obligation(CE,
	   contains(dataUseAgreement(CE,ThirdParty),
		    not(for(UsageOrDisclosure,
			    Purpose))),
	   '164.514(e)(4)(ii)(C)(1)') :-
	wm(s164_514e4iiC1(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI)).
implied(right(Individual,
	      knows(Individual,
		    not(for(UsageOrDisclosure,
			    Purpose))),
	      '164.514(e)(4)(ii)(C)(1)')) :-
	about(PHI,Individual),
	wm(s164_514e4iiC1(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI)).
liability(ThirdParty,
	  not(for(UsageOrDisclosure,
		  Purpose)),
	  '164.514(e)(4)(ii)(C)(1)') :-
	wm(s164_514e4iiC1(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI)).
implied(power(CE,
	      dataUseAgreement(CE,ThirdParty),
	      requires(CE,
		       not(for(UsageOrDisclosure,
			       Purpose))),
	      '164.514(e)(4)(ii)(C)(1)')) :-
	wm(s164_514e4iiC1(CE,ThirdParty,Purpose,UsageOrDisclosure,PHI)).

s164_514e4iiC2(CE,ThirdParty,X,Purpose,UsageOrDisclosure,PHI) :-
	dataUseAgreement(CE,ThirdParty),
	isCoveredEntity(CE),
	isPHI(PHI),
	not(permits(dataUseAgreement(CE,ThirdParty),
		    for(UsageOrDisclosure,
			Purpose))),
	isUsageOrDisclosure(X,_,PHI,UsageOrDisclosure),
	add_to_wm(s164_514e4iiC2(CE,ThirdParty,X,Purpose,UsageOrDisclosure,PHI)).
obligation(CE,
	   contains(dataUseAgreement(CE,ThirdParty),
		    to(uses(CE,
			    appropriate(safeguards(ThirdParty,
						   PHI))),
		       prevents(ThirdParty,
				for(UsageOrDisclosure,
				    Purpose)))),
	   '164.514(e)(4)(ii)(C)(2)') :-
	wm(s164_514e4iiC2(CE,ThirdParty,X,Purpose,UsageOrDisclosure,PHI)).
implied(right(Individual,
	      knows(to(uses(CE,
		      appropriate(safeguards(ThirdParty,
					     PHI))),
		       prevents(ThirdParty,
				for(UsageOrDisclosure,
				    Purpose)))),
	      '164.514(e)(4)(ii)(C)(2)')) :-
	about(PHI,Individual),
	wm(s164_514e4iiC2(CE,ThirdParty,X,Purpose,UsageOrDisclosure,PHI)).
liability(ThirdParty,
	  appropriate(safeguards(ThirdParty,
				 PHI)),
	  '164.514(e)(4)(ii)(C)(2)') :-
	wm(s164_514e4iiC2(CE,ThirdParty,X,Purpose,UsageOrDisclosure,PHI)).
implied(power(CE,
	      dataUseAgreement(CE,ThirdParty),
	      requires(CE,
		       appropriate(safeguards(ThirdParty,
				 PHI))),
	  '164.514(e)(4)(ii)(C)(2)')) :-
	wm(s164_514e4iiC2(CE,ThirdParty,X,Purpose,UsageOrDisclosure,PHI)).

s164_514e4iiC3(CE,ThirdParty,X,Purpose,UsageOrDisclosure,PHI) :-
	dataUseAgreement(CE,ThirdParty),
	isCoveredEntity(CE),
	isPHI(PHI),
	not(permits(dataUseAgreement(CE,ThirdParty),
		    for(UsageOrDisclosure,
			Purpose))),
	becomesAwareOf(ThirdParty,
		       for(UsageOrDisclosure,
			   Purpose)),
	isUsageOrDisclosure(X,_,PHI,UsageOrDisclosure),
	add_to_wm(s164_514e4iiC3(CE,ThirdParty,X,Purpose,UsageOrDisclosure,PHI)).
obligation(CE,
	   contains(dataUseAgreement(CE,ThirdParty),
		    reports(ThirdParty,
			    CE,
			    for(UsageOrDisclosure,
				Purpose))),
	   '164.514(e)(4)(ii)(C)(3)') :-
	wm(s164_514e4iiC3(CE,ThirdParty,X,Purpose,UsageOrDisclosure,PHI)).
% TODO what is the implied right?
liability(ThirdParty,
	  reports(ThirdParty,
		  CE,
		  for(UsageOrDisclosure,
		      Purpose)),
	  '164.514(e)(4)(ii)(C)(3)') :-
	wm(s164_514e4iiC3(CE,ThirdParty,X,Purpose,UsageOrDisclosure,PHI)).
implied(power(CE,
	      dataUseAgreement(CE,ThirdParty),
	      requires(CE,
		       reports(ThirdParty,
			       CE,
			       for(UsageOrDisclosure,
				   Purpose))),
	      '164.514(e)(4)(ii)(C)(3)')) :-
	wm(s164_514e4iiC3(CE,ThirdParty,X,Purpose,UsageOrDisclosure,PHI)).

s164_514e4iiC4_restricts(CE,ThirdParty,Agent,PHI) :-
	dataUseAgreement(CE,ThirdParty),
	isCoveredEntity(CE),
	isPHI(PHI),
	restricts(CE,
		  ThirdParty,
		  _),
	provides(ThirdParty,
		 Agent,
		 PHI),
	add_to_wm(s164_514e4iiC4_restricts(CE,ThirdParty,Agent,PHI)).
obligation(CE,
	   contains(dataUseAgreement(CE,ThirdParty),
		    ensures(agrees(Agent,
				   restricts(CE,
					     ThirdParty,
					     _)))),
	   '164.514(e)(4)(ii)(C)(4)') :-
	wm(s164_514e4iiC4_restricts(CE,ThirdParty,Agent,PHI)).
implied(right(Individual,
	      restricts(CE,ThirdParty,_),
	      '164.514(e)(4)(ii)(C)(4)')) :-
	about(PHI,Individual),
	wm(s164_514e4iiC4_restricts(CE,ThirdParty,Agent,PHI)).
liability(ThirdParty,
	  ensures(agrees(Agent,
			 restricts(CE,
				   ThirdParty,
				   _))),
	  '164.514(e)(4)(ii)(C)(4)') :-
	wm(s164_514e4iiC4_restricts(CE,ThirdParty,Agent,PHI)).
implied(power(CE,
	      dataUseAgreement(CE,ThirdParty),
	      requires(CE,
		       ensures(agrees(Agent,
				      restricts(CE,
						ThirdParty,
						_)))),
	      '164.514(e)(4)(ii)(C)(4)')) :-
	wm(s164_514e4iiC4_restricts(CE,ThirdParty,Agent,PHI)).
	      
s164_514e4iiC4_conditions(CE,ThirdParty,Agent,PHI) :-
	dataUseAgreement(CE,ThirdParty),
	isCoveredEntity(CE),
	isPHI(PHI),
	isConditionOf(_,
		      dataUseAgreement(CE,ThirdParty)),
	provides(ThirdParty,
		 Agent,
		 PHI),
	add_to_wm(s164_514e4iiC4_conditions(CE,ThirdParty,Agent,PHI)).
obligation(CE,
	   contains(dataUseAgreement(CE,ThirdParty),
		    ensures(agrees(Agent,
				   isConditionOf(_,
						 dataUseAgreement(CE,ThirdParty))))),
	   '164.514(e)(4)(ii)(C)(4)') :-
	wm(s164_514e4iiC4_conditions(CE,ThirdParty,Agent,PHI)).
% TODO what is the implied right
liability(ThirdParty,
	  ensures(agrees(Agent,
			     isConditionOf(_,
					   dataUseAgreement(CE,ThirdParty)))),
     '164.514(e)(4)(ii)(C)(4)') :-
	wm(s164_514e4iiC4_conditions(CE,ThirdParty,Agent,PHI)).
implied(power(CE,
	      dataUseAgreement(CE,ThirdParty),
	      requires(CE,
		       ensures(agrees(Agent,
			     isConditionOf(_,
					   dataUseAgreement(CE,ThirdParty))))),
	      '164.514(e)(4)(ii)(C)(4)')) :-
	wm(s164_514e4iiC4_conditions(CE,ThirdParty,Agent,PHI)).

s164_514e4iiC5(CE,ThirdParty,Individual,PHI) :-
	dataUseAgreement(CE,ThirdParty),
	isCoveredEntity(CE),
	isPHI(PHI),
	about(PHI,Individual),
	add_to_wm(s164_514e4iiC5(CE,ThirdParty,Individual,PHI)).
obligation(CE,
	   contains(dataUseAgreement(CE,ThirdParty),
		    not(identifies(ThirdParty,
				   Individual))),
	   '164.514(e)(4)(ii)(C)(5)') :-
	wm(s164_514e4iiC5(CE,ThirdParty,Individual,PHI)).
implied(right(Individual,
	      not(identifies(ThirdParty,
			     Individual)),
	      '164.514(e)(4)(ii)(C)(5)')) :-
	wm(s164_514e4iiC5(CE,ThirdParty,Individual,PHI)).
liability(ThirdParty,
	  not(identifies(ThirdParty,
			     Individual)),
	      '164.514(e)(4)(ii)(C)(5)') :-
	wm(s164_514e4iiC5(CE,ThirdParty,Individual,PHI)).
implied(power(CE,
	      dataUseAgreement(CE,ThirdParty),
	      requires(CE,
		       not(identifies(ThirdParty,
			     Individual))),
	      '164.514(e)(4)(ii)(C)(5)')) :-
	wm(s164_514e4iiC5(CE,ThirdParty,Individual,PHI)).
obligation(CE,
	   contains(dataUseAgreement(CE,ThirdParty),
		    not(contacts(ThirdParty,
				 Individual))),
	   '164.514(e)(4)(ii)(C)(5)') :-
	wm(s164_514e4iiC5(CE,ThirdParty,Individual,PHI)).
implied(right(Individual,
	      not(contacts(ThirdParty,
			   Individual)),
     '164.514(e)(4)(ii)(C)(5)')) :-
	wm(s164_514e4iiC5(CE,ThirdParty,Individual,PHI)).
liability(ThirdParty,
	  not(contacts(ThirdParty,
			   Individual)),
	  '164.514(e)(4)(ii)(C)(5)') :-
	wm(s164_514e4iiC5(CE,ThirdParty,Individual,PHI)).
implied(power(CE,
	      dataUseAgreement(CE,ThirdParty),
	      requires(CE,
		       not(contacts(ThirdParty,
			   Individual))),
	  '164.514(e)(4)(ii)(C)(5)')) :-
	wm(s164_514e4iiC5(CE,ThirdParty,Individual,PHI)).

inNonCompliance(CE,'164.514(e)') :-
	isCoveredEntity(CE),
	knows(CE,
	      pattern(violates(ThirdParty,
			       dataUseAgreement(CE,ThirdParty)))),
	not(s164_514e4iiiA_exception(CE,ThirdParty)),
	dataUseAgreement(CE,ThirdParty),
	discloses(CE,
		  ThirdParty,
		  PHI),
	isPHI(PHI).
	
s164_514e4iiiA_exception(CE,ThirdParty) :-
	reasonable(takesStepsTo(CE,
				ends(CE,
				     violates(ThirdParty,
					      dataUseAgreement(CE,ThirdParty))))),
	isCoveredEntity(CE),
	dataUseAgreement(CE,ThirdParty),
	knows(CE,
	      pattern(violates(ThirdParty,
			       dataUseAgreement(CE,ThirdParty)))).
s164_514e4iiiA_exception(CE,ThirdParty) :-
	reasonable(takesStepsTo(CE,
				cures(CE,
				      violates(ThirdParty,
					      dataUseAgreement(CE,ThirdParty))))),
	isCoveredEntity(CE),
	dataUseAgreement(CE,ThirdParty),
	knows(CE,
	      pattern(violates(ThirdParty,
			       dataUseAgreement(CE,ThirdParty)))).
s164_514e4iiiA_exception(CE,ThirdParty) :-
	unsuccessful(reasonable(takesStepsTo(CE,
				cures(CE,
				      violates(ThirdParty,
					      dataUseAgreement(CE,ThirdParty)))))),
	unsuccessful(reasonable(takesStepsTo(CE,
				ends(CE,
				     violates(ThirdParty,
					      dataUseAgreement(CE,ThirdParty)))))),
	isCoveredEntity(CE),
	dataUseAgreement(CE,ThirdParty),
	discontinues(CE,
		      discloses(CE,
				ThirdParty,
				PHI)),
	reports(CE,
		secretary(hhs),
		violates(ThirdParty,
			 dataUseAgreement(CE,ThirdParty))),
	isPHI(PHI).

inNonCompliance(CE, '164.514(e)') :-
	dataUseAgreement(OtherCE,CE),
	isCoveredEntity(OtherCE),
	isCoveredEntity(CE),
	violates(CE,
		 dataUseAgreement(OtherCE,CE)).

is_s164_514f1_info(PHI) :-
	isDemographicInformation(PHI).
is_s164_514f1_info(date(treats(CE,Individual))) :-
	treats(CE,Individual).
is_s164_514f1_thirdParty(CE, ThirdParty) :-
	areBusinessAssociates(CE,ThirdParty).
is_s164_514f1_thirdParty(_, ThirdParty) :-
	isInstitutionallyRelatedFoundation(ThirdParty).
s164_514f1_uses(CE,Individual,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	is_s164_514f1_info(PHI),
	add_to_wm(s164_514f1_uses(CE,Individual,PHI)).
privilege(CE,
	  without(for(uses(CE,PHI),
		      fundraising(CE)),
		  authorizes(Individual,CE,for(uses(CE,PHI),fundraising(CE)))),
	  '164.514(f)(1)') :-
	wm(s164_514f1_uses(CE,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(without(for(uses(CE,PHI),
				      fundraising(CE)),
				  authorizes(Individual,CE,for(uses(CE,PHI),fundraising(CE))))),
		      _),
		'164.514(f)(1)')) :-
	wm(s164_514f1_uses(CE,Individual,PHI)).
s164_514f1_discloses(CE,ThirdParty,Individual,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	is_s164_514f1_info(PHI),
	is_s164_514f1_thirdParty(CE,ThirdParty),
	add_to_wm(s164_514f1_discloses(CE,ThirdParty,Individual,PHI)).
privilege(CE,
	  without(for(discloses(CE,ThirdParty,PHI),
		      fundraising(CE)),
		  authorizes(Individual,CE,for(discloses(CE,ThirdParty,PHI),
					       fundraising(CE)))),
	  '164.514(f)(1)') :-
	wm(s164_514f1_discloses(CE,ThirdParty,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(for(discloses(CE,ThirdParty,PHI),
			      fundraising(CE))),
		      _),
		'164.514(f)(1)')) :-
	wm(s164_514f1_discloses(CE,ThirdParty,Individual,PHI)).

s164_514f2i_uses(CE,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	wm(s164_514f1_uses(CE,Individual,PHI)),
	not(states(notice(_),
		   'The covered entity may contact the individual to raise funds for the covered entity')),
	add_to_wm(s164_514f2i_uses(CE,PHI)).
obligation(CE,
	   not(for(uses(CE,
			PHI),
		   fundraising(CE))),
	   '164.514(f)(2)(i)') :-
	wm(s164_514f2i_uses(CE,PHI)).
implied(right(Individual,
	      not(for(uses(CE,
			   PHI),
		      fundraising(CE))),
	      '164.514(f)(2)(i)')) :-
	about(PHI,Individual),
	wm(s164_514f2i_uses(CE,PHI)).
s164_514f2i_discloses(CE,ThirdParty,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	wm(s164_514f1_discloses(CE,ThirdParty,Individual,PHI)),
	not(states(notice(_),
		   'The covered entity may contact the individual to raise funds for the covered entity')),
	add_to_wm(s164_514f2i_discloses(CE,ThirdParty,PHI)).
obligation(CE,
	   not(for(discloses(CE,
			     ThirdParty,
			     PHI),
		   fundraising(CE))),
	   '164.514(f)(2)(i)') :-
	wm(s164_514f2i_discloses(CE,ThirdParty,PHI)).
implied(right(Individual,
	      not(for(discloses(CE,ThirdParty,PHI),
		      fundraising(CE))),
     '164.514(f)(2)(i)')) :-
	about(PHI,Individual),
	wm(s164_514f2i_discloses(CE,ThirdParty,PHI)).

s164_514f2i_privilege_uses(CE,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	wm(s164_514f1_uses(CE,Individual,PHI)),
	not(states(notice(_),
		   'The covered entity may contact the individual to raise funds for the covered entity')),
	add_to_wm(s164_514f2i_privilege_uses(CE,PHI)).
privilege(CE,
	  for(uses(CE,PHI),fundraising(CE)),
	  '164.514(f)(2)(i)') :-
	wm(s164_514f2i_privilege_uses(CE,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(for(uses(CE,PHI),fundraising(CE))),
		      _),
		'164.514(f)(2)(i)')) :-
	wm(s164_514f2i_privilege_uses(CE,PHI)).
s164_514f2i_privilege_discloses(CE,ThirdParty,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	wm(s164_514f1_discloses(CE,ThirdParty,Individual,PHI)),
	not(states(notice(_),
		   'The covered entity may contact the individual to raise funds for the covered entity')),
	add_to_wm(s164_514f2i_privilege_discloses(CE,ThirdParty,PHI)).
privilege(CE,
	  for(discloses(CE,ThirdParty,PHI),fundraising(CE)),
	  '164.514(f)(2)(i)') :-
	wm(s164_514f2i_privilege_discloses(CE,ThirdParty,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(for(discloses(CE,ThirdParty,PHI),fundraising(CE))),
		      _),
		'164.514(f)(2)(i)')) :-
	wm(s164_514f2i_privilege_discloses(CE,ThirdParty,PHI)).

s164_514f2ii(CE,Individual,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	about(PHI,Individual),
	add_to_wm(s164_514f2ii(CE,Individual,PHI)).
obligation(CE,
	   includes(description(optsOut(Individual,
					receives(Individual,
						 CE,
						 communications(fundraising(CE))))),
		    fundraisingMaterials(CE)),
	   '164.514(f)(2)(ii)') :-
	wm(s164_514f2ii(CE,Individual,PHI)).
implied(right(Individual,
	      optsOut(Individual,
				  receives(Individual,
					   CE,
					   communications(fundraising(CE)))),
	      '164.514(f)(2)(ii)')) :-
	about(PHI,Individual),
	wm(s164_514f2ii(CE,Individual,PHI)).

s164_514f2iii(CE,Individual,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	about(PHI,Individual),
	optsOut(Individual,
		receives(Individual,
			 CE,
			 communications(fundraising(CE)))),
	add_to_wm(s164_514f2iii(CE,Individual,PHI)).
obligation(CE,
	   reasonable(makesEfforts(CE,
				   not(sends(CE,
					     Individual,
					     communications(fundraising(CE)))))),
	   '164.514(f)(2)(iii)') :-
	wm(s164_514f2iii(CE,Individual,PHI)).
implied(right(Individual,
	      not(sends(CE,
			Individual,
			communications(fundraising(CE)))),
	      '164.514(f)(2)(iii)')) :-
	about(PHI,Individual),
	wm(s164_514f2iii(CE,Individual,PHI)).

s164_514g(HealthPlan,Benefits,UsageOrDisclosure,Purpose,OtherPurpose,PHI) :-
	isCoveredEntity(HealthPlan),
	isPHI(PHI),
	isUsageOrDisclosure(HealthPlan,_,PHI,UsageOrDisclosure),
	for(receives(HealthPlan,
		     _,
		     PHI),
	    Purpose),
	is_s164_514g_purpose(HealthPlan,Benefits,Purpose),
	not(required_by_law(HealthPlan,
			    for(uses(HealthPlan,
				     PHI),
			        OtherPurpose),
			    _)),
	is_s164_514g_benefits(Benefits),
	add_to_wm(s164_514g(HealthPlan,Benefits,Purpose,OtherPurpose,PHI)).
obligation(HealthPlan,
	   not(for(UsageOrDisclosure,
		   OtherPurpose)),
	   '164.514(g)') :-
	wm(s164_514g(HealthPlan,Benefits,UsageOrDisclosure,Purpose,OtherPurpose,PHI)).
implied(right(Individual,
	      not(for(UsageOrDisclosure,
		      OtherPurpose)),
	      '164.514(g)')) :-
	about(PHI,Individual),
	wm(s164_514g(HealthPlan,Benefits,UsageOrDisclosure,Purpose,OtherPurpose,PHI)). 
is_s164_514g_benefits(Benefits) :-
	healthBenefits(Benefits).
is_s164_514g_benefits(Benefits) :-
	isHealthInsurance(Benefits).
is_s164_514g_purpose(HealthPlan,
		     Benefits,
		     underwrites(HealthPlan,Benefits)).
is_s164_514g_purpose(HealthPlan,
		     Benefits,
		     rates(HealthPlan,premium(Benefits))).
is_s164_514g_purpose(HealthPlan,
		     Benefits,
		     creates(HealthPlan,contract(Benefits))).
is_s164_514g_purpose(HealthPlan,
		     Benefits,
		     renews(HealthPlan,contract(Benefits))).
is_s164_514g_purpose(HealthPlan,
		     Benefits,
		     replaces(HealthPlan,contract(Benefits))).

:- dynamic has_access_according_to_514/2.
s164_514h1i(CE,ThirdParty,IdentityOrAuthority,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	requests(ThirdParty,CE,PHI),
	permitted_by_164_514(CE,ThirdParty,PHI),
	isIdentityOrAuthority(ThirdParty,IdentityOrAuthority),
	not(knows(CE,IdentityOrAuthority)),
	not(privilege(CE,discloses(CE,ThirdParty,PHI),'164.510')),
% TODO figure out recursive call
	not(obligation(CE,discloses(CE,ThirdParty,PHI),'164.510')),
	add_to_wm(s164_514h1i(CE,ThirdParty,IdentityOrAuthority,PHI)).
isIdentityOrAuthority(ThirdParty,identity(ThirdParty)).
isIdentityOrAuthority(ThirdParty,authority(ThirdParty)).
obligation(CE,
	   before(discloses(CE,
			    ThirdParty,
			    PHI),
		  verifies(CE,
			   IdentityOrAuthority)),
     '164.514(h)(1)(i)') :-
	wm(s164_514h1i(CE,ThirdParty,IdentityOrAuthority,PHI)).
implied(right(Individual,
	      before(discloses(CE,
		      ThirdParty,
		      PHI),
	    verifies(CE,
		     IdentityOrAuthority)),
     '164.514(h)(1)(i)')) :-
        about(PHI,Individual),
	wm(s164_514h1i(CE,ThirdParty,IdentityOrAuthority,PHI)).

s164_514h1ii(CE,ThirdParty,Documentation,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	requests(ThirdParty,
		 CE,
		 PHI),
	is_s164_514h1i_documentation(CE,ThirdParty,PHI,Documentation),
	isConditionOf(Documentation,
		      discloses(CE,
			        ThirdParty,
			        PHI)),
	add_to_wm(s164_514h1ii(CE,ThirdParty,Documentation,PHI)).
obligation(CE,
	   before(discloses(CE,
			    ThirdParty,
			    PHI),
		  obtains(CE,
			  Documentation)),
	   '164.514(h)(1)(ii)') :-
	wm(s164_514h1ii(CE,ThirdParty,Documentation,PHI)).
% TODO add implied right
is_s164_514h1i_documentation(CE,
			     ThirdParty,
			     PHI,
			     oral(documents(CE,requests(ThirdParty,CE,PHI)))).
is_s164_514h1i_documentation(CE,
			     ThirdParty,
			     PHI,
			     written(documents(CE,requests(ThirdParty,CE,PHI)))).
is_s164_514h1i_documentation(CE,
			     ThirdParty,
			     PHI,
			     oral(states(ThirdParty,requests(ThirdParty,CE,PHI)))).
is_s164_514h1i_documentation(CE,
			     ThirdParty,
			     PHI,
			     written(states(ThirdParty,requests(ThirdParty,CE,PHI)))).
is_s164_514h1i_documentation(CE,
			     ThirdParty,
			     PHI,
			     oral(represents(CE,requests(ThirdParty,CE,PHI)))).
is_s164_514h1i_documentation(CE,
			     ThirdParty,
			     PHI,
			     written(represents(CE,requests(ThirdParty,CE,PHI)))).

s164_514h2i(CE,ThirdParty,Statement,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	isConditionOf(Statement,
		      discloses(CE,
			        ThirdParty,
			        PHI)),
	reasonable(relies(CE,
			  Statement)),
	is_s164_514h2i_statement(CE,ThirdParty,PHI,Statement),
	add_to_wm(s164_514h2i(CE,ThirdParty,Statement,PHI)).
privilege(CE,
	  for(relies(CE,
		     Statement),
	      meets(CE,
		    isConditionOf(Statement,
				  discloses(CE,
					    ThirdParty,
					    PHI)))),
	  '164.514(h)(2)(i)') :-
	wm(s164_514h2i(CE,ThirdParty,Statement,PHI)).
% TODO what is the implied no right?

is_s164_514h2i_statement(CE,ThirdParty,PHI,states(ThirdParty,X)) :-
	isConditionOf(states(ThirdParty,X),
		      discloses(CE,
				ThirdParty,
				PHI)),
	privilege(CE,
		  discloses(CE,ThirdParty,PHI),
		  Section),
	isSubsectionOf(Section, '164.514').
is_s164_514h2i_statement(CE,ThirdParty,PHI,states(ThirdParty,X)) :-
	isConditionOf(states(ThirdParty,X),
		      discloses(CE,
				ThirdParty,
				PHI)),
	obligation(CE,
		   discloses(CE,ThirdParty,PHI),
		   Section),
	isSubsectionOf(Section, '164.514').
is_s164_514h2i_statement(CE,ThirdParty,PHI,documents(ThirdParty,X)) :-
	isConditionOf(documents(ThirdParty,X),
		      discloses(CE,
				ThirdParty,
				PHI)),
	privilege(CE,
		  discloses(CE,ThirdParty,PHI),
		  Section),
	isSubsectionOf(Section, '164.514').
is_s164_514h2i_statement(CE,ThirdParty,PHI,documents(ThirdParty,X)) :-
	isConditionOf(documents(ThirdParty,X),
		      discloses(CE,
				ThirdParty,
				PHI)),
	obligation(CE,
		   discloses(CE,ThirdParty,PHI),
		   Section),
	isSubsectionOf(Section, '164.514').
is_s164_514h2i_statement(CE,ThirdParty,PHI,represents(ThirdParty,X)) :-
	isConditionOf(represents(ThirdParty,X),
		      discloses(CE,
				ThirdParty,
				PHI)),
	privilege(CE,
		  discloses(CE,ThirdParty,PHI),
		  Section),
	isSubsectionOf(Section, '164.514').
is_s164_514h2i_statement(CE,ThirdParty,PHI,represents(ThirdParty,X)) :-
	isConditionOf(represents(ThirdParty,X),
		      discloses(CE,
				ThirdParty,
				PHI)),
	obligation(CE,
		   discloses(CE,ThirdParty,PHI),
		   Section),
	isSubsectionOf(Section, '164.514').

s164_514h2iiA(CE,PublicOfficial,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	reasonable(relies(CE,
			  presents(PublicOfficial,
				   identificationBadge(PublicOfficial)))),
	inPerson(requests(PublicOfficial,
			  discloses(CE,
				    PublicOfficial,
				    PHI))),
	(   isPublicOfficial(PublicOfficial)
	    ; 
	    (	actOnBehalf(PublicOfficial,
			    RealPublicOfficial),
		isPublicOfficial(RealPublicOfficial)
	    )
	),
	add_to_wm(s164_514h2iiA(CE,PublicOfficial,PHI)).
privilege(CE,
	  for(relies(CE,
		     presents(PublicOfficial,
			      identificationBadge(PublicOfficial))),
	      verifies(CE,
		       identity(PublicOfficial))),
	  '164.514(h)(2)(ii)(A)') :-
	wm(s164_514h2iiA(CE,PublicOfficial,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(for(relies(CE,
				     presents(PublicOfficial,
					      identificationBadge(PublicOfficial))),
			      verifies(CE,
				       identity(PublicOfficial)))),
		      _), 
		'164.514(h)(2)(ii)(A)')) :-
	about(PHI,Individual),
	wm(s164_514h2iiA(CE,PublicOfficial,PHI)).

s164_514h2iiB(CE,PublicOfficial,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	reasonable(relies(CE,
			  onGovernmentLetterhead(requests(PublicOfficial,
							  discloses(CE,
								    PublicOfficial,
								    PHI))))),
	written(requests(PublicOfficial,
			 discloses(CE,
				   PublicOfficial,
				   PHI))),
	onGovernmentLetterhead(requests(PublicOfficial,
					discloses(CE,
						  PublicOfficial,
						  PHI))),
	(   isPublicOfficial(PublicOfficial)
	    ; 
	    (	actOnBehalf(PublicOfficial,
			    RealPublicOfficial),
		isPublicOfficial(RealPublicOfficial)
	    )
	),
	add_to_wm(s164_514h2iiB(CE,PublicOfficial,PHI)).
privilege(CE,
	  for(relies(CE,
		     onGovernmentLetterhead(requests(PublicOfficial,
						     discloses(CE,
							       PublicOfficial,
							       PHI)))),
	      verifies(CE,
		       identity(PublicOfficial))),
	  '164.514(h)(2)(ii)(B)') :-
	wm(s164_514h2iiB(CE,PublicOfficial,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(for(relies(CE,
				     onGovernmentLetterhead(requests(PublicOfficial,
								     discloses(CE,
									       PublicOfficial,
									       PHI)))),
			      verifies(CE,
				       identity(PublicOfficial)))),
		      _),
		'164.514(h)(2)(ii)(B)')) :-
	about(PHI,Individual),
	wm(s164_514h2iiB(CE,PublicOfficial,PHI)).

s164_514h2iiC(CE,PublicOfficial,Person,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	actOnBehalf(Person,
		    PublicOfficial),
	isPublicOfficial(PublicOfficial),
	reasonable(relies(CE,
	       written(onGovernmentLetterhead(statement(actOnBehalf(Person,
								    PublicOfficial)))))),
	written(onGovernmentLetterhead(statement(actOnBehalf(Person,
								    PublicOfficial)))),
	add_to_wm(s164_514h2iiC(CE,PublicOfficial,Person,PHI)).
privilege(CE,
	  for(relies(CE,
		     written(onGovernmentLetterhead(statement(actOnBehalf(Person,
									  PublicOfficial))))),
	      verifies(CE,
		       identity(PublicOfficial))),
	  '164.514(h)(2)(ii)(C)') :-
	wm(s164_514h2iiC(CE,PublicOfficial,Person,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(for(relies(CE,
				     written(onGovernmentLetterhead(statement(actOnBehalf(Person,
											  PublicOfficial))))),
			      verifies(CE,
				       identity(PublicOfficial)))),
		      _),
		'164.514(h)(2)(ii)(C)')) :-
	about(PHI,Individual),
	wm(s164_514h2iiC(CE,PublicOfficial,Person,PHI)).

s164_514h2iiiA(CE,PublicOfficial,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	(   isPublicOfficial(PublicOfficial)
	    ; 
	    (	actOnBehalf(PublicOfficial,
			    RealPublicOfficial),
		isPublicOfficial(RealPublicOfficial)
	    )
	),
	reasonable(relies(CE,
			  written(statement(authority(PublicOfficial,
						      receives(PublicOfficial,
							       CE,
							       PHI)))))),
	add_to_wm(s164_514h2iiiA(CE,PublicOfficial,PHI)).
privilege(CE,
	  for(relies(CE,
		     written(statement(authority(PublicOfficial,
						 receives(PublicOfficial,
							  CE,
							  PHI))))),
	      verifies(CE,
		       authority(PublicOfficial,
				 receives(PublicOfficial,CE,PHI)))),
	  '164.514(h)(2)(iii)(A)') :-
	wm(s164_514h2iiiA(CE,PublicOfficial,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(for(relies(CE,
				     written(statement(authority(PublicOfficial,
								 receives(PublicOfficial,
									  CE,
									  PHI))))),
			      verifies(CE,
				       authority(PublicOfficial,
						 receives(PublicOfficial,CE,PHI))))),
		      _),
		'164.514(h)(2)(iii)(A)')) :-
	about(PHI,Individual),
	wm(s164_514h2iiiA(CE,PublicOfficial,PHI)).

s164_514h2iiiA(CE,PublicOfficial,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	(   isPublicOfficial(PublicOfficial)
	    ; 
	    (	actOnBehalf(PublicOfficial,
			    RealPublicOfficial),
		isPublicOfficial(RealPublicOfficial)
	    )
	),
	reasonable(relies(CE,
			  oral(statement(authority(PublicOfficial,
						   receives(PublicOfficial,
							    CE,
							    PHI)))))),
	impracticable(written(statement(authority(PublicOfficial,
						  receives(PublicOfficial,
							   CE,
							   PHI))))),
	add_to_wm(s164_514h2iiiA(CE,PublicOfficial,PHI)).
privilege(CE,
	  for(relies(CE,
		     oral(statement(authority(PublicOfficial,
					      receives(PublicOfficial,
						       CE,
						       PHI))))),
	      verifies(CE,
		       authority(PublicOfficial,
				 receives(PublicOfficial,CE,PHI)))),
	  '164.514(h)(2)(iii)(A)') :-
	wm(s164_514h2iiiA(CE,PublicOfficial,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(for(relies(CE,
				     oral(statement(authority(PublicOfficial,
							      receives(PublicOfficial,
								       CE,
								       PHI))))),
			      verifies(CE,
				       authority(PublicOfficial,
						 receives(PublicOfficial,CE,PHI))))),
		      _),
		'164.514(h)(2)(iii)(A)')) :-
	about(PHI,Individual),
	wm(s164_514h2iiiA(CE,PublicOfficial,PHI)).

s164_514h2iiiB(CE,PublicOfficial,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	subpoenas(PublicOfficial,
		  CE,
		  PHI),
	add_to_wm(s164_514h2iiiB(CE,PublicOfficial,PHI)).
privilege(CE,
	  for(relies(CE,
		     subpoenas(PublicOfficial,CE,PHI)),
	      verifies(CE,
		       authority(PublicOfficial,
				 receives(PublicOfficial,CE,PHI)))),
	  '164.514(h)(2)(iii)(B)') :-
	wm(s164_514h2iiiB(CE,PublicOfficial,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(for(relies(CE,
				     subpoenas(PublicOfficial,CE,PHI)),
			      verifies(CE,
				       authority(PublicOfficial,
						 receives(PublicOfficial,CE,PHI))))),
		      _),
		'164.514(h)(2)(iii)(B)')) :-
	about(PHI,Individual),
	wm(s164_514h2iiiB(CE,PublicOfficial,PHI)).

% TODO cross reference to 164.510 and 164.512(j)

% eof







