% Models section 164.514 of the HIPAA Privacy Rule

:- dynamic s164_520a2_exception/0,
	s164_520a3_exception/0.

s164_520_notice(CE, PHI, uses(CE,PHI)).
s164_520_notice(CE, PHI, discloses(CE,_,PHI)).
% TODO: these two throw the engine in infinite loops
%s164_520_notice(CE, PHI, right(Individual,CE,_,_)) :-
%	about(PHI,Individual).
%s164_520_notice(CE, _, obligation(CE,_,_)).

s164_520a1(CE,Individual,Contents,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	about(PHI,Individual),
	s164_520_notice(CE,PHI,Contents),
	not(s164_520a2_exception(CE,Individual,Contents,PHI)),
	not(s164_520a3_exception),
	add_to_wm(s164_520a1(CE,Individual,Contents,PHI)).
s164_520a2_exception(CE,Individual,Contents,PHI) :-
	s164_520a2iA(CE,HIIorHMO,Individual,Contents,PHI) ;
	s164_520a2iB(CE,HIIorHMO,Individual,Contents,PHI) ;
	s164_520a2ii(CE,HIIorHMO,Individual,Contents,PHI) ;
	s164_520a2iii(CE,HIIorHMO,Individual,Contents,PHI) ;
	s164_520a3(CE,Contents,PHI).
right(Individual,
      adequate(notice(Contents)),
      '164.520(a)(1)') :-
	wm(s164_520a1(CE,Individual,Contents,PHI)).
implied(obligation(CE,
		   maintains(CE,
			     notice(Contents)),
		   '164.520(a)(1)')) :-
	wm(s164_520a1(CE,Individual,Contents,PHI)).

s164_520a2iA(GHP,HIIorHMO,Individual,Contents,PHI) :-
	isGroupHealthPlan(GHP),
	isPHI(PHI),
	about(PHI,Individual),
	s164_520_notice(GHP,PHI,Contents),
	not(through(receives(Individual,
			     HIIorHMO,
			     healthBenefits(HIIorHMO)),
		    insuranceContract(GHP,HIIorHMO))),
	isHealthInsuranceIssuerOrHMO(HIIorHMO),
	add_to_wm(s164_520a2iA(GHP,HIIorHMO,Individual,Contents,PHI)).
right(Individual,
      notice(Contents),
      '164.520(a)(2)(i)(A)') :-
	wm(s164_520a2iA(GHP,HIIorHMO,Individual,Contents,PHI)).
implied(obligation(GHP,
		   maintains(GHP,
			     notice(Contents)),
		   '164.520(a)(2)(i)(A)')) :-
	wm(s164_520a2iA(GHP,HIIorHMO,Individual,Contents,PHI)).

s164_520a2iB(GHP,HIIorHMO,Individual,Contents,PHI) :-
	isPHI(PHI),
	isHealthInsuranceIssuerOrHMO(HIIorHMO),
	about(PHI,Individual),
	s164_520_notice(GHP,PHI,Contents),
	under(receives(Individual,
		       HIIorHMO,
		       healthBenefits(HIIorHMO)),
	      GHP),
	isGroupHealthPlan(GHP),
	add_to_wm(s164_520a2iB(GHP,HIIorHMO,Individual,Contents,PHI)).
right(Individual,
      notice(Contents),
      '164.520(a)(2)(i)(B)') :-
	wm(s164_520a2iB(GHP,HIIorHMO,Individual,Contents,PHI)).
implied(obligation(HIIorHMO,
		   maintains(HIIorHMO,
			     notice(Contents)),
		   '164.520(a)(2)(i)(B)')) :-
	wm(s164_520a2iB(GHP,HIIorHMO,Individual,Contents,PHI)).

s164_520a2ii(GHP,HIIorHMO,Individual,Contents,PHI) :-
	isGroupHealthPlan(GHP),
	isPHI(PHI),
	s164_520_notice(GHP,PHI,Contents),
	solely(through(provides(GHP,
				Individual,
				healthBenefits(GHP)),
		       insuranceContract(GHP,HIIorHMO))),
	isHealthInsuranceIssuerOrHMO(HIIorHMO),
	createsOrReceives(GHP,
			  _,
			  PHI),
	is_s164_520aii_info(GHP,HIIorHMO,PHI),
	add_to_wm(s164_520a2ii(GHP,HIIorHMO,Individual,Contents,PHI)).
createsOrReceives(GHP,_,PHI) :-
	creates(GHP,PHI).
createsOrReceives(GHP,ThirdParty,PHI) :-
	receives(GHP,ThirdParty,PHI).
is_s164_520aii_info(_,_,PHI) :-
	not(summary(PHI)).
is_s164_520aii_info(GHP,_,PHI) :-
	about(PHI,
	      Individual),
	on(PHI,
	   participates(Individual,
			GHP)).
is_s164_520aii_info(GHP,HIIorHMO,PHI) :-
	about(PHI,
	      Individual),
	on(PHI,
	   enrolled(Individual,
		    HIIorHMO)),
	by(offers(GHP,
		  Individual,
		  HIIorHMO),
	   GHP).
is_s164_520aii_info(GHP,HIIorHMO,PHI) :-
	about(PHI,
	      Individual),
	on(PHI,
	   disenrolled(Individual,
		    HIIorHMO)),
	by(offers(GHP,
		  Individual,
		  HIIorHMO),
	   GHP).
obligation(GHP,
	   maintains(GHP,
		     notice(Contents)),
	   '164.520(a)(2)(ii)(A)') :-
	wm(s164_520a2ii(GHP,HIIorHMO,Individual,Contents,PHI)).
implied(right(Individual,
	      notice(Contents),
	      '164.520(a)(ii)(A)')) :-
	wm(s164_520a2ii(GHP,HIIorHMO,Individual,Contents,PHI)).
obligation(GHP,
	   provides(GHP,
		    Individual,
		    notice(Contents)),
	   '164.520(a)(2)(ii)(B)') :-
	wm(s164_520a2ii(GHP,HIIorHMO,Individual,Contents,PHI)).

s164_520a2iii(GHP,HIIorHMO,Individual,Contents,PHI) :-
	maintains(GHP,PHI),
	isGroupHealthPlan(GHP),
	isPHI(PHI),
	s164_520_notice(GHP,PHI,Contents),
	solely(through(provides(GHP,
				Individual,
				healthBenefits(GHP)),
		       insuranceContract(GHP,HIIorHMO))),
	isHealthInsuranceIssuerOrHMO(HIIorHMO),
	not(createsOrReceives(GHP,
			      _,
			      PHI)),
	is_s164_520aii_info(GHP,HIIorHMO,PHI),
	add_to_wm(s164_520a2iii(GHP,HIIorHMO,Individual,Contents,PHI)).
privilege(GHP,
	  not(maintains(GHP,
			notice(Contents))),
	  '164.520(a)(2)(iii)') :-
	wm(s164_520a2iii(GHP,HIIorHMO,Individual,Contents,PHI)).
implied(noRight(Individual,
		right(Individual,
		      notice(Contents),
		      _),
	        '164.520(a)(2)(iii)')) :-
	wm(s164_520a2iii(GHP,HIIorHMO,Individual,Contents,PHI)).

s164_520a3(CorrectionalInstitution,Contents,PHI) :-
	isPHI(PHI),
	isCorrectionalInstitution(CorrectionalInstitution),
	s164_520_notice(CorrectionalInstitution,PHI,Contents),
	add_to_wm(s164_520a3(CorrectionalInstitution,Contents,PHI)).
privilege(CorrectionalInstitution,
	  not(maintains(CorrectionalInstitution,
			notice(Contents))),
	  '164.520(a)(3)') :-
	wm(s164_520a3(CorrectionalInstitution,Contents,PHI)).
noRight(Individual,
	right(Individual,
	      notice(Contents),
	      _),
	'164.520(a)(3)') :-
	isInmate(Individual),
	about(PHI,Individual),
	s164_520_notice(_,PHI,Contents).

obligation(CE,
	   inPlainLanguage(notice(_)),
	   '164.520(b)(1)') :-
	isCoveredEntity(CE).
implied(right(Individual,
	      inPlainLanguage(notice(_)),
	      '164.520(b)(1)')) :-
	isCoveredEntity(CE).
obligation(CE,
	   contains(notice(_),
		    Contents),
	   '164.520(b)(1)') :-
	isCoveredEntity(CE),
	is164_520b1_noticeContents(CE,Contents,_).
implied(right(Individual,
	      notice(Contents),
	      '164.520(b)(1)')) :-
	isCoveredEntity(CE),
	is164_520b1_noticeContents(CE,Contents,_).

is164_520b1_noticeContents(_,
			   'THIS NOTICE DESCRIBES HOW MEDICAL INFORMATION ABOUT YOU MAY BE USED AND DISCLOSED AND HOW YOU CAN GET ACCESS TO THIS INFORMATION. PLEASE REVIEW IT CAREFULLY',
			   '164.520(b)(1)(i)').
is164_520b1_noticeContents(_,
			   'A description, including at least one example, of the types of uses and disclosures that the covered entity is permitted by this subpart to make for each of the following purposes: treatment, payment, and health care operations.',
			  '164.520(b)(1)(ii)(A)').
is164_520b1_noticeContents(_,
			   'A description of each of the other purposes for which the covered entity is permitted or required by this subpart to use or disclose protected health information without the individual\'s written authorization.',
			   '164.520(b)(1)(ii)(B)').
is164_520b1_noticeContents(_,
			   'If a use or disclosure for any purpose described in paragraphs (b)(1)(ii)(A) or (B) of this section is prohibited or materially limited by other applicable law, the description of such use or disclosure must reflect the more stringent law as defined in 160.202 of this subchapter.',
			  '164.520(b)(1)(ii)(C)').

s164_520b1iiD(CE,Individual,UsageOrDisclosure,Contents,PHI) :-
	isCoveredEntity(CE),
	isUsageOrDisclosure(CE,_,PHI,UsageOrDisclosure),
	isPHI(PHI),
	about(PHI,Individual),
	is164_520b1_noticeContents(CE,
				   Contents,
				   '164.520(b)(1)(ii)(A)'),
	add_to_wm(s164_520b1iiD(CE,Individual,UsageOrDisclosure,Contents,PHI)).
obligation(CE,
	   includesSufficientDetail(for(description(Contents),
					notifies(CE,
						 Individual,
						 UsageOrDisclosure))),
	   '164.520(b)(1)(ii)(D)') :-
	wm(s164_520b1iiD(CE,Individual,UsageOrDisclosure,Contents,PHI)).
implied(right(Individual,
	      notifies(CE,
		       Individual,
		       UsageOrDisclosure),
	      '164.520(b)(1)(ii)(D)')) :-
	wm(s164_520b1iiD(CE,Individual,UsageOrDisclosure,_,PHI)).

is164_520b1_noticeContents(_,
			   'A statement that other uses and disclosures will be made only with the individual\'s written authorization and that the individual may revoke such authorization as provided by 164.508(b)(5).',
			  '164.520(b)(1)(ii)(E)').

s164_520b1iii(CE,Activity,Statement,Source) :-
	isCoveredEntity(CE),
	intends(CE, Activity),
	is164_520b1iii_activity(CE, Activity, Source),
	is164_520b1iii_statement(CE, Statement, Source),
	add_to_wm(s164_520b1iii(CE,Activity,Statement,Source)).
obligation(CE,
	   includes(is164_520b1_noticeContents(CE,
					       _,
					       '164.520(b)(1)(ii)(A)'),
		    Statement),
	   '164.520(b)(1)(iii)') :-
	wm(s164_520b1iii(CE,Activity,Statement,Source)).
implied(right(Individual,
	      notifies(CE,
		       Individual,
		       Activity),
	      '164.520(b)(1)(iii)')) :-
	wm(s164_520b1iii(CE,Activity,Statement,Source)).

privilege(CE,
	  to(contacts(CE,
		      Individual),
	     provides(CE,
		      Individual,
		      Info)),
	  '164.520(b)(1)(iii)(A)') :-
	isCoveredEntity(CE),
	is_s164_520b1iiiA_info(CE, Info).
implied(noRight(Individual,
		right(Individual,
		      not(to(contacts(CE,
				      Individual),
			     provides(CE,
				      Individual,
				      Info))),
		      _),
		'164.520(b)(1)(iii)(A)')) :-
	isCoveredEntity(CE),
	is_s164_520b1iiiA_info(CE, Info).
is164_520b1iii_activity(CE,
			to(contacts(CE,
				    Individual),
			   provides(CE,
				    Individual,
				    Info)),
		        '164.520(b)(1)(iii)(A)') :-
	is_s164_520b1iiiA_info(CE,Info).
is_s164_520b1iiiA_info(_, appointmentReminders).
is_s164_520b1iiiA_info(CE, information(alternative(treatment(CE)))).
is_s164_520b1iiiA_info(CE, healthBenefits(CE)).
is164_520b1iii_statement(_,
			 'The covered entity may contact the individual to provide appointment reminders or information about treatment alternatives or other health-related benefits and services that may be of interest to the individual;',
			 '164.520(b)(1)(iii)(A)').

privilege(CE,
	  to(contact(CE,
		     Individual),
	     fundraising(CE)),
	  '164.520(b)(1)(iii)(B)') :-
	isCoveredEntity(CE).
implied(noRight(Individual,
		right(Individual,
		      not(to(contact(CE,
				     Individual),
			     fundraising(CE))),
		      _),
	'164.520(b)(1)(iii)(B)')) :-
	isCoveredEntity(CE).
is164_520b1iii_activity(CE,
			to(contact(CE,
				   Individual),
			   fundraising(CE)),
			'164.520(b)(1)(iii)(B)').
is164_520b1iii_statement(_,
			 'The covered entity may contact the individual to raise funds for the covered entity',
			 '164.520(b)(1)(iii)(B)').

s164_520b1iiiC(GHPorHIIorHMO,Sponsor,PHI) :-
	isGHPorHIIorHMO(GHPorHIIorHMO),
	isPHI(PHI),
	isPlanSponsor(Sponsor,GHPorHIIorHMO),
	add_to_wm(s164_520b1iiiC(GHPorHIIorHMO,Sponsor,PHI)).
privilege(GHPorHIIorHMO,
	  discloses(GHPorHIIorHMO,
		    Sponsor,
		    PHI),
	  '164.520(b)(1)(iii)(C)') :-
	wm(s164_520b1iiiC(GHPorHIIorHMO,Sponsor,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(discloses(GHPorHIIorHMO,
				    Sponsor,
				    PHI)),
		      _),
		'164.520(b)(1)(iii)(C)')) :-
	about(PHI,Individual),
	wm(s164_520b1iiiC(GHPorHIIorHMO,Sponsor,PHI)).
is164_520b1iii_activity(GHPorHIIorHMO,
			discloses(CE,
				  Sponsor,
				  PHI),
			'164.520(b)(1)(iii)(C)') :-
	wm(s164_520b1iiiC(GHPorHIIorHMO,Sponsor,PHI)).
is164_520b1iii_statement(_,
			 'A group health plan, or a health insurance issuer or HMO with respect to a group health plan, may disclose protected health information to the sponsor of the plan',
			 '164.520(b)(1)(iii)(C)').

is164_520b1_noticeContents(_,
			   'The notice must contain a statement of the individual\'s rights with respect to protected health information and a brief description of how the individual may exercise these rights',
			   '164.520(b)(1)(iv)').
is164_520b1_noticeContents(_,
			   'a brief description of how the individual may exercise these rights, as follows: The right to request restrictions on certain uses and disclosures of protected health information as provided by 164.522(a), including a statement that the covered entity is not required to agree to a requested restriction',
			   '164.520(b)(1)(iv)(A)').
is164_520b1_noticeContents(_,
			   'a brief description of how the individual may exercise these rights, as follows: The right to receive confidential communications of protected health information as provided by 164.522(b), as applicable',
			   '164.520(b)(1)(iv)(B)').
is164_520b1_noticeContents(_,
			   'a brief description of how the individual may exercise these rights, as follows: The right to inspect and copy protected health information as provided by 164.524',
			   '164.520(b)(1)(iv)(C)').
is164_520b1_noticeContents(_,
			   'a brief description of how the individual may exercise these rights, as follows: The right to amend protected health information as provided by 164.526',
			   '164.520(b)(1)(iv)(D)').
is164_520b1_noticeContents(_,
			   'a brief description of how the individual may exercise these rights, as follows: The right to receive an accounting of disclosures of protected health information as provided by 164.528',
			   '164.520(b)(1)(iv)(E)').
is164_520b1_noticeContents(_,
			   'a brief description of how the individual may exercise these rights, as follows: The right of an individual, including an individual who has agreed to receive the notice electronically in accordance with paragraph (c)(3) of this section, to obtain a paper copy of the notice from the covered entity upon request.',
			   '164.520(b)(1)(iv)(F)').
is164_520b1_noticeContents(_,
			   'A statement that the covered entity is required by law to maintain the privacy of protected health information and to provide individuals with notice of its legal duties and privacy practices with respect to protected health information',
			   '164.520(b)(1)(v)(A)').
is164_520b1_noticeContents(_,
			   'A statement that the covered entity is required to abide by the terms of the notice currently in effect',
			   '164.520(b)(1)(v)(B)').
is164_520b1_noticeContents(_,
			   'For the covered entity to apply a change in a privacy practice that is described in the notice to protected health information that the covered entity created or received prior to issuing a revised notice, in accordance with 164.530(i)(2)(ii), a statement that it reserves the right to change the terms of its notice and to make the new notice provisions effective for all protected health information that it maintains. The statement must also describe how it will provide individuals with a revised notice.',
			   '164.520(b)(1)(v)(C)').
is164_520b1_noticeContents(_,
			   'The notice must contain a statement that individuals may complain to the covered entity and to the Secretary if they believe their privacy rights have been violated, a brief description of how the individual may file a complaint with the covered entity, and a statement that the individual will not be retaliated against for filing a complaint.',
			   '164.520(b)(1)(vi)').
is164_520b1_noticeContents(_,
			   'The notice must contain the name, or title, and telephone number of a person or office to contact for further information as required by 164.530(a)(1)(ii).',
			   '164.520(b)(1)(vii)').
is164_520b1_noticeContents(_,
			   'The notice must contain the date on which the notice is first in effect, which may not be earlier than the date on which the notice is printed or otherwise published.',
			   '164.520(b)(1)(viii)').

s164_520b2i_privilege(CE,UsageOrDisclosure,PHI) :-
	isCoveredEntity(CE),
	isUsageOrDisclosure(CE,_,PHI,UsageOrDisclosure),
	isPHI(PHI),
	limits(CE,
	       UsageOrDisclosure),
	add_to_wm(s164_520b2i_privilege(CE,UsageOrDisclosure,PHI)).
privilege(CE,
	  in(describes(CE,
		       limits(CE,
			      UsageOrDisclosure)),
	     notice(_)),
	  '164.520(b)(2)(i)') :-
	wm(s164_520b2i_privilege(CE,UsageOrDisclosure,PHI)).
implied(noRight(Individual,
		right(Individual,
		      in(describes(CE,
				   limits(CE,
					  UsageOrDisclosure)),
			 notice(_)),
		      _),
		'164.520(b)(2)(i)')) :-
	wm(s164_520b2i_privilege(CE,UsageOrDisclosure,PHI)).

s164_520b2i_obligation(CE,UsageOrDisclosure,PHI) :-
	isCoveredEntity(CE),
	isUsageOrDisclosure(CE,_,PHI,UsageOrDisclosure),
	isPHI(PHI),
	affects(limits(CE,
		       UsageOrDisclosure),
		Disclosure),
	required_by_law_or_164_512j1i(CE,PHI,Disclosure),
	add_to_wm(s164_520b2i_obligation(CE,UsageOrDisclosure,PHI)).
required_by_law_or_164_512j1i(CE,PHI,Disclosure) :-
	required_by_law(CE,Disclosure,_).
required_by_law_or_164_512j1i(CE,PHI,Disclosure) :-
	privilege(CE,Disclosure,'164.512(j)(1)(i)').
obligation(CE,
	   not(in(describes(CE,
			    limits(CE,
				   UsageOrDisclosure)),
		  notice(_))),
	   '164.520(b)(2)(i)') :-
	wm(s164_520b2i_obligation(CE,UsageOrDisclosure,PHI)).
% TODO add implied right

s164_520b3(CE,RevisesOrDistributes,ThirdParty,Activity) :-
	isCoveredEntity(CE),
	revisesOrDistributes(CE,Activity,ThirdParty,RevisesOrDistributes),
	makesMaterialChange(CE,notice(Activity),Activity),
	add_to_wm(s164_520b3(CE,RevisesOrDistributes,ThirdParty,Activity)).
obligation(CE,
	   promptly(RevisesOrDistributes),
	   '164.520(b)(3)') :-
	wm(s164_520b3(CE,RevisesOrDistributes,ThirdParty,Activity)).
implied(right(Individual,
	      receives(Individual,
		       CE,
		       notice(Activity)),
	      '164.520(b)(3)')) :-
	wm(s164_520b3(CE,RevisesOrDistributes,ThirdParty,Activity)).       
revisesOrDistributes(CE,Activity,_,revises(CE,
					   notice(Activity))).
revisesOrDistributes(CE,Activity,Individual,distributes(CE,
							Individual,
							notice(Activity))).
makesMaterialChange(CE,notice(uses(CE,PHI)),uses(CE,PHI)) :-
	isPHI(PHI).
makesMaterialChange(CE,notice(discloses(CE,_,PHI)),discloses(CE,_,PHI)) :-
	isPHI(PHI).
makesMaterialChange(_,notice(right(_,_,_)),right(_,_,_)).
makesMaterialChange(CE,notice(obligation(CE,_,_)),obligation(CE,_,_)).
%makesMaterialChange(_,notice(Activity),notice(Activity)).

obligation(CE,
	   not(before(makesMaterialChange(CE,notice(Activity),Activity),
		      effectiveDate(notice(Activity)))),
	   '164.520(b)(3)') :-
	isCoveredEntity(CE),
	not(required_by_law(CE,
			    makesMaterialChange(CE,notice(Activity),Activity),
			    _)).
implied(right(Individual,
	      before(makesMaterialChange(CE,notice(Activity),Activity),
		     receives(Individual,
			      CE,
			      notice(Activity))),
	      '164.520(b)(3)')) :-
	isCoveredEntity(CE),
	not(required_by_law(CE,
			    makesMaterialChange(CE,notice(Activity),Activity),
			    _)).
privilege(CE,
	  before(makesMaterialChange(CE,notice(Activity),Activity),
		 effectiveDate(notice(Activity))),
	  '164.520(b)(3)') :-
	isCoveredEntity(CE),
	required_by_law(CE,
			makesMaterialChange(CE,notice(Activity),Activity),
			_).
implied(noRight(Individual,
		right(Individual,
		      before(makesMaterialChange(CE,notice(Activity),Activity),
			     receives(Individual,
				      CE,
				      notice(Activity))),
		      _),
		'164.520(b)(3)')) :-
	isCoveredEntity(CE),
	required_by_law(CE,
			makesMaterialChange(CE,notice(Activity),Activity),
			_).

s164_520c1iA(HealthPlan,Individual) :-
	isHealthPlan(HealthPlan),
	at(coveredUnder(Individual,
			HealthPlan),
	   complianceDate(HealthPlan)),
	add_to_wm(s164_520c1iA(HealthPlan,Individual)).
obligation(HealthPlan,
	   noLaterThan(provides(HealthPlan,
				Individual,
				notice(_)),
		       complianceDate(HealthPlan)),
	   '164.520(c)(1)(i)(A)') :-
	wm(s164_520c1iA(HealthPlan,Individual)).
implied(right(Individual,
	      noLaterThan(provides(HealthPlan,
				   Individual,
				   notice(_)),
			  complianceDate(HealthPlan)),
	      '164.520(c)(1)(i)(A)')) :-
	wm(s164_520c1iA(HealthPlan,Individual)).

s164_520c1iB(HealthPlan,Individual) :-
	isHealthPlan(HealthPlan),
	add_to_wm(s164_520c1iB(HealthPlan,Individual)).
obligation(HealthPlan,
	   at(date(enrolled(Individual,HealthPlan)),
	      provides(HealthPlan,
		       Individual,
		       notice(_))),
	   '164.520(c)(1)(i)(B)') :-
	wm(s164_520c1iB(HealthPlan,Individual)).
implied(right(Individual,
	      at(date(enrolled(Individual,HealthPlan)),
		 provides(HealthPlan,
			  Individual,
			  notice(_))),
	      '164.520(c)(1)(i)(B)')) :-
	wm(s164_520c1iB(HealthPlan,Individual)).

s164_520c1iC(HealthPlan,Individual,notice(Activity),Activity) :-
	isHealthPlan(HealthPlan),
	makesMaterialChange(HealthPlan,
			    notice(Activity),
			    Activity),
	add_to_wm(s164_520c1iC(HealthPlan,Individual,notice(Activity),Activity)).
obligation(HealthPlan,
	   within(provides(HealthPlan,
			   Individual,
			   notice(_)),
		  of(day(60),
		     makesMaterialChange(HealthPlan,
					 notice(Activity),
					 Activity))),
	   '164.520(c)(1)(i)(C)') :-
	wm(s164_520c1iC(HealthPlan,Individual,notice(Activity),Activity)).
implied(right(Individual,
	      within(provides(HealthPlan,
			      Individual,
			      notice(_)),
		     of(day(60),
			makesMaterialChange(HealthPlan,
					    notice(Activity),
					    Activity))),
	      '164.520(c)(1)(i)(C)')) :-
	wm(s164_520c1iC(HealthPlan,Individual,notice(Activity),Activity)).

s164_520c1ii(HealthPlan,Individual) :-
	isHealthPlan(HealthPlan),
	coveredUnder(Individual,HealthPlan),
	add_to_wm(s164_520c1ii(HealthPlan,Individual)).
obligation(HealthPlan,
	   noLessFrequently(occursOnce(year(3)),
			    notifies(HealthPlan,
				     Individual,
				     availability(notice(_)))),
	   '164.520(c)(1)(ii)') :-
	wm(s164_520c1ii(HealthPlan,Individual)).
implied(right(Individual,
	      noLessFrequently(occursOnce(year(3)),
		      notifies(HealthPlan,
			       Individual,
			       availability(notice(_)))),
     '164.520(c)(1)(ii)')) :-
	wm(s164_520c1ii(HealthPlan,Individual)).

satisfies(HealthPlan,
	  '164.520(c)(1)') :-
	provides(HealthPlan,
		 Individual,
		 notice(_)),
	isNamedInsured(Individual).
	  
satisfies(HealthPlan,
	  '164.520(c)(1)') :-
	provides(HealthPlan,
		 Individual,
		 notice(_)),
	relavent(notice(_),
		 Individual),
	hasMoreThanOne(HealthPlan,
		       notice(_)).

s164_520c2iA(CHCP,Individual) :-
	isHealthcareProvider(CHCP),
	after(treats(CHCP,
		     Individual),
	      complianceDate(CHCP)),
	inDirectTreatmentRelationship(Individual,CHCP),
	add_to_wm(s164_520c2iA(CHCP,Individual)).
obligation(CHCP,
	   noLaterThan(provides(CHCP,
				Individual,
				notice(_)),
		       date(treats(CHCP,Individual))),
	   '164.520(c)(2)(i)(A)') :-
	wm(s164_520c2iA(CHCP,Individual)).
implied(right(Individual,
	      noLaterThan(provides(CHCP,
				   Individual,
				   notice(_)),
			  date(treats(CHCP,Individual))),
	      '164.520(c)(2)(i)(A)')) :-
	wm(s164_520c2iA(CHCP,Individual)).

s164_520c2iB(CHCP,Individual) :-
	isHealthcareProvider(CHCP),
	isInEmergency(Individual),
	add_to_wm(s164_520c2iB(CHCP,Individual)).
obligation(CHCP,
	   reasonable(practicable(after(provides(CHCP,
						 Individual,
						 notice(_)),
					treats(CHCP,
					       Individual)))),
	   '164.520(c)(2)(i)(B)') :-
	wm(s164_520c2iB(CHCP,Individual)).
implied(right(Individual,
	      reasonable(practicable(after(provides(CHCP,
						    Individual,
						    notice(_)),
					   treats(CHCP,
						  Individual)))),
	      '164.520(c)(2)(i)(B)')) :-
	wm(s164_520c2iB(CHCP,Individual)).

s164_520c2ii(CHCP,Individual) :-
	isHealthcareProvider(CHCP),
	not(isInEmergency(Individual)),
	add_to_wm(s164_520c2ii(CHCP,Individual)).
obligation(CHCP,
	   goodFaith(makesEfforts(CHCP,
				  obtains(CHCP,
					  written(acknowledges(Individual,
							       receives(Individual,
									CHCP,
									notice(_))))))),
	   '164.520(c)(2)(ii)') :-
	wm(s164_520c2ii(CHCP,Individual)).
implied(right(Individual,
	      goodFaith(makesEfforts(CHCP,
				     obtains(CHCP,
					     written(acknowledges(Individual,
								  receives(Individual,
									   CHCP,
									   notice(_))))))),
	      '164.520(c)(2)(ii)')) :-
	wm(s164_520c2ii(CHCP,Individual)).

obligation(CHCP,
	   documents(CHCP,
		     goodFaith(makesEfforts(CHCP,
					    obtains(CHCP,
						    written(acknowledges(Individual,
									 receives(Individual,
										  CHCP,
										  notice(_)))))))),
	   '164.520(c)(2)(ii)') :-
	wm(s164_520c2ii(CHCP,Individual)),
	not(obtains(CHCP,
		    written(acknowledges(Individual,
					 receives(Individual,
						  CHCP,
						  notice(_)))))).
% TODO what is the implied right?

obligation(CHCP,
	   documents(CHCP,
		     reasonsFor(not(obtains(CHCP,
					    written(acknowledges(Individual,
								 receives(Individual,
									  CHCP,
									  notice(_)))))))),
	   '164.520(c)(2)(ii)') :-
	wm(s164_520c2ii(CHCP,Individual)),
	not(obtains(CHCP,
		    written(acknowledges(Individual,
					 receives(Individual,
						  CHCP,
						  notice(_)))))).
% TODO what is the implied right?

s164_520c2iiiA(CHCP,Individual) :-
	isHealthcareProvider(CHCP),
	maintains(CHCP,
		  physical(serviceDeliverySite(CHCP))),
	add_to_wm(s164_520c2iiiA(CHCP,Individual)).
obligation(CHCP,
	   available(notice(_),
		     Individual),
	   '164.520(c)(2)(iii)(A)') :-
	wm(s164_520c2iiiA(CHCP,Individual)).
implied(right(Individual,
	      available(notice(_),
			Individual),
	      '164.520(c)(2)(iii)(A)')) :-
	wm(s164_520c2iiiA(CHCP,Individual)).

s164_520c2iiiB(CHCP,Individual) :-
	isHealthcareProvider(CHCP),
	maintains(CHCP,
		  physical(serviceDeliverySite(CHCP))),
	reasonable(expects(CHCP,
			   able(Individual,
				reads(Individual,
				      notice(_))))),
	add_to_wm(s164_520c2iiiB(CHCP,Individual)).
obligation(CHCP,
	   in(posts(CHCP,
		    notice(_)),
	      clear(location)),
	   '164.520(c)(2)(iii)(B)') :-
	wm(s164_520c2iiiB(CHCP,Individual)).
obligation(CHCP,
	   in(posts(CHCP,
		    notice(_)),
	      prominent(location)),
	   '164.520(c)(2)(iii)(B)') :-
	wm(s164_520c2iiiB(CHCP,Individual)).
implied(right(Individual,
	      in(posts(CHCP,
		       notice(_)),
		 clear(location)),
	      '164.520(c)(2)(iii)(B)')) :-
	wm(s164_520c2iiiB(CHCP,Individual)).
implied(right(Individual,
	      in(posts(CHCP,
		       notice(_)),
		 prominent(location)),
	      '164.520(c)(2)(iii)(B)')) :-
	wm(s164_520c2iiiB(CHCP,Individual)).

s164_520c2iv(CHCP,Individual) :-
	isHealthcareProvider(CHCP),
	revises(CHCP,
		notice(_)),
	onOrAfter(makes(CHCP,
			available(notice(_),
				  Individual)),
		  effectiveDate(notice(_))),
	add_to_wm(s164_520c2iv(CHCP,Individual)).
% [IGNORE_PRECONDITIONS]
onOrAfter(X,Y) :-
	on(X,Y).
% [IGNORE_PRECONDITIONS]
onOrAfter(X,Y) :-
	after(X,Y).
obligation(CHCP,
     upon(makes(CHCP,
		available(notice(_),
			  Individual)),
	  requests(Individual,
		   CHCP,
		   notice(_))),
     '164.520(c)(2)(iv)') :-
	wm(s164_520c2iv(CHCP,Individual)).
implied(right(Individual,
	      upon(makes(CHCP,
		available(notice(_),
			  Individual)),
	  requests(Individual,
		   CHCP,
		   notice(_))),
     '164.520(c)(2)(iv)')) :-
	wm(s164_520c2iv(CHCP,Individual)).

% TODO: throws the inference engine in an infinite loop
%obligation(CHCP,
%	   promptly(complies(CHCP,
%			    Requirement)),
%	   '164.520(c)(2)(iv)') :-
%	obligation(CHCP,
%	     Requirement,
%	     Source),
%	isSubsectionOf(Source,'164.520(c)(2)(iv)'),
%	wm(s164_520c2iv(CHCP,Individual)).
implied(right(Individual,
	       promptly(complies(CHCP,
				Requirement)),
	      '164.520(c)(2)(iv)')) :-
	obligation(CHCP,
	     Requirement,
	     Source),
	isSubsectionOf(Source,'164.520(c)(2)(iv)'),
	wm(s164_520c2iv(CHCP,Individual)).

s164_520c3i(CE,Individual,ServicesOrBenefits) :-
	isCoveredEntity(CE),
	maintains(CE,
		  website(CE)),
	provides(CE,
		 Individual,
		 information(ServicesOrBenefits)),
	isServicesOrBenefits(CE,Individual,ServicesOrBenefits),
	add_to_wm(s164_520c3i(CE,Individual,ServicesOrBenefits)).
isServicesOrBenefits(CE,Individual,services(CE,Individual)).
isServicesOrBenefits(CE,_,healthBenefits(CE)).
obligation(CE,
	   prominent(on(posts(CE,
			      notice(_)),
			website(CE))),
	   '164.520(c)(3)(i)') :-
	wm(s164_520c3i(CE,Individual,ServicesOrBenefits)).
obligation(CE,
	   makes(CE,
		 available(Individual,
			   electronic(notice(_)))),
	   '164.520(c)(3)(i)') :-
	wm(s164_520c3i(CE,Individual,ServicesOrBenefits)).
implied(right(Individual,
	      through(receives(Individual,
			       CE,
			       notice(_)),
		      website(CE)),
	      '164.520(c)(3)(i)')) :-
	wm(s164_520c3i(CE,Individual,ServicesOrBenefits)).

s164_520c3ii(CE,Individual) :-
	isCoveredEntity(CE),
	agrees(Individual,
	       by(provides(CE,
			   Individual,
			   notice(_)),
		  email)),
	not(withdraws(Individual,
		      agrees(Individual,
			     by(provides(CE,
					 Individual,
					 notice(_)),
				email)))),
	add_to_wm(s164_520c3ii(CE,Individual)).
privilege(CE,
	  by(provides(CE,
		      Individual,
		      notice(_)),
	     email),
	  '164.520(c)(3)(ii)') :-
	wm(s164_520c3ii(CE,Individual)).
implied(noRight(Individual,
		right(Individual,
		      not(by(provides(CE,
				      Individual,
				      notice(_)),
			     email)),
		      _),
		'164.520(c)(3)(ii)')) :-
	wm(s164_520c3ii(CE,Individual)).

s164_520c3ii_failedEmail(CE,Individual) :-
	isCoveredEntity(CE),
	knows(CE,
	      fails(by(provides(CE,
				Individual,
				notice(_)),
		       email))),
	add_to_wm(s164_520c3ii_failedEmail(CE,Individual)).
obligation(CE,
	   provides(CE,
		    Individual,
		    paper(notice(_))),
	   '164.520(c)(3)(ii)') :-
	wm(s164_520c3ii_failedEmail(CE,Individual)).
implied(right(Individual,
	      provides(CE,
		       Individual,
		       paper(notice(_))),
	      '164.520(c)(3)(ii)')) :-
	wm(s164_520c3ii_failedEmail(CE,Individual)).

satisfies(CE,
	  '164.520(c)(3)(ii)') :-
	isCoveredEntity(CE),
	by(provides(CE,
		    Individual,
		    notice(_)),
	   email).

s164_520c3iii(CHCP,Individual) :-
	isHealthcareProvider(CHCP),
	electronic(firstServiceDelivery),
	add_to_wm(s164_520c3iii(CHCP,Individual)).
obligation(CHCP,
	   contemporaneously(provides(CHCP,
				      Individual,
				      electronic(notice(_)))),
	   '164.520(c)(iii)') :-
	wm(s164_520c3iii(CHCP,Individual)).
obligation(CHCP,
	   automatically(provides(CHCP,
				  Individual,
				  electronic(notice(_)))),
	   '164.520(c)(iii)') :-
	wm(s164_520c3iii(CHCP,Individual)).
implied(right(Individual,
	      contemporaneously(receives(Individual,
					 CHCP,
					 electronic(notice(_)))),
	      '164.520(c)(iii)')) :-
	wm(s164_520c3iii(CHCP,Individual)).
implied(right(Individual,
	      automatically(receives(Individual,
				     CHCP,
				     electronic(notice(_)))),
	      '164.520(c)(iii)')) :-
	wm(s164_520c3iii(CHCP,Individual)).

obligation(CHCP,
	   goodFaith(makesEfforts(CHCP,
				  obtains(CHCP,
					  written(acknowledges(Individual,
							       receives(Individual,
									CHCP,
									electronic(notice(_)))))))),
	   '164.520(c)(3)(iii)') :-
	wm(s164_520c2ii(CHCP,Individual)).
implied(right(Individual,
	      goodFaith(makesEfforts(CHCP,
				     obtains(CHCP,
					     written(acknowledges(Individual,
								  receives(Individual,
									   CHCP,
									   electronic(notice(_)))))))),
	      '164.520(c)(3)(iii)')) :-
	wm(s164_520c2ii(CHCP,Individual)).

obligation(CHCP,
	   documents(CHCP,
		     goodFaith(makesEfforts(CHCP,
					    obtains(CHCP,
						    written(acknowledges(Individual,
									 receives(Individual,
										  CHCP,
										  electronic(notice(_))))))))),
	   '164.520(c)(3)(iii)') :-
	wm(s164_520c2ii(CHCP,Individual)),
	not(obtains(CHCP,
		    written(acknowledges(Individual,
					 receives(Individual,
						  CHCP,
						  electronic(notice(_))))))).
% TODO what is the implied right?

obligation(CHCP,
	   documents(CHCP,
		     reasonsFor(not(obtains(CHCP,
					    written(acknowledges(Individual,
								 receives(Individual,
									  CHCP,
									  electronic(notice(_))))))))),
	   '164.520(c)(3)(iii)') :-
	wm(s164_520c2ii(CHCP,Individual)),
	not(obtains(CHCP,
		    written(acknowledges(Individual,
					 receives(Individual,
						  CHCP,
						  notice(_)))))).
% TODO what is the implied right?

s164_520c3iv(CE,Individual) :-
	isCoveredEntity(CE),
	receives(Individual,
		 CE,
		 electronic(notice(_))),
	add_to_wm(s164_520c3iv(CE,Individual)).
right(Individual,
      upon(from(obtains(Individual,
			paper(notice(_))),
		CE),
	   requests(Individual,
		    CE,
		    paper(notice(_)))),
      '164.520(c)(iv)') :-
	wm(s164_520c3iv(CE,Individual)).
implied(obligation(CE,
		   upon(from(obtains(Individual,
				     paper(notice(_))),
			     CE),
			requests(Individual,
				 CE,
				 paper(notice(_)))),
		   '164.520(c)(iv)')) :-
	wm(s164_520c3iv(CE,Individual)).

s164_520d1_2(CE,PHI,CreatesOrReceives) :-
	isCoveredEntity(CE),
	participatesInOrganizedHealthcareArrangement(CE),
	agrees(CE,
	       abides(CE,
		      jointNotice(CreatesOrReceives))),
	createsOrReceives(CE,_,PHI,CreatesOrReceives),
	isPHI(PHI),
	add_to_wm(s164_520d1_2(CE,PHI,CreatesOrReceives)).

% TODO add meta rule for requirements in section (b) for 164.520(d)(2)(i-iii)
:- dynamic meetsRequirementsOfSection_b/2.
privilege(CE,
	  by(complies(CE,
		      '164.520'),
	     jointNotice(_)),
	  '164.520(d)') :-
	wm(s164_520d1_2(CE,PHI,CreatesOrReceives)).
implied(noRight(Individual,
		right(Individual,
		      not(receives(Individual,
				   CE,
				   jointNotice(_))),
		      _),
		'164.520(d)')) :-
	wm(s164_520d1_2(CE,PHI,CreatesOrReceives)).

s164_520e(CE,Documentation) :-
	isCoveredEntity(CE),
	is_164_520e_documentation(CE,Documentation),
	add_to_wm(s164_520e(CE,Documentation)).
is_164_520e_documentation(_,copy(notice(_))).
is_164_520e_documentation(CE,acknowledges(Individual,
					  receives(Individual,
						   CE,
						   notice(_)))).
obligation(CE,
	   by(documents(CE,
			complies(CE,
				 '164.530(j)')),
	      retains(CE,
		      Documentation)),
	   '164.520(e)') :-
	wm(s164_520e(CE,Documentation)).
% TODO what is the implied right?
obligation(CE,
	   documents(CE,Documentation),
	   '164.520(e)') :-
	wm(s164_520e(CE,Documentation)).
% TODO what is the implied right?

% eof













