% Models section 164.522 of the HIPAA Privacy Rule

s164_522a1iA(CE,Individual,TPO,UsageOrDisclosure,PHI) :-
	isCoveredEntity(CE),
	isUsageOrDisclosure(CE,_,PHI,UsageOrDisclosure),
	about(PHI,Individual),
	valid_HIPAA_TPO(TPO),
	add_to_wm(s164_522a1iA(CE,Individual,TPO,UsageOrDisclosure,PHI)).
obligation(CE,
	   permits(CE,
		   requests(Individual,
			    CE,
			    restricts(CE,
				      for(UsageOrDisclosure,
					  TPO)))),
	   '164.522(a)(1)(i)(A)') :-
	wm(s164_522a1iA(CE,Individual,TPO,UsageOrDisclosure,PHI)).
implied(right(Individual,
	      permits(CE,
		      requests(Individual,
			       CE,
			       restricts(CE,
					 for(UsageOrDisclosure,
					     TPO)))),
	      '164.522(a)(1)(i)(A)')) :-
	wm(s164_522a1iA(CE,Individual,TPO,UsageOrDisclosure,PHI)).

s164_522a1iB(CE,Individual,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	privilege(CE,discloses(CE,_,PHI),Section),
	isSubsectionOf(Section,'164.510(b)'),
	add_to_wm(s164_522a1iB(CE,Individual,PHI)).
obligation(CE,
	   permits(CE,
		   requests(Individual,
			    CE,
			    restricts(CE,
				      discloses(CE,
						_,
						PHI)))),
	   '164.522(a)(1)(i)(B)') :-
	wm(s164_522a1iB(CE,Individual,PHI)).
implied(right(Individual,
	      permits(CE,
		      requests(Individual,
			       CE,
			       restricts(CE,
					 discloses(CE,
						   _,
						   PHI)))),
	      '164.522(a)(1)(i)(B)')) :-
	wm(s164_522a1iB(CE,Individual,PHI)).

s164_522a1ii(CE,UsageOrDisclosure,Individual,PHI) :-
	isCoveredEntity(CE),
	isUsageOrDisclosure(CE,_,PHI,UsageOrDisclosure),
	isPHI(PHI),
	about(PHI,Individual),
	add_to_wm(s164_522a1ii(CE,UsageOrDisclosure,Individual,PHI)).
privilege(CE,
	  agrees(CE,
		 requests(Individual,
			  CE,
			  restricts(CE,
				    UsageOrDisclosure))),
	  '164.522(a)(1)(ii)') :-
	wm(s164_522a1ii(CE,UsageOrDisclosure,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      agrees(CE,
			     requests(Individual,
				      CE,
				      restricts(CE,
						UsageOrDisclosure))),
		      _),
		'164.522(a)(1)(ii)')) :-
	wm(s164_522a1ii(CE,UsageOrDisclosure,Individual,PHI)).

s164_522a1iii_obligation(CE,UsageOrDisclosure,UnspecifiedActor,Individual,PHI) :-
	isCoveredEntity(CE),
	isUsageOrDisclosure(CE,_,PHI,UsageOrDisclosure),
	isPHI(PHI),
	about(PHI,Individual),
	requests(Individual,
		 CE,
		 restricts(CE,UsageOrDisclosure)),
	agrees(CE,
	       requests(Individual,
			CE,
			restricts(CE,UsageOrDisclosure))),
	violates(UsageOrDisclosure,
		 restricts(CE,UsageOrDisclosure)),
	not(isInEmergency(Individual)),
	not(to(requires(UnspecifiedActor,PHI),
	       provides(UnspecifiedActor,
			Individual,
			treats(UnspecifiedActor,Individual)))),
	add_to_wm(s164_522a1iii_obligation(CE,UsageOrDisclosure,UnspecifiedActor,Individual,PHI)).
obligation(CE,
	   not(UsageOrDisclosure),
	   '164.522(a)(1)(iii)') :-
	wm(s164_522a1iii_obligation(CE,UsageOrDisclosure,UnspecifiedActor,Individual,PHI)).
implied(right(Individual,
	      not(UsageOrDisclosure),
	      '164.522(a)(1)(iii)')) :-
	wm(s164_522a1iii_obligation(CE,UsageOrDisclosure,UnspecifiedActor,Individual,PHI)).

s164_522a1iii_privilege(CE,HCP,UsageOrDisclosure,Individual,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	about(PHI,Individual),
	requests(Individual,
		 CE,
		 restricts(CE,UsageOrDisclosure)),
	agrees(CE,
	       requests(Individual,
			CE,
			restricts(CE,UsageOrDisclosure))),
	violates(UsageOrDisclosure,
		 restricts(CE,UsageOrDisclosure)),
	isInEmergency(Individual),
	to(requires(HCP,PHI),
	   provides(HCP,
		    Individual,
		    treats(HCP,Individual))),
	add_to_wm(s164_522a1iii_privilege(CE,HCP,UsageOrDisclosure,Individual,PHI)).
privilege(CE,
	  to(uses(CE,PHI),
	     treats(CE,
		    Individual)),
	  '164.522(a)(1)(iii)') :-
	wm(s164_522a1iii_privilege(CE,_,uses(CE,PHI),Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(to(uses(CE,PHI),
			     treats(CE,
				    Individual))),
		      _),
		'164.522(a)(1)(iii)')) :-
	wm(s164_522a1iii_privilege(CE,_,uses(CE,PHI),Individual,PHI)).
privilege(CE,
	  to(discloses(CE,HCP,PHI),
	     treats(HCP,
		    Individual)),
	  '164.522(a)(1)(iii)') :-
	wm(s164_522a1iii_privilege(CE,HCP,discloses(CE,HCP,PHI),Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(to(discloses(CE,HCP,PHI),
			     treats(HCP,
				    Individual))),
		      _),
		'164.522(a)(1)(iii)')) :-
	wm(s164_522a1iii_privilege(CE,HCP,discloses(CE,HCP,PHI),Individual,PHI)).

s164_522a1iv(CE,HCP,FurtherUsageOrDisclosure,Individual,PHI) :-
	isCoveredEntity(CE),
	isHealthcareProvider(HCP),
	isPHI(PHI),
	about(PHI,Individual),
	requests(Individual,
		 CE,
		 restricts(CE,UsageOrDisclosure)),
	agrees(CE,
	       requests(Individual,
			CE,
			restricts(CE,UsageOrDisclosure))),
	violates(UsageOrDisclosure,
		 restricts(CE,UsageOrDisclosure)),
	isInEmergency(Individual),
	to(requires(HCP,PHI),
	   provides(HCP,
		    Individual,
		    treats(HCP,Individual))),
	discloses(CE,HCP,PHI),
        isUsageOrDisclosure(HCP,_,PHI,FurtherUsageOrDisclosure),
	add_to_wm(s164_522a1iv(CE,HCP,FurtherUsageOrDisclosure,Individual,PHI)).
obligation(CE,
	   requests(CE,
		    HCP,
		    not(futher(FurtherUsageOrDisclosure,
			       discloses(CE,HCP,PHI)))),
	   '164.522(a)(1)(iv)') :-
	wm(s164_522a1iv(CE,HCP,FurtherUsageOrDisclosure,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(futher(FurtherUsageOrDisclosure,
			       discloses(CE,HCP,PHI))),
		      _),
		'164.522(a)(1)(iv)')) :-
	wm(s164_522a1iv(CE,HCP,FurtherUsageOrDisclosure,Individual,PHI)).

notEffective(restricts(CE,UsageOrDisclosure)) :-
	isCoveredEntity(CE),
	agrees(CE,
	       requests(Individual,
			CE,
			restricts(CE,UsageOrDisclosure))),
	obligationOrPrivilege(CE,
			      UsageOrDisclosure,
			      Section),
	isUsageOrDisclosure(CE,_,PHI,UsageOrDisclosure),
	isPHI(PHI),
	about(PHI,Individual),
	is_164_522a1v_crossrefs(Section).
is_164_522a1v_crossrefs('164.502(a)(2)(ii)').
is_164_522a1v_crossrefs('164.510(a)').
is_164_522a1v_crossrefs('164.512').
obligationOrPrivilege(CE,UsageOrDisclosure,Section) :-
	obligation(CE,UsageOrDisclosure,Section).
obligationOrPrivilege(CE,UsageOrDisclosure,Section) :-
	privilege(CE,UsageOrDisclosure,Section).

s164_522a2i(CE,Individual,UsageOrDisclosure,PHI) :-
	isCoveredEntity(CE),
	isUsageOrDisclosure(CE,_,PHI,UsageOrDisclosure),
	isPHI(PHI),
	about(PHI,Individual),
	agrees(CE,
	       requests(Individual,
			CE,
			restricts(CE,UsageOrDisclosure))),
	agreesOrRequests(Individual,CE,UsageOrDisclosure),
	add_to_wm(s164_522a2i(CE,Individual,UsageOrDisclosure,PHI)).
agreesOrRequests(Individual,CE,UsageOrDisclosure) :-
	written(agrees(Individual,
		       terminates(CE,
				  agrees(CE,
					 requests(Individual,
						  CE,
						  restricts(CE,UsageOrDisclosure)))))).
agreesOrRequests(Individual,CE,UsageOrDisclosure) :-
	written(requests(Individual,
			 CE,
			 terminates(CE,
				    agrees(CE,
					   requests(Individual,
						    CE,
						    restricts(CE,UsageOrDisclosure)))))).
power(CE,
      agrees(CE,
	     requests(Individual,
		      CE,
		      restricts(CE,UsageOrDisclosure))),
      terminates(CE,
		 agrees(CE,
			requests(Individual,
				 CE,
				 restricts(CE,UsageOrDisclosure)))),
      '164.522(a)(2)(i)') :-
	wm(s164_522a2i(CE,Individual,UsageOrDisclosure,PHI)).
implied(liability(Individual,
		  terminates(CE,
			     agrees(CE,
				    requests(Individual,
					     CE,
					     restricts(CE,UsageOrDisclosure)))),
		  '164.522(a)(2)(i)')) :-
	wm(s164_522a2i(CE,Individual,UsageOrDisclosure,PHI)).

s164_522a2ii(CE,Individual,UsageOrDisclosure,PHI) :-
	isCoveredEntity(CE),
	isUsageOrDisclosure(CE,_,PHI,UsageOrDisclosure),
	isPHI(PHI),
	about(PHI,Individual),
	agrees(CE,
	       requests(Individual,
			CE,
			restricts(CE,UsageOrDisclosure))),
	oral(agrees(Individual,
		    terminates(CE,
			       agrees(CE,
				      requests(Individual,
					       CE,
					       restricts(CE,UsageOrDisclosure)))))),
	documents(CE,
		  oral(agrees(Individual,
			      terminates(CE,
					 agrees(CE,
						requests(Individual,
							 CE,
							 restricts(CE,UsageOrDisclosure))))))),
	add_to_wm(s164_522a2ii(CE,Individual,UsageOrDisclosure,PHI)).
power(CE,
      agrees(CE,
	     requests(Individual,
		      CE,
		      restricts(CE,UsageOrDisclosure))),
      terminates(CE,
		 agrees(CE,
			requests(Individual,
				 CE,
				 restricts(CE,UsageOrDisclosure)))),
      '164.522(a)(2)(ii)') :-
	wm(s164_522a2ii(CE,Individual,UsageOrDisclosure,PHI)).
implied(liability(Individual,
		  terminates(CE,
			     agrees(CE,
				    requests(Individual,
					     CE,
					     restricts(CE,UsageOrDisclosure)))),
		  '164.522(a)(2)(ii)')) :-
	wm(s164_522a2ii(CE,Individual,UsageOrDisclosure,PHI)).

s164_522a2iii(CE,Individual,UsageOrDisclosure,PHI) :-
	isCoveredEntity(CE),
	isUsageOrDisclosure(CE,_,PHI,UsageOrDisclosure),
	isPHI(PHI),
	about(PHI,Individual),
	agrees(CE,
	       requests(Individual,
			CE,
			restricts(CE,UsageOrDisclosure))),
	informs(CE,
		Individual,
		terminates(CE,
			   agrees(CE,
				  requests(Individual,
					   CE,
					   restricts(CE,UsageOrDisclosure))))),
	add_to_wm(s164_522a2iii(CE,Individual,UsageOrDisclosure,PHI)).
power(CE,
      agrees(CE,
	     requests(Individual,
		      CE,
		      restricts(CE,UsageOrDisclosure))),
      terminates(CE,
		 agrees(CE,
			requests(Individual,
				 CE,
				 restricts(CE,UsageOrDisclosure)))),
      '164.522(a)(2)(iii)') :-
	wm(s164_522a2iii(CE,Individual,UsageOrDisclosure,PHI)).
implied(liability(Individual,
		  terminates(CE,
			     agrees(CE,
				    requests(Individual,
					     CE,
					     restricts(CE,UsageOrDisclosure)))),
		  '164.522(a)(2)(iii)')) :-
	wm(s164_522a2iii(CE,Individual,UsageOrDisclosure,PHI)).

notEffective(terminates(CE,
		        agrees(CE,
			       requests(Individual,
				        CE,
				        restricts(CE,UsageOrDisclosure))))) :-
	wm(s164_522a2iii(CE,Individual,UsageOrDisclosure,PHI)),
	before(CreatesOrReceives,
	       terminates(CE,
			  agrees(CE,
				 requests(Individual,
					  CE,
					  restricts(CE,UsageOrDisclosure))))),
	createsOrReceives(CE,_,PHI,CreatesOrReceives).

s164_522a3(CE,Individual,UsageOrDisclosure,PHI) :-
	isCoveredEntity(CE),
	isUsageOrDisclosure(CE,_,PHI,UsageOrDisclosure),
	agrees(CE,
	       requests(Individual,
			CE,
			restricts(CE,UsageOrDisclosure))),
	isPHI(PHI),
	about(PHI,Individual),
	add_to_wm(s164_522a3(CE,Individual,UsageOrDisclosure,PHI)).
obligation(CE,
	   documents(CE,
		     restricts(CE,UsageOrDisclosure)),
	   '164.522(a)(3)') :-
	wm(s164_522a3(CE,Individual,UsageOrDisclosure,PHI)).
% TODO what is the implied right?

s164_522b1i(CE,Individual,AlternativeMeansOrLocations,PermitsOrAccomodates,PHI) :-
	   isCoveredEntity(CE),
	   about(PHI,Individual),
	   isPermitsOrAccomodates(CE,Individual,AlternativeMeansOrLocations,PHI,PermitsOrAccomodates),
	   isAlternativeMeansOrLocations(AlternativeMeansOrLocations),
	   add_to_wm(s164_522b1i(CE,Individual,AlternativeMeansOrLocations,PHI)).
isAlternativeMeansOrLocations(alternativeMeans).
isAlternativeMeansOrLocations(alternativeLocations).
isPermitsOrAccomodates(CE,
		       Individual,
		       AlternativeMeansOrLocations,
		       PHI,
		       permits(CE,
			       requests(Individual,
					CE,
					by(receives(Individual,
						    CE,
						    PHI),
					   AlternativeMeansOrLocations)))).
isPermitsOrAccomodates(CE,
		       Individual,
		       AlternativeMeansOrLocations,
		       PHI,
		       accomodates(CE,
				   reasonable(requests(Individual,
						       CE,
						       by(receives(Individual,
								   CE,
								   PHI),
							  AlternativeMeansOrLocations))))).
obligation(CE,
	   PermitsOrAccomodates,
	   '164.522(b)(1)(i)') :-
	wm(s164_522b1i(CE,Individual,AlternativeMeansOrLocations,PermitsOrAccomodates,PHI)).
implied(right(Individual,
	      reasonable(requests(Individual,
				  CE,
				  by(receives(Individual,
					      CE,
					      PHI),
				     AlternativeMeansOrLocations))),
	      '164.522(b)(1)(i)')) :-
	wm(s164_522b1i(CE,Individual,AlternativeMeansOrLocations,_,PHI)).

s164_522b1ii(HP,Individual,AlternativeMeansOrLocations,PermitsOrAccomodates,PHI) :-
	isHealthPlan(HP),
	isPHI(PHI),
	about(PHI,Individual),
	isAlternativeMeansOrLocations(AlternativeMeansOrLocations),
	isPermitsOrAccomodates(HP,Individual,AlternativeMeansOrLocations,PHI,PermitsOrAccomodates),
	clear(states(Individual,
		       couldEndanger(discloses(HP,_,PHI),
				     Individual))),
	add_to_wm(s164_522b1ii(HP,Individual,AlternativeMeansOrLocations,PermitsOrAccomodates,PHI)).
obligation(HP,
	   PermitsOrAccomodates,
	   '164.522(b)(1)(ii)') :-
	wm(s164_522b1ii(HP,Individual,AlternativeMeansOrLocations,PermitsOrAccomodates,PHI)).
implied(right(Individual,
	      reasonable(requests(Individual,
				  CE,
				  by(receives(Individual,
					      CE,
					      PHI),
				     AlternativeMeansOrLocations))),
	      '164.522(b)(1)(ii)')) :-
	wm(s164_522b1ii(HP,Individual,AlternativeMeansOrLocations,_,PHI)).

privilege(CE,
	  requires(CE,
		   Individual,
		   written(requests(Individual,
				    CE,
				    by(receives(Individual,
						CE,
						PHI),
				       AlternativeMeansOrLocations)))),
	  '164.522(b)(2)(i)') :-
	wm(s164_522b1i(CE,Individual,AlternativeMeansOrLocations,_,PHI)) ;
	wm(s164_522b1ii(CE,Individual,AlternativeMeansOrLocations,_,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(written(requests(Individual,
					   CE,
					   by(receives(Individual,
						       CE,
						       PHI),
					      AlternativeMeansOrLocations)))),
		      _),
		'164.522(b)(2)(i)')) :-
	wm(s164_522b1i(CE,Individual,AlternativeMeansOrLocations,_,PHI)) ;
	wm(s164_522b1ii(CE,Individual,AlternativeMeansOrLocations,_,PHI)).

s164_522b2iiA(CE,Individual,AlternativeMeansOrLocations,Condition,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	about(PHI,Individual),
	isAlternativeMeansOrLocations(AlternativeMeansOrLocations),
	is_164_522b2ii_condition(Individual,Condition),
	add_to_wm(s164_522b2iiA(CE,Individual,AlternativeMeansOrLocations,Condition,PHI)).
is_164_522b2ii_condition(_,howToHandle(payment)).
is_164_522b2ii_condition(Individual,alternative(address(Individual))).
is_164_522b2ii_condition(Individual,otherContactMeans(alternative(address(Individual)))).
privilege(CE,
	  isConditionOf(Condition,
			accomodates(CE,
				    reasonable(requests(Individual,
							CE,
							by(receives(Individual,
								    CE,
								    PHI),
							   AlternativeMeansOrLocations))))),
	  '164.522(b)(2)(ii)') :-
	wm(s164_522b2iiA(CE,Individual,AlternativeMeansOrLocations,Condition,PHI)).
% TODO  what is the implied no right?

obligation(CE,
	   not(requires(CE,
			Individual,
			explains(Individual,
				 basis(requests(Individual,
						CE,
						confidential(provides(CE,
								      Individual,
								      communication))))))),
	   '164.522(b)(2)(iii)') :-
	isCoveredEntity(CE).
implied(right(Individual,
	      not(requires(CE,
			   Individual,
			   explains(Individual,
				    basis(requests(Individual,
						   CE,
						   confidential(provides(CE,
									 Individual,
									 communication))))))),
	      '164.522(b)(2)(iii)')) :-
	isCoveredEntity(CE).
	
s164_522b2iv(HP,ThirdParty,Individual,UsageOrDisclosure,PHI) :-
	isHealthPlan(HP),
	isUsageOrDisclosure(HP,ThirdParty,PHI,UsageOrDisclosure),
	isPHI(PHI),
	about(PHI,Individual),
	add_to_wm(s164_522b2iv(HP,ThirdParty,Individual,UsageOrDisclosure,PHI)).
privilege(HP,
	  contains(requests(Individual,
			    HP,
			    restricts(HP,
				      UsageOrDisclosure)),
		   statement(couldEndanger(discloses(HP,ThirdParty,PHI),
					   Individual))),
	  '164.522(b)(2)(iv)') :-
	wm(s164_522b2iv(HP,ThirdParty,Individual,UsageOrDisclosure,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(states(Individual,
				 couldEndanger(discloses(HP,ThirdParty,PHI),
					       Individual))),
		      _),
		'164.522(b)(2)(iv)')) :-
	wm(s164_522b2iv(HP,ThirdParty,Individual,UsageOrDisclosure,PHI)).

% eof
