% Models section 164.526 of the HIPAA Privacy Rule

s164_526a1(CE,Individual,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	isHIPAAIndividual(Individual),
	isPHI(PHI),
	maintains(CE,PHI),
	add_to_wm(s164_526a1(CE,Individual,PHI)).
right(Individual,
      amends(CE,
	     PHI),
      '164.526(a)(1)') :-
	wm(s164_526a1(CE,Individual,PHI)).
implied(obligation(CE,
		   amends(CE,PHI),
		   '164.526(a)(1)')) :-
	wm(s164_526a1(CE,Individual,PHI)).

s164_526a2i(CE,Individual,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	isPHI(PHI),
	determines(CE,
		   not(creates(CE,PHI))),
	not(provides(Individual,
		     CE,
		     reasonable(basis(believes(Individual,
					       unavailable(originator(PHI))))))),
	add_to_wm(s164_526a2i(CE,Individual,PHI)).
privilege(CE,
	  denies(requests(Individual,
			  CE,
			  amends(CE,PHI))),
	  '164.526(a)(2)(i)') :-
	wm(s164_526a2i(CE,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(denies(requests(Individual,
			  CE,
			  amends(CE,PHI)))),
		      _),
		'164.526(a)(2)(i)')) :-
	wm(s164_526a2i(CE,Individual,PHI)).

s164_526a2i_exception(CE,Individual,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	isPHI(PHI),
	not(creates(CE,PHI)),
	provides(Individual,
		 CE,
		 reasonable(basis(believes(Individual,
					   unavailable(originator(PHI)))))),
	add_to_wm(s164_526a2i_exception(CE,Individual,PHI)).
obligation(CE,
	   not(denies(requests(Individual,
			       CE,
			       amends(CE,PHI)))),
	   '164.526(a)(2)(i)') :-
	wm(s164_526a2i_exception(CE,Individual,PHI)).
implied(right(Individual,
	      not(denies(requests(Individual,
			  CE,
			  amends(CE,PHI)))),
	      '164.526(a)(2)(i)')) :-
	wm(s164_526a2i_exception(CE,Individual,PHI)).

s164_526a2ii(CE,Individual,DSR,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	isPHI(PHI),
	maintains(CE,DSR),
	isDesignatedRecordSet(DSR),
	determines(CE,not(in(PHI,DSR))),
	add_to_wm(s164_526a2ii(CE,Individual,DSR,PHI)).
privilege(CE,
	  denies(requests(Individual,
			  CE,
			  amends(CE,PHI))),
	  '164.526(a)(2)(ii)') :-
	wm(s164_526a2ii(CE,Individual,DSR,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(denies(requests(Individual,
			  CE,
			  amends(CE,PHI)))),
		      _),
		'164.526(a)(2)(ii)')) :-
	wm(s164_526a2ii(CE,Individual,DSR,PHI)).

s164_526a2iii(CE,Individual,DSR,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	about(PHI,Individual),
	not(right(Individual,
		  forAsLongAs(inspects(Individual,copy(PHI)),in(PHI,DSR)),
		  _)),
	isDesignatedRecordSet(DSR),
	add_to_wm(s164_526a2iii(CE,Individual,DSR,PHI)).
privilege(CE,
	  denies(requests(Individual,
			  CE,
			  amends(CE,PHI))),
	  '164.526(a)(2)(iii)') :-
	wm(s164_526a2iii(CE,Individual,DSR,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(denies(requests(Individual,
					  CE,
					  amends(CE,PHI)))),
		      _),
		'164.526(a)(2)(iii)')) :- 
	wm(s164_526a2iii(CE,Individual,DSR,PHI)).

s164_526a2iv(CE,Individual,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	isPHI(PHI),
	determines(CE,accurate(PHI)),
	determines(CE,complete(PHI)),
	add_to_wm(s164_526a2iv(CE,Individual,PHI)).
privilege(CE,
	  denies(requests(Individual,
			  CE,
			  amends(CE,PHI))),
	  '164.526(a)(2)(iv)') :-
	wm(s164_526a2iv(CE,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(denies(requests(Individual,
			  CE,
			  amends(CE,PHI)))),
		      _),
		'164.526(a)(2)(iv)')) :-
	wm(s164_526a2iv(CE,Individual,PHI)).

s164_526b1(CE,Individual,DSR,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	isPHI(PHI),
	maintains(CE,
		  in(PHI,DSR)),
	isDesignatedRecordSet(DSR),
	add_to_wm(s164_526b1(CE,Individual,DSR,PHI)).
obligation(CE,
	   permits(CE,
		   requests(Individual,
			    CE,
			    amends(CE,
				   PHI))),
	   '164.526(b)(1)') :-
	wm(s164_526b1(CE,Individual,DSR,PHI)).
implied(right(Individual,
	      requests(Individual,
		       CE,
		       amends(CE,PHI)),
	      '164.526(b)(1)')) :-
	wm(s164_526b1(CE,Individual,DSR,PHI)).

privilege(CE,
	  requires(CE,
		   Individual,
		   written(requires(Individual,
				    CE,
				    amends(CE,PHI)))),
	  '164.526(b)(1)') :-
	informs(CE,
		Individual,
		requires(CE,
			 Individual,
			 written(requires(Individual,
					  CE,
					  amends(CE,PHI))))),
	wm(s164_526b1(CE,Individual,DSR,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(requires(CE,
				   Individual,
				   written(requires(Individual,
						    CE,
						    amends(CE,PHI))))),
		      _),
		'164.526(b)(1)')) :-
	informs(CE,
		Individual,
		requires(CE,
			 Individual,
			 written(requires(Individual,
					  CE,
					  amends(CE,PHI))))),
	wm(s164_526b1(CE,Individual,DSR,PHI)).

privilege(CE,
	  requires(CE,
		   Individual,
		   provides(Individual,
			    CE,
			    reasonToSupport(amends(CE,PHI)))),
	  '164.526(b)(1)') :-
	informs(CE,
		Individual,
		requires(CE,
			 Individual,
			 provides(Individual,
				  CE,
				  reasonToSupport(amends(CE,PHI))))),
	wm(s164_526b1(CE,Individual,DSR,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(requires(CE,
				   Individual,
				   provides(Individual,
					    CE,
					    reasonToSupport(amends(CE,PHI))))),
		      _),
		'164.526(b)(1)')) :-
	informs(CE,
		Individual,
		requires(CE,
			 Individual,
			 provides(Individual,
				  CE,
				  reasonToSupport(amends(CE,PHI))))),
	wm(s164_526b1(CE,Individual,DSR,PHI)).

s164_526b2iA(CE,Individual,Action,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	isPHI(PHI),
	requests(Individual,
		 CE,
		 amends(CE,PHI)),
	grants(CE,
	       requests(Individual,
			CE,
			amends(CE,PHI))),
	is_164_526b1_action(CE,Individual,PHI,Action),
	add_to_wm(s164_526b2iA(CE,Individual,Action,PHI)).
is_164_526b1_action(CE,Individual,PHI,Action) :-
	is_164_526c1and2_action(CE,Individual,PHI,Action).
is_164_526b1_action(CE,Individual,PHI,Action) :-
	is_164_526d1_action(CE,Individual,PHI,Action).
obligation(CE,
	   noLaterThan(Action,
		       after(day(60),
			     receives(CE,
				      Individual,
				      requests(Individual,
					       CE,
					       amends(CE,PHI))))),
	   '164.526(b)(2)') :-
	wm(s164_526b2iA(CE,Individual,Action,PHI)).
implied(right(Individual,
	      noLaterThan(Action,
			  after(day(60),
				receives(CE,
					 Individual,
					 requests(Individual,
						  CE,
						  amends(CE,PHI))))),
	      '164.526(b)(2)')) :-
	wm(s164_526b2iA(CE,Individual,Action,PHI)).

s164_526b2ii(CE,Individual,Action,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	isPHI(PHI),
	requests(Individual,
		 CE,
		 amends(CE,PHI)),
	within(provides(CE,
			Individual,
			written(statement(reasonsFor(delays(CE,
							    requests(Individual,
								     CE,
								     amends(CE,PHI))))))),
	       day(60)),
	within(provides(CE,
			Individual,
			written(statement(date(Action)))),
	       day(60)),
	add_to_wm(s164_526b2ii(CE,Individual,Action,PHI)).
privilege(CE,
	  onlyOnce(extends(CE,
			   noLaterThan(Action,
				       after(day(60),
					     receives(CE,
						      Individual,
						      requests(Individual,
							       CE,
							       amends(CE,PHI))))),
			   day(30))),
	  '164.526(b)(2)(ii)') :-
	wm(s164_526b2ii(CE,Individual,Action,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(extends(CE,
				  noLaterThan(Action,
					      after(day(60),
						    receives(CE,
							     Individual,
							     requests(Individual,
								      CE,
								      amends(CE,PHI))))),
				  day(30))),
		      _),
		'164.526(b)(2)(ii)')) :-
	wm(s164_526b2ii(CE,Individual,Action,PHI)).

s164_526b2iiB(CE,Individual,Action,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	isPHI(PHI),
	requests(Individual,
		 CE,
		 amends(CE,PHI)),
	extends(CE,
		noLaterThan(Action,
			    after(day(60),
				  receives(CE,
					   Individual,
					   requests(Individual,
						    CE,
						    amends(CE,PHI))))),
		day(30)),
	add_to_wm(s164_526b2iiB(CE,Individual,Action,PHI)).
obligation(CE,
	   not(extends(CE,
		       noLaterThan(Action,
				   after(day(60),
					 receives(CE,
						  Individual,
						  requests(Individual,
							   CE,
							   amends(CE,PHI))))),
		       _)),
	   '164.526(b)(2)(ii)(B)') :-
	wm(s164_526b2iiB(CE,Individual,Action,PHI)).
implied(right(Individual,
	      not(extends(CE,
		       noLaterThan(Action,
				   after(day(60),
					 receives(CE,
						  Individual,
						  requests(Individual,
							   CE,
							   amends(CE,PHI))))),
		       _)),
	   '164.526(b)(2)(ii)(B)')) :-
	wm(s164_526b2iiB(CE,Individual,Action,PHI)).

s164_526c(CE,Individual,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	isPHI(PHI),
	requests(Individual,
		 CE,
		 amends(CE,PHI)),
	accepts(CE,
		requests(Individual,
			 CE,
			 amends(CE,PHI))),
	add_to_wm(s164_526c(CE,Individual,PHI)).
is_164_526c1and2_action(CE,_,PHI,xor(by(amends(CE,PHI),
					appends(CE,
						amends(CE,PHI),
						PHI)),
				     by(amends(CE,PHI),
					appends(CE,
						link(location(amends(CE,PHI))),
						PHI)))).
obligation(CE,
	   xor(by(amends(CE,PHI),
		  appends(CE,
			  amends(CE,PHI),
			  PHI)),
	       by(amends(CE,PHI),
		  appends(CE,
			  link(location(amends(CE,PHI))),
			  PHI))),
	   '164.526(c)(1)') :-
	wm(s164_526c(CE,Individual,PHI)).
implied(right(Individual,
	      xor(by(amends(CE,PHI),
		     appends(CE,
			     amends(CE,PHI),
			     PHI)),
		  by(amends(CE,PHI),
		     appends(CE,
			     link(location(amends(CE,PHI))),
			     PHI))),
	      '164.526(c)(1)')) :-
	wm(s164_526c(CE,Individual,PHI)).

is_164_526c1and2_action(CE,Individual,PHI,timely(informs(CE,
							 Individual,
							 accepts(CE,
								 requests(Individual,
									  CE,
									  amends(CE,PHI)))))).
obligation(CE,
	   timely(informs(CE,
			  Individual,
			  accepts(CE,
				  requests(Individual,
					   CE,
					   amends(CE,PHI))))),
	   '164.526(c)(2)') :-
	add_to_wm(s164_526c(CE,Individual,PHI)).
implied(right(Individual,
	      timely(informs(CE,
			     Individual,
			     accepts(CE,
				     requests(Individual,
					      CE,
					      amends(CE,PHI))))),
	      '164.526(c)(2)')) :-
	add_to_wm(s164_526c(CE,Individual,PHI)).

is_164_526c1and2_action(CE,Individual,PHI,obtains(CE,
						  Individual,
						  identity(Person))) :-
	is_164_526c3_person(CE,Individual,PHI,Person).
obligation(CE,
	   obtains(CE,
		   Individual,
		   identity(Person)),
	   '164.526(c)(2)') :-
	is_164_526c3_person(CE,Individual,PHI,Person),
	add_to_wm(s164_526c(CE,Individual,PHI)).
implied(right(Individual,
	      obtains(CE,
		      Individual,
		      identity(Person)),
	      '164.526(c)(2)')) :-
	is_164_526c3_person(CE,Individual,PHI,Person),
	add_to_wm(s164_526c(CE,Individual,PHI)).

is_164_526c1and2_action(CE,Individual,PHI,obtains(CE,
						  Individual,
						  agrees(Individual,
							 CE,
							 notifies(CE,
								  Person,
								  amends(CE,PHI))))) :-
	is_164_526c3_person(CE,Individual,PHI,Person).
obligation(CE,
	   obtains(CE,
		   Individual,
		   agrees(Individual,
			  CE,
			  notifies(CE,
				   Person,
				   amends(CE,PHI)))),
	   '164.526(c)(2)') :-
	is_164_526c3_person(CE,Individual,PHI,Person),
	add_to_wm(s164_526c(CE,Individual,PHI)).
implied(right(Individual,
	      obtains(CE,
		      Individual,
		      agrees(Individual,
			     CE,
			     notifies(CE,
				      Person,
				      amends(CE,PHI)))),
	      '164.526(c)(2)')) :-
	is_164_526c3_person(CE,Individual,PHI,Person),
	add_to_wm(s164_526c(CE,Individual,PHI)).

obligation(CE,
	   reasonable(makesEfforts(CE,
				   informs(CE,
					   Person,
					   amends(CE,PHI)))),
	   '164.526(c)(3)') :-
	is_164_526c3_person(CE,Individual,PHI,Person),
	add_to_wm(s164_526c(CE,Individual,PHI)).
implied(right(Individual,
	      reasonable(makesEfforts(CE,
				      informs(CE,
					      Person,
					      amends(CE,PHI)))),
	      '164.526(c)(3)')) :-
	is_164_526c3_person(CE,Individual,PHI,Person),
	add_to_wm(s164_526c(CE,Individual,PHI)).
obligation(CE,
	   reasonable(makesEfforts(CE,
				   provides(CE,
					    Person,
					    amends(CE,PHI)))),
	   '164.526(c)(3)') :-
	is_164_526c3_person(CE,Individual,PHI,Person),
	add_to_wm(s164_526c(CE,Individual,PHI)).
implied(right(Individual,
	      reasonable(makesEfforts(CE,
				      provides(CE,
					       Person,
					       amends(CE,PHI)))),
	      '164.526(c)(3)')) :-
	is_164_526c3_person(CE,Individual,PHI,Person),
	add_to_wm(s164_526c(CE,Individual,PHI)).

is_164_526c3_person(CE,Individual,PHI,Person) :-
	identifies(Individual,Person),
	receives(Person,_,PHI),
	requires(Person,amends(CE,PHI)).
is_164_526c3_person(CE,Individual,PHI,Person) :-
	knows(CE,maintains(Person,PHI)),
	to(relies(Person,PHI),
	   detriment(Individual)).
is_164_526c3_person(CE,Individual,PHI,Person) :-
	knows(CE,maintains(Person,PHI)),
	foresees(CE,
		 to(relies(Person,PHI),
		    detriment(Individual))).

s164_526d(CE,Individual,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	isPHI(PHI),
	requests(Individual,
		 CE,
		 amends(CE,PHI)),
	denies(CE,
	       requests(Individual,
			CE,
			amends(CE,PHI))),
	add_to_wm(s164_526d(CE,Individual,PHI)).
is_164_526d1_action(CE,Individual,PHI,timely(written(denies(CE,
							    requests(Individual,
								     CE,
								     amends(CE,PHI)))))).
obligation(CE,
	   provides(CE,
		    Individual,
		    timely(written(denies(CE,
					  requests(Individual,
						   CE,
						   amends(CE,PHI)))))),
	   '164.526(d)(1)') :-
	wm(s164_526d(CE,Individual,PHI)).
implied(right(Individual,
	      provides(CE,
		       Individual,
		       timely(written(denies(CE,
					     requests(Individual,
						      CE,
						      amends(CE,PHI)))))),
	      '164.526(d)(1)')) :-
	wm(s164_526d(CE,Individual,PHI)).

obligation(CE,
	   contains(written(denies(CE,
				   requests(Individual,
					    CE,
					    amends(CE,PHI)))),
		    basis(denies(CE,
				 requests(Individual,
					  CE,
					  amends(CE,PHI))))),
	   '164.526(d)(1)(i)') :-
	wm(s164_526d(CE,Individual,PHI)).
% TODO what is the implied right?

obligation(CE,
	   contains(written(denies(CE,
				   requests(Individual,
					    CE,
					    amends(CE,PHI)))),
		    right(Individual,
			  disagrees(Individual,
				    denies(CE,
					   requests(Individual,
						    CE,
						    amends(CE,PHI)))),
			  '164.526(d)(1)(ii)')),
	   '164.526(d)(1)(ii)') :-
	wm(s164_526d(CE,Individual,PHI)).
implied(right(Individual,
	      disagrees(Individual,
			denies(CE,
			       requests(Individual,
					CE,
					amends(CE,PHI)))),
	      '164.526(d)(1)(ii)')) :-
	wm(s164_526d(CE,Individual,PHI)).

obligation(CE,
	   contains(written(denies(CE,
				   requests(Individual,
					    CE,
					    amends(CE,PHI)))),
		    statement(requests(Individual,
				       CE,
				       with(discloses(CE,_,requests(Individual,
								    CE,
								    amends(CE,PHI))),
					    discloses(CE,_,PHI))))),
	   '164.526(d)(1)(iii)') :-
	not(submits(Individual,
		    CE,
		    statement(disagrees(Individual,
					denies(CE,
					       requests(Individual,
							CE,
							amends(CE,PHI))))))),
	wm(s164_526d(CE,Individual,PHI)).
implied(right(Individual,
	      requests(Individual,
		       CE,
		       with(discloses(CE,_,requests(Individual,
						    CE,
						    amends(CE,PHI))),
			    discloses(CE,_,PHI))),
	      '164.526(d)(1)(iii)')) :-
	not(submits(Individual,
		    CE,
		    statement(disagrees(Individual,
					denies(CE,
					       requests(Individual,
							CE,
							amends(CE,PHI))))))),
	wm(s164_526d(CE,Individual,PHI)).

obligation(CE,
	   contains(written(denies(CE,
				   requests(Individual,
					    CE,
					    amends(CE,PHI)))),
		    statement(Statement)),
	   '164.526(d)(1)(iv)') :-
	is_s164_526d1iv_statement(CE,Individual,PHI,Statement),
	wm(s164_526d(CE,Individual,PHI)).
is_s164_526d1iv_statement(CE,
			  Individual,
			  PHI,
			  Statement) :-
	is_s160_306_compliantProcedure(CE,Individual,PHI,Statement).
is_s164_526d1iv_statement(CE,
			  Individual,
			  _,
			  statement(process(Compliant))) :-
	is_164_530d1_complaint(CE,Individual,_,Compliant).

is_s164_526d1iv_statement(CE,
			  Individual,
			  _,
			  statement(PersonOrOffice)) :-
	wm(s164_530a1ii(CE,PersonOrOffice,Individual,_,_)).

obligation(CE,
	   permits(CE,
		   Individual,
		   submits(Individual,
			   CE,
			   written(statement(disagrees(Individual,
						       denies(CE,
							      requests(Individual,
								       CE,
								       amends(CE,PHI)))))))),
	   '164.526(d)(2)') :-
	wm(s164_526d(CE,Individual,PHI)).
implied(right(Individual,
	      submits(Individual,
		      CE,
		      written(statement(disagrees(Individual,
						  denies(CE,
							 requests(Individual,
								  CE,
								  amends(CE,PHI))))))),
	      '164.526(d)(2)')) :-
	wm(s164_526d(CE,Individual,PHI)).

obligation(CE,
	   permits(CE,
		   Individual,
		   submits(Individual,
			   CE,
			   written(statement(basis(disagrees(Individual,
							     denies(CE,
								    requests(Individual,
									     CE,
									     amends(CE,PHI))))))))),
	   '164.526(d)(2)') :-
	wm(s164_526d(CE,Individual,PHI)).
implied(right(Individual,
	      submits(Individual,
		      CE,
		      written(statement(basis(disagrees(Individual,
							denies(CE,
							       requests(Individual,
									CE,
									amends(CE,PHI)))))))),
	      '164.526(d)(2)')) :-
	wm(s164_526d(CE,Individual,PHI)).

privilege(CE,
	  reasonable(limits(CE,
			    length(statement(disagrees(Individual,
						       denies(CE,
							      requests(Individual,
								       CE,
								       amends(CE,PHI)))))))),
	  '164.526(d)(2)') :-
	wm(s164_526d(CE,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(reasonable(limits(CE,
					    length(statement(disagrees(Individual,
								       denies(CE,
									      requests(Individual,
										       CE,
										       amends(CE,PHI))))))))),
		      _),
		'164.526(d)(2)')) :-
	wm(s164_526d(CE,Individual,PHI)).

privilege(CE,
	  prepares(CE,
		   written(rebuttal(statement(disagrees(Individual,
						        denies(CE,
							       requests(Individual,
									CE,
									amends(CE,PHI)))))))),
	  '164.526(d)(3)') :-
	wm(s164_526d(CE,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(prepares(CE,
				   written(rebuttal(statement(disagrees(Individual,
									denies(CE,
									       requests(Individual,
											CE,
											amends(CE,PHI))))))))),
		      _),
		'164.526(d)(3)')) :-
	wm(s164_526d(CE,Individual,PHI)).

obligation(CE,
	   provides(CE,
		    Individual,
		    copy(written(rebuttal(statement(disagrees(Individual,
						        denies(CE,
							       requests(Individual,
									CE,
									amends(CE,PHI))))))))),
	   '164.526(d)(3)') :-
	prepares(CE,
		 written(rebuttal(statement(disagrees(Individual,
						      denies(CE,
							     requests(Individual,
								      CE,
								      amends(CE,PHI)))))))),
	wm(s164_526d(CE,Individual,PHI)).
implied(right(Individual,
	      provides(CE,
		       Individual,
		       copy(written(rebuttal(statement(disagrees(Individual,
								 denies(CE,
									requests(Individual,
										 CE,
										 amends(CE,PHI))))))))),
	      '164.526(d)(3)')) :-
	prepares(CE,
		 written(rebuttal(statement(disagrees(Individual,
						      denies(CE,
							     requests(Individual,
								      CE,
								      amends(CE,PHI)))))))),
	wm(s164_526d(CE,Individual,PHI)).

obligation(CE,
	   asAppropriate(appends(CE,PHI,Info)),
	   '164.526(d)(4)') :-
	is_s164_526d4_info(CE,Individual,PHI,Info),
	wm(s164_526d(CE,Individual,PHI)).
implied(right(Individual,
	      asAppropriate(appends(CE,PHI,Info)),
	      '164.526(d)(4)')) :-
	is_s164_526d4_info(CE,Individual,PHI,Info),
	wm(s164_526d(CE,Individual,PHI)).
is_s164_526d4_info(CE,Individual,PHI,requests(Individual,
					 CE,
					 amends(CE,PHI))).
is_s164_526d4_info(CE,Individual,PHI,denies(CE,
					    requests(Individual,
						     CE,
						     amends(CE,PHI)))).
is_s164_526d4_info(CE,Individual,PHI,statement(disagrees(Individual,
							 denies(CE,
								requests(Individual,
									 CE,
									 amends(CE,PHI)))))).
is_s164_526d4_info(CE,Individual,PHI,rebuttal(statement(disagrees(Individual,
								  denies(CE,
									 requests(Individual,
										  CE,
										  amends(CE,PHI))))))).

obligation(CE,
	   includes(CE,
		    with(Info,
			 discloses(CE,_,PHI))),
	   '164.526(d)(5)(i)') :-
	is_s164_526d4_info(CE,Individual,PHI,Info),
	wm(s164_526d(CE,Individual,PHI)).
implied(right(Individual,
	      includes(CE,
		       with(Info,
			    discloses(CE,_,PHI))),
	      '164.526(d)(5)(i)')) :-
	is_s164_526d4_info(CE,Individual,PHI,Info),
	wm(s164_526d(CE,Individual,PHI)).

privilege(CE,
	  insteadOf(Info,
		    accurate(summary(Info))),
	  '164.526(d)(5)(i)') :-
	is_s164_526d4_info(CE,Individual,PHI,Info),
	wm(s164_526d(CE,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      CE,
		      not(insteadOf(Info,
				    accurate(summary(Info)))),
		      _),
		'164.526(d)(5)(i)')) :-
	is_s164_526d4_info(CE,Individual,PHI,Info),
	wm(s164_526d(CE,Individual,PHI)).

obligation(CE,
	   includes(CE,
		    with(Info,
			 discloses(CE,_,PHI))),
	   '164.526(d)(5)(ii)') :-
	is_s164_526d5ii_info(CE,Individual,PHI,Info),
	wm(s164_526d(CE,Individual,PHI)).
implied(right(Individual,
	      includes(CE,
		       with(Info,
			    discloses(CE,_,PHI))),
	      '164.526(d)(5)(ii)')) :-
	is_s164_526d5ii_info(CE,Individual,PHI,Info),
	wm(s164_526d(CE,Individual,PHI)).
is_s164_526d5ii_info(CE,Individual,PHI,requests(Individual,
						CE,
						amends(CE,PHI))).
is_s164_526d5ii_info(CE,Individual,PHI,denies(CE,
					      requests(Individual,
						       CE,
						       amends(CE,PHI)))).

privilege(CE,
	  insteadOf(includes(CE,
			     with(summary(Info),
				  discloses(CE,_,PHI))),
		    includes(CE,
			     with(Info,
				  discloses(CE,_,PHI)))),
	  '164.526(d)(5)(ii)') :-
	is_s164_526d5ii_info(CE,Individual,PHI,Info),
	wm(s164_526d(CE,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(insteadOf(includes(CE,
					     with(summary(Info),
						  discloses(CE,_,PHI))),
				    includes(CE,
					     with(Info,
						  discloses(CE,_,PHI))))),
		      _),
		'164.526(d)(5)(ii)')) :-
	is_s164_526d5ii_info(CE,Individual,PHI,Info),
	wm(s164_526d(CE,Individual,PHI)).

s164_526e(CE,OtherCE,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	notifies(OtherCE,
		 CE,
		 amends(OtherCE,PHI)),
	add_to_wm(s164_526e(CE,OtherCE,PHI)).
obligation(CE,
	   amends(CE,PHI),
	   '164.526(e)') :-
	wm(s164_526e(CE,OtherCE,PHI)).
implied(right(Individual,
	      amends(CE,PHI),
	      '164.526(e)')) :-
	about(PHI,Individual),
	wm(s164_526e(CE,OtherCE,PHI)).

s164_526f(CE,PersonOrOffice,Individual,PHI) :-
	isCoveredEntity(CE),
	isPersonOrOffice(PersonOrOffice),
	isResponsible(PersonOrOffice,
		      receives(PersonOrOffice,
			       requests(Individual,
					CE,
					amends(CE,PHI)))),
	isPHI(PHI),
	about(PHI,Individual),
	add_to_wm(s164_526f(CE,PersonOrOffice,Individual,PHI)).
obligation(CE,
	   documents(CE,title(PersonOrOffice)),
	   '164.526(f)') :-
	wm(s164_526f(CE,PersonOrOffice,Individual,PHI)).
% TODO what is the implied right?	   

% eof











