% Models section 164.528 of the HIPAA Privacy Rule

s164_528a1(CE,Individual,PHI,Disclosure) :-
        isCoveredEntity(CE),
	isPHI(PHI),
	about(PHI,Individual),
% TODO throws the engine into an infinite loop
%	is_164_528a1_exception(CE,Individual,PHI,Disclosure),
	within(discloses(CE,_,PHI),
	       year(6),
	       requests(Individual,
			CE,
			receives(Individual,
				 CE,
				 accounting(Disclosure)))),
	add_to_wm(s164_528a1(CE,Individual,PHI,Disclosure)).
right(Individual,
      receives(Individual,
	       CE,
	       accounting(Disclosure)),
      '164.528(a)(1)') :-
	wm(s164_528a1(CE,Individual,PHI,Disclosure)).
implied(obligation(CE,
		   provides(CE,
			    Individual,
			    accounting(Disclosure)),
		   '164.528(a)(1)')) :-
	wm(s164_528a1(CE,Individual,PHI,Disclosure)).

is_164_528a1_exception(CE,_,PHI,for(discloses(CE,ThirdParty,PHI),TPO)) :-
	valid_HIPAA_TPO(TPO),
	privilege(CE,for(discloses(CE,ThirdParty,PHI),TPO),Section),
	isSubsectionOf(Section,'164.506').
is_164_528a1_exception(CE,_,PHI,for(discloses(CE,ThirdParty,PHI),TPO)) :-
	valid_HIPAA_TPO(TPO),
	obligation(CE,for(discloses(CE,ThirdParty,PHI),TPO),Section),
	isSubsectionOf(Section,'164.506').

is_164_528a1_exception(CE,Individual,PHI,discloses(CE,Individual,PHI)) :-
	privilege(CE,discloses(CE,Individual,PHI),Section),
	isSubsectionOf(Section,'164.502').
is_164_528a1_exception(CE,Individual,PHI,discloses(CE,Individual,PHI)) :-
	obligation(CE,discloses(CE,Individual,PHI),Section),
	isSubsectionOf(Section,'164.502').

is_164_528a1_exception(CE,_,PHI,discloses(CE,ThirdParty,PHI)) :-
	privilege(CE,discloses(CE,ThirdParty,PHI),Section),
	isSubsectionOf(Section,'164.502').
is_164_528a1_exception(CE,_,PHI,discloses(CE,ThirdParty,PHI)) :-
	obligation(CE,discloses(CE,ThirdParty,PHI),Section),
	isSubsectionOf(Section,'164.502').

is_164_528a1_exception(CE,Individual,PHI,discloses(CE,ThirdParty,PHI)) :-
	authorizes(Individual,CE,discloses(CE,ThirdParty,PHI)),
	privilege(CE,discloses(CE,ThirdParty,PHI),Section),
	isSubsectionOf(Section,'164.508').
is_164_528a1_exception(CE,Individual,PHI,discloses(CE,ThirdParty,PHI)) :-
	authorizes(Individual,CE,discloses(CE,ThirdParty,PHI)),
	obligation(CE,discloses(CE,ThirdParty,PHI),Section),
	isSubsectionOf(Section,'164.508').

is_164_528a1_exception(CE,Individual,PHI,discloses(CE,ThirdParty,PHI)) :-
	privilege(CE,discloses(CE,ThirdParty,PHI),Section),
	isSubsectionOf(Section,'164.510').
is_164_528a1_exception(CE,Individual,PHI,discloses(CE,ThirdParty,PHI)) :-
	obligation(CE,discloses(CE,ThirdParty,PHI),Section),
	isSubsectionOf(Section,'164.510').

is_164_528a1_exception(CE,Individual,PHI,discloses(CE,ThirdParty,PHI)) :-
	privilege(CE,discloses(CE,ThirdParty,PHI),Section),
	isSubsectionOf(Section,'164.512(k)(2)').
is_164_528a1_exception(CE,Individual,PHI,discloses(CE,ThirdParty,PHI)) :-
	obligation(CE,discloses(CE,ThirdParty,PHI),Section),
	isSubsectionOf(Section,'164.512(k)(2)').

is_164_528a1_exception(CE,Individual,PHI,discloses(CE,ThirdParty,PHI)) :-
	privilege(CE,discloses(CE,ThirdParty,PHI),Section),
	isSubsectionOf(Section,'164.512(k)(5)').
is_164_528a1_exception(CE,Individual,PHI,discloses(CE,ThirdParty,PHI)) :-
	obligation(CE,discloses(CE,ThirdParty,PHI),Section),
	isSubsectionOf(Section,'164.512(k)(5)').

is_164_528a1_exception(CE,Individual,PHI,discloses(CE,ThirdParty,PHI)) :-
	privilege(CE,discloses(CE,ThirdParty,PHI),Section),
	isSubsectionOf(Section,'164.514(e)').
is_164_528a1_exception(CE,Individual,PHI,discloses(CE,ThirdParty,PHI)) :-
	obligation(CE,discloses(CE,ThirdParty,PHI),Section),
	isSubsectionOf(Section,'164.514(e)').

is_164_528a1_exception(CE,_,PHI,discloses(CE,ThirdParty,PHI)) :-
	before(discloses(CE,ThirdParty,PHI),
	       complianceDate(CE)).

s164_528a2i(CE,Agency,Individual,Time,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	isPHI(PHI),
	isHOAorLE(Agency),
	specifies(CE,Time),
	isTimeUnit(Time),
	provides(Agency,
		 CE,
		 written(statement(reasonable(likely(impedes(provides(CE,
								      Individual,
								      accounting(discloses(CE,
											   Agency,
											   PHI))),
							     activities(Agency))))))),
	add_to_wm(s164_528a2i(CE,Agency,Individual,Time,PHI)).
isHOAorLE(Agency) :-
	isHealthOversightAgency(Agency).
isHOAorLE(Agency) :-
	isLawEnforcement(Agency).
obligation(CE,
	   for(temporarily(suspends(CE,
				    right(Individual,
					  receives(Individual,
						   CE,
						   accounting(discloses(CE,Agency,PHI))),
					  _))),
	       Time),
	   '164.528(2)(i)') :-
	wm(s164_528a2i(CE,Agency,Individual,Time,PHI)).
implied(right(Agency,
	      for(temporarily(suspends(CE,
				       right(Individual,
					     receives(Individual,
						      CE,
						      accounting(discloses(CE,Agency,PHI))),
					     _))),
		  Time),
	      '164.528(2)(i)')) :-
	wm(s164_528a2i(CE,Agency,Individual,Time,PHI)).

s164_528a2ii(CE,Agency,Individual,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	about(PHI,Individual),
	provides(Agency,
		 CE,
		 oral(statement(reasonable(likely(impedes(provides(CE,
								   Individual,
								   accounting(discloses(CE,
											Agency,
											PHI))),
							  activities(Agency))))))),
	add_to_wm(s164_528a2ii(CE,Agency,Individual,PHI)).
obligation(CE,
	   documents(CE,
		     oral(statement(reasonable(likely(impedes(provides(CE,
								       Individual,
								       accounting(discloses(CE,
											    Agency,
											    PHI))),
							       activities(Agency))))))),
	   '164.528(a)(2)(ii)(A)') :-
	wm(s164_528a2ii(CE,Agency,Individual,PHI)).
% TODO what is the implied right?

obligation(CE,
	   documents(CE,
		     identity(Agency)),
	   '164.528(a)(2)(ii)(A)') :-
	wm(s164_528a2ii(CE,Agency,Individual,PHI)).
% TODO what is the implied right?

obligation(CE,
	   temporarily(suspends(CE,
				right(Individual,
				      receives(Individual,
					       CE,
					       accounting(discloses(CE,Agency,PHI))),
				      _))),
	   '164.528(2)(ii)(B)') :-
	wm(s164_528a2ii(CE,Agency,Individual,PHI)).
% TODO what is the implied right?

obligation(CE,
	   to(limits(CE,
		     temporarily(suspends(CE,
					  right(Individual,
						receives(Individual,
							 CE,
							 accounting(discloses(CE,Agency,PHI))),
						_)))),
	      from(day(30),
		   oral(statement(reasonable(likely(impedes(provides(CE,
								     Individual,
								     accounting(discloses(CE,
											  Agency,
											  PHI))),
							    activities(Agency)))))))),
	   '164.528(2)(ii)(C)') :-
	not(during(provides(Agency,
			    CE,
			    written(statement(reasonable(likely(impedes(provides(CE,
								     Individual,
								     accounting(discloses(CE,
											  Agency,
											  PHI))),
							    activities(Agency))))))),
		   day(30))),
	wm(s164_528a2ii(CE,Agency,Individual,PHI)).
implied(right(Individual,
	      to(limits(CE,
			temporarily(suspends(CE,
					     right(Individual,
						   receives(Individual,
							    CE,
							    accounting(discloses(CE,Agency,PHI))),
						   _)))),
		 from(day(30),
		      oral(statement(reasonable(likely(impedes(provides(CE,
									Individual,
									accounting(discloses(CE,
											     Agency,
											     PHI))),
							       activities(Agency)))))))),
	      '164.528(2)(ii)(C)')) :-
	not(during(provides(Agency,
			    CE,
			    written(statement(reasonable(likely(impedes(provides(CE,
								     Individual,
								     accounting(discloses(CE,
											  Agency,
											  PHI))),
							    activities(Agency))))))),
		   day(30))),
	wm(s164_528a2ii(CE,Agency,Individual,PHI)).

s164_528a3(CE,ThirdParty,Individual,PHI) :-
	lessThan(date(requests(Individual,
			       CE,
			       accounting(discloses(CE,ThirdParty,PHI)))),
		 date(discloses(CE,ThirdParty,PHI))),
	isCoveredEntity(CE),
	about(PHI,Individual),
	isPHI(PHI),
	add_to_wm(s164_528a3(CE,ThirdParty,Individual,PHI)).
privilege(Individual,
	  requests(Individual,
		   CE,
		   accounting(discloses(CE,ThirdParty,PHI))),
	  '164.528(a)(3)') :-
	wm(s164_528a3(CE,ThirdParty,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      requests(Individual,
			       CE,
			       accounting(discloses(CE,ThirdParty,PHI))),
		      _),
		'164.528(a)(3)')) :-
	wm(s164_528a3(CE,ThirdParty,Individual,PHI)).

s164_528b1(CE,ThirdParty,Individual,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	about(PHI,Individual),
	within(discloses(CE,_,PHI),
	       year(6),
	       requests(Individual,
			CE,
			accounting(discloses(CE,ThirdParty,PHI)))),
	add_to_wm(s164_528b1(CE,ThirdParty,Individual,PHI)).
obligation(CE,
	   contains(accounting(discloses(CE,ThirdParty,PHI)),
		    discloses(CE,_,PHI)),
	   '164.528(b)(1)') :-
	wm(s164_528b1(CE,ThirdParty,Individual,PHI)).
implied(right(Individual,
	      receives(Individual,
		       CE,
		       accounting(discloses(CE,ThirdParty,PHI))),
	      '164.528(b)(1)')) :-
	wm(s164_528b1(CE,ThirdParty,Individual,PHI)).

s164_528b2(CE,ThirdParty,Individual,PHI) :-
	isCoveredEntity(CE),
	about(PHI,Individual),
	isPHI(PHI),
	add_to_wm(s164_528b2(CE,ThirdParty,Individual,PHI)).
obligation(CE,
	   contains(accounting(discloses(CE,ThirdParty,PHI)),
		    date(discloses(CE,ThirdParty,PHI))),
	   '164.526(b)(2)(i)') :-
	wm(s164_528b2(CE,ThirdParty,Individual,PHI)).
% TODO what is the implied right?

obligation(CE,
	   contains(accounting(discloses(CE,ThirdParty,PHI)),
		    name(ThirdParty)),
	   '164.528(b)(2)(ii)') :-
	wm(s164_528b2(CE,ThirdParty,Individual,PHI)).
% TODO what is the implied right?

obligation(CE,
	   contains(accounting(discloses(CE,ThirdParty,PHI)),
		    address(ThirdParty)),
	   '164.528(b)(2)(ii)') :-
	knows(CE,address(ThirdParty)),
	wm(s164_528b2(CE,ThirdParty,Individual,PHI)).
% TODO what is the implied right?

obligation(CE,
	   contains(accounting(discloses(CE,ThirdParty,PHI)),
		    brief(description(PHI))),
	   '164.528(b)(2)(iii)') :-
	wm(s164_528b2(CE,ThirdParty,Individual,PHI)).
% TODO what is the implied right?

obligation(CE,
	   contains(accounting(discloses(CE,ThirdParty,PHI)),
		    statement(Purpose)),
	   '164.528(b)(2)(iv)') :-
	for(discloses(CE,ThirdParty,PHI),
	    Purpose),
	reasonable(informs(statement(Purpose),
			   Individual,
			   basis(discloses(CE,ThirdParty,PHI)))),
	wm(s164_528b2(CE,ThirdParty,Individual,PHI)).
implied(right(Individual,
	      knows(Individual,
		    Purpose),
	      '164.528(b)(2)(iv)')) :-
	for(discloses(CE,ThirdParty,PHI),
	    Purpose),
	reasonable(informs(statement(Purpose),
			   Individual,
			   basis(discloses(CE,ThirdParty,PHI)))),
	wm(s164_528b2(CE,ThirdParty,Individual,PHI)).

obligation(CE,
	   contains(accounting(discloses(CE,ThirdParty,PHI)),
		    statement(requests(ThirdParty,CE,PHI))),
	   '164.528(b)(2)(iv)') :-
	requests(ThirdParty,CE,PHI),
	wm(s164_528b2(CE,ThirdParty,Individual,PHI)).
% TODO what is the implied right

s164_528b3(CE,ThirdParty,Information,Attribute,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	multiple(discloses(CE,ThirdParty,PHI)),
	obligation(CE,
		   contains(accounting(discloses(CE,ThirdParty,PHI)),
			    Information),
		   Section),
	isSubsectionOf(Section,'164.528(b)(2)'),
	is_164_528b3_attribute(CE,ThirdParty,PHI,Attribute),
	add_to_wm(s164_528b3(CE,ThirdParty,Information,Attribute,PHI)).
is_164_528b3_attribute(CE,ThirdParty,PHI,frequency(discloses(CE,ThirdParty,PHI))).
is_164_528b3_attribute(CE,ThirdParty,PHI,periodicity(discloses(CE,ThirdParty,PHI))).
is_164_528b3_attribute(CE,ThirdParty,PHI,numberOf(discloses(CE,ThirdParty,PHI))).
privilege(CE,
	  (   contains(accounting(discloses(CE,ThirdParty,PHI)),
		       Information),
	      Attribute,
	      date(last(discloses(CE,ThirdParty,PHI)))
	  ),
	  '164.528(b)(3)') :-
	wm(s164_528b3(CE,ThirdParty,Information,Attribute,PHI)).
implied(noRight(Individual,
		right(Individual,
		      (   contains(accounting(discloses(CE,ThirdParty,PHI)),
				   Information),
			  Attribute,
			  date(last(discloses(CE,ThirdParty,PHI)))
		      ),
		      _),
		'164.528(b)(3)')) :-
	wm(s164_528b3(CE,ThirdParty,Information,Attribute,PHI)).

s164_528b4i(CE,ThirdParty,Individual,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	for(discloses(CE,ThirdParty,PHI),
	    research),
	for(discloses(CE,ThirdParty,PHI),
	    moreThan(people(50))),
	includes(research,
		 Individual),
	about(PHI,Individual),
	add_to_wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).
privilege(CE,
	  contains(accounting(discloses(CE,ThirdParty,PHI)),
		   name(research)),
	  '164.528(b)(4)(i)(A)') :-
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      contains(accounting(discloses(CE,ThirdParty,PHI)),
				   name(research)),
		      _),
		'164.528(b)(4)(i)(A)')) :-
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).

privilege(CE,
	  contains(accounting(discloses(CE,ThirdParty,PHI)),
		   inPlainLanguage(description(research))),
	  '164.528(b)(4)(i)(B)') :-
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      contains(accounting(discloses(CE,ThirdParty,PHI)),
				   inPlainLanguage(description(research))),			  
		      _),
		'164.528(b)(4)(i)(B)')) :-
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).
privilege(CE,
	  contains(accounting(discloses(CE,ThirdParty,PHI)),
		   Purpose),
	  '164.528(b)(4)(i)(B)') :-
	for(research,
	    Purpose),
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      contains(accounting(discloses(CE,ThirdParty,PHI)),
				   Purpose),
		      _),
		'164.528(b)(4)(i)(B)')) :-
	for(research,
	    Purpose),
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).

privilege(CE,
	  contains(accounting(discloses(CE,ThirdParty,PHI)),
		   brief(description(PHI))),
	  '164.528(b)(4)(i)(C)') :-
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      contains(accounting(discloses(CE,ThirdParty,PHI)),
			       brief(description(PHI))),
		      _),
		'164.528(b)(4)(i)(C)')) :-
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).

privilege(CE,
	  contains(accounting(discloses(CE,ThirdParty,PHI)),
		   date(discloses(CE,ThirdParty,PHI))),
	  '164.528(b)(4)(i)(D)') :-
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      contains(accounting(discloses(CE,ThirdParty,PHI)),
			       date(discloses(CE,ThirdParty,PHI))),
		      _),
		'164.528(b)(4)(i)(D)')) :-
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).
privilege(CE,
	  contains(accounting(discloses(CE,ThirdParty,PHI)),
		   date(last(discloses(CE,ThirdParty,PHI)))),
	  '164.528(b)(4)(i)(D)') :-
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      contains(accounting(discloses(CE,ThirdParty,PHI)),
			       date(last(discloses(CE,ThirdParty,PHI)))),
		      _),
		'164.528(b)(4)(i)(D)')) :-
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).

privilege(CE,
	  contains(accounting(discloses(CE,ThirdParty,PHI)),
		   Info),
	  '164.528(b)(4)(i)(E)') :-
	is_164_528a4iE_info(Person,Info),
	is_164_528a4iE_person(Person,ThirdParty),
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      contains(accounting(discloses(CE,ThirdParty,PHI)),
			       Info),
		      _),
		'164.528(b)(4)(i)(E)')) :-
	is_164_528a4iE_info(Person,Info),
	is_164_528a4iE_person(Person,ThirdParty),
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).
is_164_528a4iE_info(Person,name(Person)).
is_164_528a4iE_info(Person,address(Person)).
is_164_528a4iE_info(Person,telephone(Person)).
is_164_528a4iE_person(Person,_) :-
	sponsors(Person,research).
is_164_528a4iE_person(Researcher,Researcher) :-
	isResearcher(Researcher).

privilege(CE,
	  contains(accounting(discloses(CE,ThirdParty,PHI)),
		   statement(privilege(CE,
				       for(discloses(CE,_,PHI),
					   research),
				       _))),
	  '164.528(b)(4)(i)(F)') :-
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).
implied(noRight(Individual,
		right(Individual,
		      contains(accounting(discloses(CE,ThirdParty,PHI)),
			       statement(privilege(CE,
						   for(discloses(CE,_,PHI),
						       research),
						   _))),
		      _),
		'164.528(b)(4)(i)(F)')) :-
	wm(s164_528b4i(CE,ThirdParty,Individual,PHI)).

s164_528b4ii(CE,SponsorOrResearcher,Individual,PHI) :-
	isCoveredEntity(CE),
	isSponsorOrResearcher(SponsorOrResearcher,research),
	requests(Individual,
		 CE,
		 assists(CE,
			 Individual,
			 contacts(Individual,
				  SponsorOrResearcher))),
	isPHI(PHI),
	about(PHI,Individual),
	reasonable(likely(for(discloses(CE,_,PHI),
			      research))),
	add_to_wm(s164_528b4ii(CE,SponsorOrResearcher,Individual,PHI)).
isSponsorOrResearcher(Sponsor,research) :-
	sponsors(Sponsor,research).
isSponsorOrResearcher(Researcher,_) :-
	isResearcher(Researcher).
obligation(CE,
	   assists(CE,
		   Individual,
		   contacts(Individual,
			    SponsorOrResearcher)),
	   '164.528(b)(4)(ii)') :-
	wm(s164_528b4ii(CE,SponsorOrResearcher,Individual,PHI)).
implied(right(Individual,
	      assists(CE,
		   Individual,
		   contacts(Individual,
			    SponsorOrResearcher)),
	      '164.528(b)(4)(ii)')) :-
	wm(s164_528b4ii(CE,SponsorOrResearcher,Individual,PHI)).

s164_528c1(CE,ThirdParty,Individual,Action,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	about(PHI,Individual),
	requests(Individual,
		 CE,
		 accounting(discloses(CE,_,PHI))),
	is_164_528c1_action(CE,ThirdParty,Individual,PHI,Action),
	add_to_wm(s164_528c1(CE,ThirdParty,Individual,Action,PHI)).
is_164_528c1_action(CE,ThirdParty,Individual,PHI,provides(CE,
							  Individual,
							  accounting(discloses(CE,ThirdParty,PHI)))).
		    
obligation(CE,
	   noLaterThan(Action,
		       after(day(60),
			     receives(CE,
				      Individual,
				      requests(Individual,
					       CE,
					       accounting(discloses(CE,ThirdParty,PHI)))))),
	   '164.528(c)(1)') :-
	wm(s164_528c1(CE,ThirdParty,Individual,Action,PHI)).
implied(right(Individual,
	      noLaterThan(Action,
		       after(day(60),
			     receives(CE,
				      Individual,
				      requests(Individual,
					       CE,
					       accounting(discloses(CE,ThirdParty,PHI)))))),
	      '164.528(c)(1)')) :-
	wm(s164_528c1(CE,ThirdParty,Individual,Action,PHI)).

privilege(CE,
	  onlyOnce(extends(CE,
			   noLaterThan(Action,
				       after(day(60),
					     receives(CE,
						      Individual,
						      requests(Individual,
							       CE,
							       accounting(discloses(CE,
										    ThirdParty,
										    PHI)))))),
			   day(30))),
	  '164.528(c)(1)(ii)') :-
	not(able(CE,
		 provides(CE,
			  Individual,
			  accounting(discloses(CE,ThirdParty,PHI))))),
	wm(s164_528c1(CE,ThirdParty,Individual,Action,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(onlyOnce(extends(CE,
					   noLaterThan(Action,
						       after(day(60),
							     receives(CE,
								      Individual,
								      requests(Individual,
									       CE,
									       accounting(discloses(CE,
												    ThirdParty,
												    PHI)))))),
					   day(30)))),
		      _),
		'164.528(c)(1)(ii)')) :-
	not(able(CE,
		 provides(CE,
			  Individual,
			  accounting(discloses(CE,ThirdParty,PHI))))),
	wm(s164_528c1(CE,ThirdParty,Individual,Action,PHI)).
is_164_528c1_action(CE,
		    ThirdParty,
		    Individual,
		    PHI,
		    provides(CE,
			     Individual,
			     basis(delays(CE,
					  provides(CE,
						   Individual,
						   accounting(discloses(CE,ThirdParty,PHI))))))).

s164_528c2(CE,ThirdParty,Individual,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	about(PHI,Individual),
	add_to_wm(s164_528c2(CE,ThirdParty,Individual,PHI)).
obligation(CE,
	   provides(CE,
		    Individual,
		    free(first(within(accounting(discloses(CE,ThirdParty,PHI))),
			       month(12)))),
	   '164.528(c)(2)') :-
	wm(s164_528c2(CE,ThirdParty,Individual,PHI)).
implied(right(Individual,
	      provides(CE,
		       Individual,
		       free(first(within(accounting(discloses(CE,ThirdParty,PHI)),
					 month(12))))),
	      '164.528(c)(2)')) :-
	wm(s164_528c2(CE,ThirdParty,Individual,PHI)).

privilege(CE,
	  imposes(CE,
		  Individual,
		  reasonable(costBased(for(fee,
					   moreThan(within(requests(Individual,
								    CE,
								    accounting(discloses(CE,ThirdParty,PHI))),
							   month(12)),
						    1))))),
	  
	  '164.528(c)(2)') :-
	informs(CE,
		Individual,
		imposes(CE,
			Individual,
			reasonable(costBased(for(fee,
						 moreThan(within(requests(Individual,
									  CE,
									  accounting(discloses(CE,ThirdParty,PHI))),
								 month(12)),
							  1)))))),
	provides(CE,
		 Individual,
		 to(opportunity(Action),
		    avoids(Individual,fee))),
	is_s164_528c2_Action(CE,ThirdParty,Individual,PHI,Action),
	wm(s164_528c2(CE,ThirdParty,Individual,PHI)).

is_s164_528c2_Action(CE,ThirdParty,Individual,PHI,withdraws(Individual,
							  requests(Individual,
								   CE,
								   accounting(discloses(CE,ThirdParty,PHI))))).
is_s164_528c2_Action(CE,ThirdParty,Individual,PHI,modifies(Individual,
							 requests(Individual,
								  CE,
								  accounting(discloses(CE,ThirdParty,PHI))))).

s164_528d1(CE,ThirdParty,Info,Section,PHI) :-
	isCoveredEntity(CE),
	isPHI(PHI),
	obligation(CE,
		   contains(accounting(discloses(CE,ThirdParty,PHI)),
			    Info),
		   Section),
	isSubsectionOf(Section,'164.528(b)'),
	add_to_wm(s164_528d1(CE,ThirdParty,Info,Section,PHI)).
obligation(CE,
	   documents(CE,Info),
	   '164.528(d)(1)') :-
	wm(s164_528d1(CE,ThirdParty,Info,Section,PHI)).
% TODO what is the implied right?

obligation(CE,
	   documents(CE,accounting(CE,_,PHI)),
	   '164.528(d)(2)') :-
	isCoveredEntity(CE),
	isPHI(PHI).
% TODO what is the implied right?

s164_528d3(CE,Agent,Individual,PHI) :-
	isCoveredEntity(CE),
	isResponsible(Agent,
		      receives(Agent,
			       Individual,
			       requests(Individual,
					CE,
					accounting(discloses(CE,_,PHI))))),
	isPersonOrOffice(Agent),
	isPHI(PHI),
	add_to_wm(s164_528d3(CE,Agent,Individual,PHI)).
obligation(CE,
	   documents(CE,
		     title(Agent)),
	   '164.528(d)(3)') :-
	wm(s164_528d3(CE,Agent,Individual,PHI)).
% TODO what is the implied right?

% eof
