% Models section 164.532 of the HIPAA Privacy Rule

%  cross ref to 164.508 and 164.512(i)
s164_532b(CE,Individual,UsageOrDisclosure,Authorization,PHI) :-
	isCoveredEntity(CE),
	isUsageOrDisclosure(CE,_,PHI,UsageOrDisclosure),
	isPHI(PHI),
	about(PHI,Individual),
	not(agrees(CE,
		   requests(Individual,
			    CE,
			    restricts(CE,UsageOrDisclosure)))),
	permits(Authorization,
		UsageOrDisclosure),
	is_164_532b_authorization(CE,Individual,UsageOrDisclosure,Authorization),
	before(obtains(CE,Individual,Authorization),
	       complianceDate(CE)),
	add_to_wm(s164_532b(CE,Individual,UsageOrDisclosure,Authorization,PHI)).
is_164_532b_authorization(CE,
			  Individual,
			  UsageOrDisclosure,
			  authorizes(Individual,CE,UsageOrDisclosure)).
is_164_532b_authorization(_,
			  _,
			  UsageOrDisclosure,
			  Permission) :-
	expressly(Permission,UsageOrDisclosure),
	isLegalPermission(Permission).
privilege(CE,
	  UsageOrDisclosure,
	  '164.532(b)') :-
	wm(s164_532b(CE,Individual,UsageOrDisclosure,Authorization,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(UsageOrDisclosure),
		      _), 
		'164.532(b)')) :-
	wm(s164_532b(CE,Individual,UsageOrDisclosure,Authorization,PHI)).

% cross ref to 164.508 and 164.512(i)
s164_532c(CE,Individual,UsageOrDisclosure,Authorization,PHI) :-
	isCoveredEntity(CE),
	isUsageOrDisclosure(CE,_,PHI,UsageOrDisclosure),
	isPHI(PHI),
	about(PHI,Individual),
	not(agrees(CE,
		   requests(Individual,
			    CE,
			    restricts(CE,UsageOrDisclosure)))),
	permits(Authorization,
		UsageOrDisclosure),
	is_164_532c_authorization(CE,Individual,UsageOrDisclosure,Authorization),
	before(obtains(CE,Individual,Authorization),
	       complianceDate(CE)),
	add_to_wm(s164_532c(CE,Individual,UsageOrDisclosure,Authorization,PHI)).
is_164_532c_authorization(CE,
			  Individual,
			  UsageOrDisclosure,
			  authorizes(Individual,CE,UsageOrDisclosure)).
is_164_532c_authorization(_,
			  _,
			  UsageOrDisclosure,
			  Permission) :-
	expressly(Permission,UsageOrDisclosure),
	isLegalPermission(Permission).
is_164_532c_authorization(_,
			  Individual,
			  UsageOrDisclosure,
			  consents(Individual,UsageOrDisclosure)).
is_164_532c_authorization(CE,
			  _,
			  UsageOrDisclosure,
			  waiver(authorizes(IRB,
					    CE,
					    UsageOrDisclosure))) :-
	isIRB(IRB).

privilege(CE,
	  for(UsageOrDisclosure,
	      research),
	  '164.532(c)') :-
	wm(s164_532c(CE,Individual,UsageOrDisclosure,Authorization,PHI)).
implied(noRight(Individual,
		right(Individual,
		      not(for(UsageOrDisclosure,
			      research)),
		      _),
		'164.532(c)')) :-
	wm(s164_532c(CE,Individual,UsageOrDisclosure,Authorization,PHI)).

% eof




